package com.yeejoin.amos.iot.business.controller;

import com.alibaba.fastjson.JSON;
import com.yeejoin.amos.iot.business.constants.IotConstant;
import com.yeejoin.amos.iot.business.controller.param.TestEqpParam;
import com.yeejoin.amos.iot.business.entity.Capability;
import com.yeejoin.amos.iot.business.entity.CapabilityAttribute;
import com.yeejoin.amos.iot.business.entity.CapabilitylInterface;
import com.yeejoin.amos.iot.business.entity.EqpCpblProperty;
import com.yeejoin.amos.iot.business.entity.Equipment;
import com.yeejoin.amos.iot.business.entity.EquipmentCapability;
import com.yeejoin.amos.iot.business.entity.EquipmentTemplate;
import com.yeejoin.amos.iot.business.entity.Intfc;
import com.yeejoin.amos.iot.business.entity.Node;
import com.yeejoin.amos.iot.business.entity.mybatis.CapacityInterfaceDataVo;
import com.yeejoin.amos.iot.business.entity.mybatis.CapacityPropertyDataVo;
import com.yeejoin.amos.iot.business.entity.mybatis.DeviceInterfaceDataVo;
import com.yeejoin.amos.iot.business.entity.mybatis.EquipmentTemplateVo;
import com.yeejoin.amos.iot.business.entity.mybatis.EquipmentVo;
import com.yeejoin.amos.iot.business.enums.EquipmentType;
import com.yeejoin.amos.iot.business.param.CapacityPropertyParam;
import com.yeejoin.amos.iot.business.param.DevicePageParam;
import com.yeejoin.amos.iot.business.param.EqpTemplPageParam;
import com.yeejoin.amos.iot.business.param.EquipmentCapacityParam;
import com.yeejoin.amos.iot.business.param.EquipmentInterfaceParam;
import com.yeejoin.amos.iot.business.param.EquipmentParam;
import com.yeejoin.amos.iot.business.param.EquipmentPropertyParam;
import com.yeejoin.amos.iot.business.param.QueryEqpCountParam;
import com.yeejoin.amos.iot.business.polling.test.TestCapablility;
import com.yeejoin.amos.iot.business.polling.test.TestEqpDataExportUtil;
import com.yeejoin.amos.iot.business.polling.test.TestEquipmentCache;
import com.yeejoin.amos.iot.business.polling.test.TestEquipmentService;
import com.yeejoin.amos.iot.business.polling.test.TestIntfc;
import com.yeejoin.amos.iot.business.polling.test.TestResultStoreUtil;
import com.yeejoin.amos.iot.business.service.intfc.ICapabilityService;
import com.yeejoin.amos.iot.business.service.intfc.ICapacityInterfaceService;
import com.yeejoin.amos.iot.business.service.intfc.ICapacityPropertyService;
import com.yeejoin.amos.iot.business.service.intfc.IDeviceService;
import com.yeejoin.amos.iot.business.service.intfc.IEqpCpblPropertyService;
import com.yeejoin.amos.iot.business.service.intfc.IEqpCpblService;
import com.yeejoin.amos.iot.business.service.intfc.IEqpTemplService;
import com.yeejoin.amos.iot.business.service.intfc.IEqpTmplInterfaceService;
import com.yeejoin.amos.iot.business.service.intfc.IEqpTmplPropertyService;
import com.yeejoin.amos.iot.business.service.intfc.IEquipmentService;
import com.yeejoin.amos.iot.business.service.intfc.IIntfcService;
import com.yeejoin.amos.iot.business.service.intfc.ITopoNodeService;
import com.yeejoin.amos.iot.core.common.request.CommonPageable;
import com.yeejoin.amos.iot.core.common.response.CommonPage;
import com.yeejoin.amos.iot.core.enums.QueryOperatorEnum;
import com.yeejoin.amos.iot.core.util.ImgFileServer;
import com.yeejoin.amos.iot.exception.YeeException;
import com.yeejoin.amos.iot.netty.NettyServerService;
import com.yeejoin.amos.iot.netty.vehicle.MessageCommonUtil;
import com.yeejoin.amos.op.core.common.query.DaoCriteria;
import com.yeejoin.amos.op.core.common.response.CommonResponse;
import com.yeejoin.amos.op.core.util.BasicUtil;
import com.yeejoin.amos.op.core.util.CommonResponseUtil;
import com.yeejoin.amos.op.core.util.JSONUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.apache.commons.collections.CollectionUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Sort;
import org.springframework.util.ObjectUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.ListIterator;
import java.util.Map;
import java.util.Map.Entry;

/**
 * <pre>
 * 设备
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: DeviceController.java, v 0.1 2018年1月29日 上午10:53:16 as-chenjiajun Exp $
 */
@RestController
@RequestMapping("/device")
@Api(value = "device", tags = {"设备管理"})
public class DeviceController extends BaseController {
    @Autowired
    private IDeviceService iDeviceService;

    @Autowired
    private IEqpTmplInterfaceService iEqpTmplInterfaceService;

    @Autowired
    private IEqpTmplPropertyService iEqpTmplPropertyService;

    @Autowired
    private ICapacityInterfaceService iCapacityInterfaceService;

    @Autowired
    private ICapacityPropertyService iCapacityPropertyService;

    @Autowired
    private ICapabilityService iCapabilityService;

    @Autowired
    private IEqpTemplService eqpTemplService;

    @Autowired
    private IEquipmentService equipmentService;

    @Autowired
    private IEqpCpblService eqpCpblService;

    @Autowired
    private ITopoNodeService iTopoNodeService;

    @Autowired
    private IIntfcService intfcService;

    @Autowired
    private IEqpCpblPropertyService iEqpCpblPropertyService;

    @Autowired
    private TestEquipmentService testEquipmentService;

    @Autowired
    private ImgFileServer imgFileServer;

    @Autowired
    private NettyServerService nettyServerService;

    private final Logger log = LoggerFactory.getLogger(DeviceController.class);

    @ApiOperation(httpMethod = "POST", value = "新增设备模板", notes = "新增设备模板")
    @RequestMapping(value = "/device-persistence", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse addEqpTemplate(
            @ApiParam(value = "设备参数", required = true) @RequestBody EquipmentParam param) {
        try {
            param.setOrgCode(getCompanyOrgCode());
            Long deviceID = iDeviceService.saveEquipment(param);
            return CommonResponseUtil.success(deviceID);
        } catch (Exception e) {
            return CommonResponseUtil.failure(getErrorMessage(e));
        }
    }

    @ApiOperation(httpMethod = "POST", value = "设备基本信息编辑", notes = "设备基本信息编辑")
    @RequestMapping(value = "/device-basic-info-update", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse updatedeviceBasicInfo(
            @ApiParam(value = "设备基本信息参数", required = true) @RequestBody EquipmentParam param) {
        try {
            param.setOrgCode(getCompanyOrgCode());
            Long result = iDeviceService.updateDeviceBasicInfo(param);
            return CommonResponseUtil.success(result);
        } catch (Exception e) {
            return CommonResponseUtil.failure(getErrorMessage(e));
        }
    }

    @ApiOperation(httpMethod = "POST", value = "设备属性编辑", notes = "设备属性编辑")
    @RequestMapping(value = "/device-attribute-update", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse deviceAttributeUpdate(
            @ApiParam(value = "设备属性参数", required = true) @RequestBody EquipmentPropertyParam param) {
        iDeviceService.deviceAttributeUpdate(param);
        return CommonResponseUtil.success();
    }

    @ApiOperation(httpMethod = "POST", value = "设备接口编辑", notes = "设备接口编辑")
    @RequestMapping(value = "/device-interface-update", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse deviceInterfaceUpdate(
            @ApiParam(value = "设备接口参数", required = true) @RequestBody EquipmentInterfaceParam param) {
        iDeviceService.deviceInterfaceUpdate(param);
        return CommonResponseUtil.success();
    }

    /**
     * <pre>
     * 分页查询设备数据
     * </pre>
     *
     * @param request
     * @param pageable
     * @return
     */
    @ApiOperation(httpMethod = "POST", value = "分页查询设备数据", notes = "分页查询接口数据")
    @RequestMapping(value = "/list", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonPage<EquipmentTemplateVo> queryDeviceList(
            @ApiParam(value = "查询参数", required = true) @RequestBody(required = false) DevicePageParam request,
            @ApiParam(value = "分页对象", required = true, defaultValue = "pageNumber=0&pageSize=10") CommonPageable pageable) {
        if (pageable == null) {
            pageable = new CommonPageable(1, DEFAULT_PAGE_SIZE);
        }
        CommonPage<EquipmentTemplateVo> page = null;
        try {
            request.setPageNumber(pageable.getPageNumber());
            request.setPageSize(pageable.getPageSize());
            request.setOffset(pageable.getPageNumber() * pageable.getPageSize());

            page = iDeviceService.pageDeviceData(request);
            page.setResult(SUCCESS);
        } catch (Exception e) {
            e.printStackTrace();
            log.error(e.getMessage(), e);
            page = new CommonPage<EquipmentTemplateVo>(new ArrayList<EquipmentTemplateVo>(), pageable, 0);
            page.setResult(FAILED);
            page.setMessage(e.getMessage());
        }
        return page;
    }

    @ApiOperation(httpMethod = "POST", value = "设备能力编辑", notes = "设备能力编辑")
    @RequestMapping(value = "/device-capacity-update", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse deviceCapacityUpdate(
            @ApiParam(value = "设备能力参数", required = true) @RequestBody EquipmentCapacityParam param) {
        try {
            iDeviceService.deviceCapacityUpdate(param);
            return CommonResponseUtil.success();
        } catch (Exception e) {
            return CommonResponseUtil.failure(getErrorMessage(e));
        }
    }

    @ApiOperation(httpMethod = "POST", value = "能力接口编辑", notes = "能力接口编辑")
    @RequestMapping(value = "/capacity-intf-update", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse capacityIntfUpdate(
            @ApiParam(value = "能力接口参数", required = true) @RequestBody CapabilitylInterface param) {
        iDeviceService.capacityIntfUpdate(param);
        return CommonResponseUtil.success();
    }

    @ApiOperation(httpMethod = "POST", value = "能力属性编辑", notes = "能力属性编辑")
    @RequestMapping(value = "/capacity-property-update", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse capacityPropertyUpdate(
            @ApiParam(value = "能力属性参数", required = true) @RequestBody CapacityPropertyParam param) {
        iDeviceService.capacityPropertyUpdate(param);
        return CommonResponseUtil.success();
    }

    @ApiOperation(httpMethod = "GET", value = "查询设备数据", notes = "查询设备数据")
    @RequestMapping(value = "/template-entity/{id}", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    public CommonResponse fetchDeviceEntity(@ApiParam(value = "ID", required = true, defaultValue = "1")
                                            @PathVariable Long id) {
        EquipmentTemplate equipmentTemplate = iDeviceService.getDeviceById(id);
        if (equipmentTemplate != null) {
            return CommonResponseUtil.success(equipmentTemplate);
        } else {
            return CommonResponseUtil.failure();
        }
    }

    @ApiOperation(httpMethod = "POST", value = "分页查询设备", notes = "分页查询设备")
    @RequestMapping(value = "/page-device", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonPage<EquipmentTemplateVo> pageDevice(@RequestBody DevicePageParam param) {
        CommonPage<EquipmentTemplateVo> commonPage = null;
        try {
            if (0 != param.getVisibility()) {
                param.setOrgCode(getCompanyOrgCode());
            }
            param.setUserId(getUserId());
            commonPage = iDeviceService.pageDeviceData(param);
            commonPage.setResult(SUCCESS);
        } catch (Exception e) {
            commonPage.setMessage(e.getMessage());
            commonPage.setResult(FAILED);
            log.error(e.getMessage(), e);
        }
        return commonPage;
    }

    @ApiOperation(httpMethod = "GET", value = "查询设备对应的接口数据", notes = "查询设备对应的接口数据")
    @RequestMapping(value = "/template-interface/{id}", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    public CommonResponse fetchDeviceInterface(@ApiParam(value = "ID", required = true, defaultValue = "1")
                                               @PathVariable Long id) {
        List<DeviceInterfaceDataVo> deviceInterfaceList = iDeviceService.getDeviceInterfaceById(id);
        return CommonResponseUtil.success(deviceInterfaceList);
    }

    @ApiOperation(httpMethod = "GET", value = "查询设备能力对应的协议、接口和属性数据", notes = "查询设备能力对应的协议、接口和属性数据")
    @RequestMapping(value = "/capacity-intfc-property/{id}", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    public CommonResponse fetchCapacityInterfaces(@ApiParam(value = "ID", required = true, defaultValue = "1")
                                                  @PathVariable Long id) {
        List<CapacityInterfaceDataVo> capacityInterfaceDataVos = iDeviceService.getCapacityInterfaceById(id);
        List<CapacityPropertyDataVo> capabilityAttributes = iDeviceService.getCapacityPropertyById(id);
        String protocolName = iDeviceService.getProtocolNameById(id);
        Map<String, Object> resultMap = new HashMap<String, Object>();
        resultMap.put("interface", capacityInterfaceDataVos);
        resultMap.put("property", capabilityAttributes);
        resultMap.put("protocolName", protocolName);
        return CommonResponseUtil.success(resultMap);
    }

    @ApiOperation(httpMethod = "DELETE", value = "删除设备属性", notes = "删除设备属性")
    @RequestMapping(value = "/device-property-eliminate/{id}", produces = "application/json;charset=UTF-8", method = RequestMethod.DELETE)
    public CommonResponse deleteDeviceAttribute(
            @ApiParam(value = "设备属性ID", required = true) @PathVariable Long id) {
        iEqpTmplPropertyService.deleteDeviceProperty(id);
        return CommonResponseUtil.success();
    }

    @ApiOperation(httpMethod = "DELETE", value = "删除设备接口", notes = "删除设备接口")
    @RequestMapping(value = "/device-interface-eliminate/{id}", produces = "application/json;charset=UTF-8", method = RequestMethod.DELETE)
    public CommonResponse deleteDeviceInterface(
            @ApiParam(value = "设备接口ID", required = true) @PathVariable Long id) {
        iEqpTmplInterfaceService.deleteDeviceInterface(id);
        return CommonResponseUtil.success();
    }

    @ApiOperation(httpMethod = "DELETE", value = "删除设备能力", notes = "删除设备能力")
    @RequestMapping(value = "/device-capacity-eliminate/{id}", produces = "application/json;charset=UTF-8", method = RequestMethod.DELETE)
    public CommonResponse deleteDeviceCapacity(
            @ApiParam(value = "设备能力ID", required = true) @PathVariable Long id) {
        iCapabilityService.delCapabilityById(id);
        return CommonResponseUtil.success();
    }

    @ApiOperation(httpMethod = "POST", value = "设备能力新增", notes = "设备能力新增")
    @RequestMapping(value = "/device-capacity-add", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse deviceCapacityAdd(
            @ApiParam(value = "设备能力参数", required = true) @RequestBody EquipmentCapacityParam param) {
        try {
            iDeviceService.addDeviceCapacity(param);
            return CommonResponseUtil.success();
        } catch (Exception e) {
            return CommonResponseUtil.failure(getErrorMessage(e));
        }
    }

    @ApiOperation(httpMethod = "DELETE", value = "删除能力接口", notes = "删除能力接口")
    @RequestMapping(value = "/capacity-interface-eliminate/{id}", produces = "application/json;charset=UTF-8", method = RequestMethod.DELETE)
    public CommonResponse deleteCapacityInterface(
            @ApiParam(value = "设备能力ID", required = true) @PathVariable Long id) {
        iCapacityInterfaceService.deleteCapacityInterface(id);
        return CommonResponseUtil.success();

    }

    @ApiOperation(httpMethod = "DELETE", value = "删除能力属性", notes = "删除能力属性")
    @RequestMapping(value = "/capacity-property-eliminate/{id}", produces = "application/json;charset=UTF-8", method = RequestMethod.DELETE)
    public CommonResponse deleteCapacityProperty(
            @ApiParam(value = "设备能力ID", required = true) @PathVariable Long id) {
        iCapacityPropertyService.deleteCapacityProperty(id);
        return CommonResponseUtil.success();
    }

    @ApiOperation(httpMethod = "DELETE", value = "删除设备", notes = "删除设备")
    @RequestMapping(value = "/device-eliminate/{id}", produces = "application/json;charset=UTF-8", method = RequestMethod.DELETE)
    public CommonResponse deleteEqpTemplate(
            @ApiParam(value = "设备ID", required = true) @PathVariable Long id) {
        try {
            iDeviceService.deleteDevice(id);
            return CommonResponseUtil.success();
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            return CommonResponseUtil.failure("删除设备失败！");
        }
    }

    /**
     * <pre>
     * 查询真实设备数据
     * </pre>
     *
     * @return
     */
    @ApiOperation(httpMethod = "GET", value = "查询真实设备数据", notes = "查询真实设备数据")
    @RequestMapping(value = "/real-list", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    public CommonResponse getRealDeviceList() {
        List<DaoCriteria> criterias = buildDaoCriteriasNoParam();
        List<Equipment> equipmentList = iDeviceService.getRealDeviceList(criterias);
        return CommonResponseUtil.success(equipmentList);
    }

    @ApiOperation(httpMethod = "GET", value = "根据设备id获取设备信息", notes = "根据设备id获取设备信息")
    @RequestMapping(value = "/device-info/{id}", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    public CommonResponse findEquipmentById(@ApiParam(value = "ID", required = true) @PathVariable Long id) {
        Equipment equipment = iDeviceService.findEquipmentById(id);
        return CommonResponseUtil.success(equipment);
    }

    @ApiOperation(httpMethod = "GET", value = "纳管分类统计", notes = "纳管分类统计")
    @RequestMapping(value = "/equipTempTypeStatic", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    public CommonResponse equipTempTypeStatic() {
        List<DaoCriteria> daoCriterias = buildDaoCriteriasNoParam();
        Map<String, Object> result = iDeviceService.equipTempTypeStatic(daoCriterias);
        return CommonResponseUtil.success(result);
    }

    @ApiOperation(httpMethod = "GET", value = "设备原型统计", notes = "设备原型统计")
    @RequestMapping(value = "/equipTempIndustryStatic", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    public CommonResponse equipTempIndustryStatic() {
        List<DaoCriteria> daoCriterias = buildDaoCriteriasNoParam();
        Map<String, Object> result = iDeviceService.equipTempIndustryStatic(daoCriterias);
        return CommonResponseUtil.success(result);
    }

    @ApiOperation(httpMethod = "GET", value = "获取设备的各种数量统计", notes = "获取设备的各种数量统计")
    @RequestMapping(value = "/device-count", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    public CommonResponse getDeviceCount() {
        List<DaoCriteria> daoCriteria = buildDaoCriteriasNoParam();
        Map<String, Object> map = iDeviceService.getDeviceCount(daoCriteria);
        return CommonResponseUtil.success(map);
    }

    @ApiOperation(httpMethod = "POST", value = "根据条件查询设备类型", notes = "根据条件查询设备类型")
    @RequestMapping(value = "/eqpTempl/list", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse fetchEqpTemplList(
            @ApiParam(value = "查询参数", required = true) @RequestBody EqpTemplPageParam requestParam) {
        List<EquipmentTemplate> eqpTempls = new ArrayList<EquipmentTemplate>();
        List<DaoCriteria> daoCriterias = new ArrayList<DaoCriteria>();
        HashMap<String, Object> paramMap = new HashMap<>();
        paramMap.put("name", requestParam.getName());
        paramMap.put("industryId", requestParam.getIndustryId());
        paramMap.put("model", requestParam.getModel());
        paramMap.put("type", requestParam.getType());
        paramMap.put("orgCode", getCompanyOrgCode());

        eqpTempls.addAll(eqpTemplService.findAllMybatis(paramMap));
        /**
         * 查询公共的设备类型
         */
//        List<DaoCriteria> filterCriterias = getFilterCriterias(requestParam);
//        DaoCriteria visDaoCriteria = new DaoCriteria();
//        visDaoCriteria.setPropertyName("visibility");
//        visDaoCriteria.setOperator(QueryOperatorEnum.EQUAL.getName());
//        visDaoCriteria.setValue(0);


//        daoCriterias.add(visDaoCriteria);
////        daoCriterias.add(orgDaoCriteria);
//        daoCriterias.addAll(filterCriterias);
        /**
         * 查询私有的设备类型
         */
        //构建查询条件
//        DaoCriteria orgDaoCriteria = new DaoCriteria();
//        orgDaoCriteria.setPropertyName("orgCode");
//        orgDaoCriteria.setOperator(QueryOperatorEnum.LIKE.getName());
//        orgDaoCriteria.setValue(getCompanyOrgCode() + "%");
////		buildOrgDaoCriteriaInChildren(daoCriterias, getOrgCode());
//        DaoCriteria daoCriteria = new DaoCriteria();
//        daoCriteria.setPropertyName("visibility");
//        daoCriteria.setOperator(QueryOperatorEnum.EQUAL.getName());
//        daoCriteria.setValue(1);
//        daoCriterias.add(daoCriteria);
//        daoCriterias.add(orgDaoCriteria);
//        daoCriterias.addAll(filterCriterias);
        //根据条件进行查询
//        eqpTempls.addAll(eqpTemplService.findAll(daoCriterias));
        List<Map<String, Object>> eqpTemplList = new ArrayList<Map<String, Object>>();
        Map<String, Object> eqpTemplMap = null;
        QueryEqpCountParam queryEqpCountParam = new QueryEqpCountParam();
        queryEqpCountParam.setOrgCode(getCompanyOrgCode());
        queryEqpCountParam.setModel(requestParam.getModel());//型号
        List<Long> eqpTmplIds = new ArrayList<>();
        eqpTempls.forEach(equipmentTemplate -> {
            eqpTmplIds.add(equipmentTemplate.getId());
        });
        queryEqpCountParam.setEqpTmplIds(eqpTmplIds);
        Map<Long, Long> eqpCountMap = iDeviceService.findEqpCount(queryEqpCountParam);
        /**
         *
         */
//        if (getUserInfo().getUserName().equals("yanshi"))//演示账号模拟设备数量
//        {
//            buildYanshiCount(eqpCountMap);
//        }
        /**
         *
         */
        long totalCount = 0;
        for (EquipmentTemplate equipmentTemplate : eqpTempls) {
            eqpTemplMap = new HashMap<String, Object>();
            long count = eqpCountMap.get(equipmentTemplate.getId());
            totalCount += count;
            eqpTemplMap.put("count", count);
            eqpTemplMap.put("eqpTemplate", equipmentTemplate);
            eqpTemplList.add(eqpTemplMap);
        }
        Map<String, Object> result = new HashMap<String, Object>();
        result.put("data", eqpTemplList);
        result.put("count", eqpTempls.size());
        result.put("totalCount", totalCount);
        return CommonResponseUtil.success(result);
    }

    private void buildYanshiCount(Map<Long, Long> eqpCountMap) {
        eqpCountMap.put(Long.valueOf(1), Long.valueOf(210));
        eqpCountMap.put(Long.valueOf(2), Long.valueOf(152));
        eqpCountMap.put(Long.valueOf(4), Long.valueOf(35));
        eqpCountMap.put(Long.valueOf(9), Long.valueOf(48));
        eqpCountMap.put(Long.valueOf(12), Long.valueOf(489));
        eqpCountMap.put(Long.valueOf(13), Long.valueOf(86));
        eqpCountMap.put(Long.valueOf(22), Long.valueOf(178));
        eqpCountMap.put(Long.valueOf(23), Long.valueOf(668));
        eqpCountMap.put(Long.valueOf(24), Long.valueOf(578));
        eqpCountMap.put(Long.valueOf(25), Long.valueOf(377));
        eqpCountMap.put(Long.valueOf(26), Long.valueOf(456));
        eqpCountMap.put(Long.valueOf(27), Long.valueOf(128));
        eqpCountMap.put(Long.valueOf(28), Long.valueOf(46));
        eqpCountMap.put(Long.valueOf(29), Long.valueOf(786));
        eqpCountMap.put(Long.valueOf(30), Long.valueOf(475));
    }

    /**
     * <pre>
     * 查询过滤条件
     * </pre>
     *
     * @param requestParam
     * @return
     */
    private List<DaoCriteria> getFilterCriterias(EqpTemplPageParam requestParam) {
        List<DaoCriteria> daoCriterias = new ArrayList<DaoCriteria>();
        if (requestParam.getName() != null) {
            DaoCriteria nameDaoCriteria = new DaoCriteria();
            nameDaoCriteria.setPropertyName("name");
            nameDaoCriteria.setOperator(QueryOperatorEnum.LIKE.getName());
            nameDaoCriteria.setValue("%" + requestParam.getName() + "%");
            daoCriterias.add(nameDaoCriteria);
        }
        if (requestParam.getIndustryId() != null) {
            DaoCriteria indDaoCriteria = new DaoCriteria();
            indDaoCriteria.setPropertyName("industryId");
            indDaoCriteria.setOperator(QueryOperatorEnum.EQUAL.getName());
            indDaoCriteria.setValue(requestParam.getIndustryId());
            daoCriterias.add(indDaoCriteria);
        }
        if (requestParam.getModel() != null) {
            DaoCriteria modelDaoCriteria = new DaoCriteria();
            modelDaoCriteria.setPropertyName("model");
            modelDaoCriteria.setOperator(QueryOperatorEnum.EQUAL.getName());
            modelDaoCriteria.setValue(requestParam.getModel());
            daoCriterias.add(modelDaoCriteria);
        }
        if (requestParam.getType() != null) {
            DaoCriteria typeDaoCriteria = new DaoCriteria();
            typeDaoCriteria.setPropertyName("type");
            typeDaoCriteria.setOperator(QueryOperatorEnum.EQUAL.getName());
            typeDaoCriteria.setValue(requestParam.getType());
            daoCriterias.add(typeDaoCriteria);
        }
        return daoCriterias;
    }

    /**
     * <pre>
     * 查询真实设备数据
     * </pre>
     *
     * @return
     */
    @ApiOperation(httpMethod = "POST", value = "根据参数查询真实设备数据", notes = "根据参数查询真实设备数据")
    @RequestMapping(value = "/real-device", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse getRealDeviceData(@ApiParam(value = "查询参数", required = true) @RequestBody EquipmentParam param) {
        Map<String, Object> dataMap = iDeviceService.getRealDeviceData(param);
        return CommonResponseUtil.success(dataMap);
    }

    @ApiOperation(httpMethod = "POST", value = "查询设备类型下的所有设备", notes = "查询设备类型下的所有设备")
    @RequestMapping(value = "/eqpTempl/equipments/{eqpTemplId}", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonPage<EquipmentVo> fetchDeviceList(
            @ApiParam(value = "设备类型ID", required = true) @PathVariable Long eqpTemplId,
            @ApiParam(value = "查询参数", required = true) @RequestBody EqpTemplPageParam requestParam) {
        //分页查询
        CommonPage<EquipmentVo> equipments = null;
        try {
            requestParam.setSort(new Sort(Sort.Direction.DESC, "id"));
            requestParam.setEqpTmplId(eqpTemplId);
            requestParam.setOrgCode(getCompanyOrgCode());
            equipments = iDeviceService.pageDeviceDataByMybatis(requestParam);
            equipments.setResult(SUCCESS);
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            equipments.setMessage(e.getMessage());
            equipments.setResult(FAILED);
        }
        return equipments;
    }

    @ApiOperation(httpMethod = "POST", value = "查询相同属性的所有设备", notes = "查询相同属性的所有设备")
    @RequestMapping(value = "/attr/equipments", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonPage<EquipmentVo> fetchDeviceList(
            @ApiParam(value = "查询参数", required = true) @RequestBody EqpTemplPageParam requestParam) {
        //分页查询
        CommonPage<EquipmentVo> equipments = null;
        try {
            requestParam.setSort(new Sort(Sort.Direction.DESC, "id"));
//            requestParam.setOrgCode(getCompanyOrgCode());
            equipments = iDeviceService.pageDeviceDataByMybatis(requestParam);
            equipments.setResult(SUCCESS);
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            equipments.setMessage(e.getMessage());
            equipments.setResult(FAILED);
        }
        return equipments;
    }

    @SuppressWarnings("unchecked")
    @ApiOperation(httpMethod = "POST", value = "新增/编辑测试设备", notes = "新增/编辑测试设备")
    @RequestMapping(value = "/saveFakeEquipment", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse addFakeEquipment(
            @ApiParam(value = "测试设备数量", required = true) @RequestParam int num,
            @ApiParam(value = "设备基本信息", required = true) @RequestBody String basicInfoStr) {
        String equipmentInfo = basicInfoStr;
        Equipment equipment = null;
        Map<String, String> map = BasicUtil.readStringToObject(equipmentInfo, Map.class);
        //设备基本信息
        Object basicInfo = map.get("basicInfo");
        Map<String, Object> basicInfoMap = (Map<String, Object>) basicInfo;
        // 属性信息
        Object propertyInfo = map.get("propertyMap");
        Map<String, Object> propertyMap = (Map<String, Object>) propertyInfo;

        for (int i = 1; i <= num; i++) {
            equipment = new Equipment();

            String equipId = "00" + MessageCommonUtil.bytes2HexString(MessageCommonUtil.convertInt2TwoBytesInBigEnd(i));
            propertyMap.put("equip_2", equipId);

            equipment.setOrgCode(getCompanyOrgCode());
            equipment.setName("testDevice" + i);
            if (!ObjectUtils.isEmpty(basicInfoMap.get("id"))) {
                equipment.setId(Long.parseLong(basicInfoMap.get("id").toString()));
            }

            if (equipmentService.checkNameConflict(equipment)) {
                return CommonResponseUtil.success(null, "设备名称重复");
            }

            if (equipment.getId() != null) {
                updateNodeInfo(equipment);
            }

            equipment.setDescr(basicInfoMap.get("descr").toString());
            equipment.setType(basicInfoMap.get("type").toString());

            if (basicInfoMap.get("imgName") != null) {
                equipment.setLogo(basicInfoMap.get("imgName").toString());
                if (basicInfoMap.get("binaryImg") != null) {
                    imgFileServer.saveIconFile(basicInfoMap.get("binaryImg").toString(), basicInfoMap.get("imgName").toString(), "device", "ISO-8859-1");
                }
            }

            String eqpTmplId = String.valueOf(basicInfoMap.get("eqpTmplId"));
            equipment.setEqpTmplId(Long.valueOf(eqpTmplId));
            equipment.setCfgParamJson(JSONUtil.toJson(map.get("propertyMap")).toString());
            equipment.setUserId(getUserId());
            equipment.setCreateTime(new Date());
            equipment.setAuthOrg(String.valueOf(basicInfoMap.get("authOrg")));
            equipment = equipmentService.save(equipment);

            /**
             * 删除旧的关联数据
             */
            List<EquipmentCapability> eqpCpblList = eqpCpblService.findByEqpId(equipment.getId());
            for (EquipmentCapability equipmentCapability : eqpCpblList) {
                eqpCpblService.delete(equipmentCapability);
            }
            /**
             * 构建新的关联数据
             */
            Object paramInfo = map.get("taskParam");
            Map<String, String> paramMap = (Map<String, String>) paramInfo;
            for (String cpblId : paramMap.keySet()) {
                EquipmentCapability eqpCapability = new EquipmentCapability();
                Object tastParamInfo = paramMap.get(cpblId);
                Map<String, String> tastParamMap = (Map<String, String>) tastParamInfo;
                eqpCapability.setCpblId(Long.valueOf(cpblId));
                eqpCapability.setEqpId(equipment.getId());
                String monitorPeriod = String.valueOf(tastParamMap.get("monitorPeriod"));
                eqpCapability.setMonitorPeriod(Integer.valueOf(monitorPeriod));
                String monitorType = String.valueOf(tastParamMap.get("monitorType"));
                eqpCapability.setMonitorType(Integer.valueOf(monitorType));
                eqpCpblService.save(eqpCapability);
            }
            List<Long> eqpIds = new ArrayList<>(1);
            eqpIds.add(equipment.getId());
            nettyServerService.update(eqpIds);

            /**
             * 门限配置信息
             */
            iEqpCpblPropertyService.deleteByEqpId(equipment.getId());
            Object thresholdObj = map.get("threshold");
            Map<String, Object> thresholdMap = (Map<String, Object>) thresholdObj;
            List<EqpCpblProperty> thresholdList = new ArrayList<>();
            for (Entry<String, Object> entry : thresholdMap.entrySet()) {
                String[] thresholdKeys = entry.getKey().split("_");
                Map<String, Object> thresholdInfoMap = (Map<String, Object>) entry.getValue();
                EqpCpblProperty eqpCpblProperty = new EqpCpblProperty();
                eqpCpblProperty.setEqpId(equipment.getId());
                eqpCpblProperty.setCpblId(Long.parseLong(thresholdKeys[0]));
                eqpCpblProperty.setCpblPropertyId(Long.parseLong(thresholdKeys[1]));
                eqpCpblProperty.setMaxValue(Double.parseDouble(thresholdInfoMap.get("upper").toString()));
                eqpCpblProperty.setMinValue(Double.parseDouble(thresholdInfoMap.get("lower").toString()));
                thresholdList.add(eqpCpblProperty);
            }
            iEqpCpblPropertyService.saveAll(thresholdList);
        }

        return CommonResponseUtil.success(equipment);
    }

    @SuppressWarnings("unchecked")
    @ApiOperation(httpMethod = "POST", value = "新增/编辑设备", notes = "新增/编辑设备")
    @RequestMapping(value = "/saveEquipment", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse addEquipment(
            @ApiParam(value = "设备信息", required = true) @RequestBody String equipmentInfo) {
        Equipment equipment = null;
        Map<String, String> map = BasicUtil.readStringToObject(equipmentInfo, Map.class);
        //设备基本信息
        Object basicInfo = map.get("basicInfo");
        Map<String, Object> basicInfoMap = (Map<String, Object>) basicInfo;
        if (basicInfoMap.get("id") != null) {
            equipment = equipmentService.findOne(Long.valueOf(basicInfoMap.get("id").toString()));
        } else {
            equipment = new Equipment();
            equipment.setOrgCode(getCompanyOrgCode());
        }
        equipment.setName(basicInfoMap.get("name").toString());
        if (equipmentService.checkNameConflict(equipment)) {
            return CommonResponseUtil.success(null, "设备名称重复");
        }
        if (equipment.getId() != null) {
            updateNodeInfo(equipment);

        }
        equipment.setDescr(basicInfoMap.get("descr").toString());
        equipment.setType(basicInfoMap.get("type").toString());
        if (basicInfoMap.get("imgName") != null) {
            equipment.setLogo(basicInfoMap.get("imgName").toString());
            if (basicInfoMap.get("binaryImg") != null) {
                imgFileServer.saveIconFile(basicInfoMap.get("binaryImg").toString(), basicInfoMap.get("imgName").toString(), "device", "ISO-8859-1");
            }
        }
        String eqpTmplId = String.valueOf(basicInfoMap.get("eqpTmplId"));
        equipment.setEqpTmplId(Long.valueOf(eqpTmplId));
        equipment.setCfgParamJson(JSONUtil.toJson(map.get("propertyMap")).toString());
        equipment.setUserId(getUserId());
        equipment.setCreateTime(new Date());
//        ArrayList<String> authOrg = (ArrayList) basicInfoMap.get("authOrg");
//        if (authOrg == null) {
//            authOrg = new ArrayList<String>();
//        }
//        ArrayList newAuthOrg = new ArrayList<>();
//        newAuthOrg.addAll(authOrg);
//        newAuthOrg.add(getCompanyOrgCode());
//        newAuthOrg.add(getOrgCode());
//        equipment.setAuthOrg(String.valueOf(newAuthOrg));
        equipment.setAuthOrg(String.valueOf(basicInfoMap.get("authOrg")));
        equipment = equipmentService.save(equipment);
        /**
         * 删除旧的关联数据
         */
        List<EquipmentCapability> eqpCpblList = eqpCpblService.findByEqpId(equipment.getId());
        for (EquipmentCapability equipmentCapability : eqpCpblList) {
            eqpCpblService.delete(equipmentCapability);
        }
        /**
         * 构建新的关联数据
         */
        Object paramInfo = map.get("taskParam");
        Map<String, String> paramMap = (Map<String, String>) paramInfo;
        for (String cpblId : paramMap.keySet()) {
            EquipmentCapability eqpCapability = new EquipmentCapability();
            Object tastParamInfo = paramMap.get(cpblId);
            Map<String, String> tastParamMap = (Map<String, String>) tastParamInfo;
            eqpCapability.setCpblId(Long.valueOf(cpblId));
            eqpCapability.setEqpId(equipment.getId());
            String monitorPeriod = String.valueOf(tastParamMap.get("monitorPeriod"));
            eqpCapability.setMonitorPeriod(Integer.valueOf(monitorPeriod));
            String monitorType = String.valueOf(tastParamMap.get("monitorType"));
            eqpCapability.setMonitorType(Integer.valueOf(monitorType));
            eqpCpblService.save(eqpCapability);
        }
        List<Long> eqpIds = new ArrayList<>(1);
        eqpIds.add(equipment.getId());
        nettyServerService.update(eqpIds);
        /**
         * 门限配置信息
         */
        iEqpCpblPropertyService.deleteByEqpId(equipment.getId());
        Object thresholdObj = map.get("threshold");
        Map<String, Object> thresholdMap = (Map<String, Object>) thresholdObj;
        List<EqpCpblProperty> thresholdList = new ArrayList<>();
        for (Entry<String, Object> entry : thresholdMap.entrySet()) {
            String[] thresholdKeys = entry.getKey().split("_");
            Map<String, Object> thresholdInfoMap = (Map<String, Object>) entry.getValue();
            EqpCpblProperty eqpCpblProperty = new EqpCpblProperty();
            eqpCpblProperty.setEqpId(equipment.getId());
            eqpCpblProperty.setCpblId(Long.parseLong(thresholdKeys[0]));
            eqpCpblProperty.setCpblPropertyId(Long.parseLong(thresholdKeys[1]));
            if (!ObjectUtils.isEmpty(thresholdInfoMap.get("upper"))) {
                eqpCpblProperty.setMaxValue(Double.parseDouble(thresholdInfoMap.get("upper").toString()));
            }
            if (!ObjectUtils.isEmpty(thresholdInfoMap.get("lower"))) {
                eqpCpblProperty.setMinValue(Double.parseDouble(thresholdInfoMap.get("lower").toString()));
            }

            thresholdList.add(eqpCpblProperty);
        }
        if(thresholdList.size()>0) {
        	iEqpCpblPropertyService.saveAll(thresholdList);
        }
        return CommonResponseUtil.success(equipment);
    }

    /**
     * <pre>
     * 更新拓扑视图中的名称信息
     * </pre>
     *
     * @param equipment
     */
    @SuppressWarnings("unchecked")
    private void updateNodeInfo(Equipment equipment) {
        List<Node> nodes = iTopoNodeService.findNodByEquipmentId(equipment.getId());
        ListIterator<Node> listIt = nodes.listIterator();
        while (listIt.hasNext()) {
            Node node = listIt.next();
            Map<String, Object> map = (Map<String, Object>) JSON.parse(node.getConfig());
            map.put("label", equipment.getName());
            node.setConfig(JSON.toJSONString(map));
            iTopoNodeService.save(node);
        }
    }

    @ApiOperation(httpMethod = "DELETE", value = "删除设备", notes = "删除设备")
    @RequestMapping(value = "/delEquipment", produces = "application/json;charset=UTF-8", method = RequestMethod.DELETE)
    public CommonResponse deleteDevice(
            @ApiParam(value = "设备ID", required = true) @RequestBody List<Long> ids) {
        try {
            equipmentService.delEquipmentById(ids);
            nettyServerService.delete(ids);
            return CommonResponseUtil.success();
        } catch (Exception e) {
            // TODO: handle exception
            log.error(e.getMessage(), e);
            return CommonResponseUtil.failure();
        }

    }

    @ApiOperation(httpMethod = "GET", value = "查询设备数据", notes = "查询设备数据")
    @RequestMapping(value = "/equipment-entity/{id}", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    public CommonResponse fetchEquipmentEntity(
            @ApiParam(value = "设备ID", required = true, defaultValue = "1") @PathVariable Long id) {
        Equipment equipment = equipmentService.findOne(id);
        return CommonResponseUtil.success(equipment);
    }

    @ApiOperation(httpMethod = "POST", value = "编辑设备信息", notes = "设备设备信息")
    @RequestMapping(value = "/equipment/property", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse editEquipmentInfo(
            @ApiParam(value = "设备能力参数", required = true) @RequestBody EquipmentParam param) {
        iDeviceService.editEquipmentInfo(param);
        return CommonResponseUtil.success();
    }

    @ApiOperation(httpMethod = "POST", value = "设备详情/测试设备", notes = "设备详情/测试设备")
    @RequestMapping(value = "/test/{flag}", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse test(
            @ApiParam(value = "flag", required = true, defaultValue = "connct") @PathVariable String flag,
            @ApiParam(value = "设备数据", required = true) @RequestBody TestEqpParam testEqpParam) {
        CommonResponse response = new CommonResponse();
        try {
            //testEquipmentService.test123(testEqpParam, getToken(), flag);
            testEquipmentService.startTest(testEqpParam, getToken(), flag);
            response.setResult(SUCCESS);
        } catch (YeeException e) {
            log.error(e.getMessage(), e);
            response.setResult(FAILED);
            response.setMessage(e.getMessage());
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            response.setResult(FAILED);
            response.setMessage(e.getMessage());
        }
        return response;
    }

    @ApiOperation(httpMethod = "GET", value = "查询能力属性", notes = "查询能力属性")
    @RequestMapping(value = "/quota-info/{ids}", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    public CommonResponse quotaSelecteds(
            @ApiParam(value = "指标ID集合", required = true) @PathVariable Long... ids) {
        List<CapabilityAttribute> capAttrList = iCapacityPropertyService.getInfoByIds(false, ids);
        return CommonResponseUtil.success(capAttrList);
    }

    @ApiOperation(httpMethod = "GET", value = "导出测试数据", notes = "导出测试数据")
    @RequestMapping(value = "/export", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    public void exportData(HttpServletRequest req, HttpServletResponse res) {
        try {

            String fileName = DeviceController.class.getResource("/template/test.doc").getPath();
            File file = new File(fileName);

            // 1.获取“测试设备”的结果数据构造参数
            Map<String, Object> dataMap = TestResultStoreUtil.getInstance().getResultMap();

            List<TestCapablility> cpblList = new ArrayList<>();    // 测试采集数据列表
            List<TestIntfc> intfcList = new ArrayList<>();    // 测试接口数据列表

            for (Map.Entry<String, Object> entry : dataMap.entrySet()) {
                if (entry.getKey() != null && entry.getKey().contains(IotConstant.EquipmentConstant.TEST_EQUIPMENT
                        + IotConstant.SHARP + "metric")) {
                    Map<String, Object> tempMap = (Map<String, Object>) entry.getValue();
                    TestCapablility testCpbl = (TestCapablility) tempMap.get("metricData");    // 获取指标测试数据
                    cpblList.add(testCpbl);

                }
                if (entry.getKey() != null && entry.getKey().contains(IotConstant.EquipmentConstant.TEST_EQUIPMENT
                        + IotConstant.SHARP + "connect")) {
                    Map<String, Object> tempMap = (Map<String, Object>) entry.getValue();
                    TestIntfc testIntfc = (TestIntfc) tempMap.get("connectData");    // 获取接口测试数据
                    intfcList.add(testIntfc);
                }
            }

            // 通过ID获取设备模板
            if (dataMap.get("eqpTemplateID") == null) {
                log.debug("设备模板ID为空！");
                return;
            }
            EquipmentTemplate eqpTemplate = eqpTemplService.findOne(Long.parseLong(dataMap.get("eqpTemplateID").toString()));

            if (eqpTemplate == null) {
                log.debug("设备模板为空！");
                return;
            }

            Map<Object, Object> resultMap = new HashMap<Object, Object>();
            resultMap.put("deviceName", dataMap.get("equipmentName"));
            resultMap.put("eqpType", EquipmentType.getName(eqpTemplate.getType()));
            resultMap.put("testDate", SimpleDateFormat.getDateInstance().format(System.currentTimeMillis()));
            resultMap.put("eqpTemplate", eqpTemplate);
            resultMap.put("intfcList", intfcList);
            resultMap.put("cpblList", cpblList);

            if (CollectionUtils.isNotEmpty(intfcList) && CollectionUtils.isNotEmpty(cpblList)) {
                resultMap.put("testType", "连接测试&amp;性能测试");
            } else if (CollectionUtils.isNotEmpty(intfcList) && CollectionUtils.isEmpty(cpblList)) {
                resultMap.put("testType", "连接测试");
            } else {
                resultMap.put("testType", "性能测试");
            }

            // 2.调用工具类根据模板生成Word文档
            file = TestEqpDataExportUtil.exportTestEqpResult(resultMap, "doc");

            FileInputStream fis = null;
            BufferedInputStream buff = null;
            OutputStream myout = null;
            if (!file.exists()) {
                // log.info("下载的文件不存在....");
            } else {
                // 设置response 的编码方式
                System.out.println("file:" + file.getName());
//				res.setContentType("application/x-msdownload");
                res.setContentType("application/msword");
                // 要下载文件的大小
                res.setContentLength((int) file.length());
                // 设置附件头部信息
                SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
                sdf.format(new Date());
                res.setHeader("Content-Disposition",
                        "attachment;fileName="
                                + new String(("设备在线测试报告-" + sdf.format(new Date()) + ".doc").getBytes("utf-8"),
                                "iso-8859-1"));

            }
            fis = new FileInputStream(file);
            buff = new BufferedInputStream(fis);
            byte[] b = new byte[1024];
            long len = 0;
            myout = res.getOutputStream();
            while (len < file.length()) {
                int j = buff.read(b, 0, 1024);
                len += j;
                myout.write(b, 0, j);
            }
            if (fis != null) {
                fis.close();
            }
            if (buff != null) {
                buff.close();
            }
            if (myout != null) {
                myout.close();
            }
            res.flushBuffer();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    @ApiOperation(httpMethod = "GET", value = "停止设备测试(仅仅用于自测)", notes = "停止设备测试(仅仅用于自测)")
    @RequestMapping(value = "/stopTest", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    public CommonResponse stopTest() {
        CommonResponse response = new CommonResponse();
        try {
            TestEquipmentCache.getInstance().clean();
            response.setResult(SUCCESS);
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            response.setResult(FAILED);
            response.setMessage(e.getMessage());
        }
        return response;
    }

    @ApiOperation(httpMethod = "GET", value = "查询设备下能力", notes = "查询设备下能力")
    @RequestMapping(value = "/{eqpTemplId}/{eqpId}/cpbls", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    public CommonResponse fetchCpblList(
            @ApiParam(value = "设备类型ID", required = true) @PathVariable Long eqpTemplId,
            @ApiParam(value = "设备ID", required = true) @PathVariable Long eqpId) {
        //获取设备支持的能力
        List<Long> cpblIdList = null;
        Map<Long, EquipmentCapability> cacheMap = new HashMap<>();
        if (eqpId != 0) {
            List<EquipmentCapability> eqpCpblList = eqpCpblService.findByEqpId(eqpId);
            cpblIdList = new ArrayList<Long>();
            for (EquipmentCapability equipmentCapability : eqpCpblList) {
                cpblIdList.add(equipmentCapability.getCpblId());
                cacheMap.put(equipmentCapability.getCpblId(), equipmentCapability);
            }
        }
        //获取设备模板下的所有能力
        EquipmentTemplate equipmentTemplate = eqpTemplService.findOne(eqpTemplId);
        List<Capability> capabilityList = equipmentTemplate.getCapabilities();
        for (Capability capability : capabilityList) {
            if (cpblIdList != null)//编辑或者查看,需要填充设备对应能力是否启用
            {
                EquipmentCapability equipmentCapability = cacheMap.get(capability.getId());
                if (equipmentCapability != null) {
                    capability.setMonitorPeriod(equipmentCapability.getMonitorPeriod());
                    capability.setMonitorType(equipmentCapability.getMonitorType());
                }
                if (!cpblIdList.contains(capability.getId())) {
                    capability.setIsUser(false);
                }
            }
        }
        return CommonResponseUtil.success(capabilityList);
    }

    @SuppressWarnings("unchecked")
    @ApiOperation(httpMethod = "GET", value = "查询设备下能力的属性", notes = "查询设备下能力的属性")
    @RequestMapping(value = "/{eqpId}/{cpblId}/cpblAttrs", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    public CommonResponse fetchCpblAttrList(
            @ApiParam(value = "设备ID", required = true) @PathVariable Long eqpId,
            @ApiParam(value = "能力ID", required = true) @PathVariable Long cpblId) {
        //获取设备支持的能力属性
        List<Long> cpblAttrIdList = null;
        if (eqpId != 0) {
            cpblAttrIdList = new ArrayList<Long>();
            Equipment equipment = equipmentService.findOne(eqpId);
            Map<String, Object> valueMap = equipment.getCfgParamMap();
            Object obj = valueMap.get("quotaSelected");
            if (obj != null) {
                Map<String, Object> objectMap = (Map<String, Object>) obj;
                for (String key : objectMap.keySet()) {
                    Object object = objectMap.get(key);
                    if (key.equals(String.valueOf(cpblId)) && object != null) {
                        List<Integer> intList = (List<Integer>) object;
                        for (Integer integer : intList) {
                            cpblAttrIdList.add(Long.valueOf(integer));
                        }
                    }
                }
            }
        }
        //获取设备模板下能力的所有的属性
        List<CapacityPropertyDataVo> capabilityAttributes = iDeviceService.getCapacityPropertyById(cpblId);
        for (CapacityPropertyDataVo capacityPropertyDataVo : capabilityAttributes) {
            if (cpblAttrIdList != null)//编辑或者查看,需要填充设备对应能力属性是否启用
            {
                if (!cpblAttrIdList.contains(capacityPropertyDataVo.getId())) {
                    capacityPropertyDataVo.setIsUser(false);
                }
            }
        }

        // 清空“测试设备”上一次测试结果数据
        TestResultStoreUtil.getInstance().getResultMap().clear();

        return CommonResponseUtil.success(capabilityAttributes);
    }

    @SuppressWarnings("unchecked")
    @ApiOperation(httpMethod = "GET", value = "查询设备下能力属性", notes = "查询设备下能力属性")
    @RequestMapping(value = "/{eqpTemplId}/{eqpId}/eqpCpblAttrs", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    public CommonResponse fetchEqpAttrList(
            @ApiParam(value = "设备类型ID", required = true) @PathVariable Long eqpTemplId,
            @ApiParam(value = "设备ID", required = true) @PathVariable Long eqpId) {
        //获取设备支持的能力属性
        List<Long> cpblAttrIdList = null;
        List<String> selIds = null;
        Map<String, EqpCpblProperty> thresholdMap = new HashMap<>();
        if (eqpId != 0) {
            cpblAttrIdList = new ArrayList<Long>();
            Equipment equipment = equipmentService.findOne(eqpId);
            Map<String, Object> valueMap = equipment.getCfgParamMap();
            Object obj = valueMap.get("quotaSelected");
            if (obj != null) {
                Map<String, Object> objectMap = (Map<String, Object>) obj;
                for (String key : objectMap.keySet()) {
                    Object object = objectMap.get(key);
                    if (object != null) {
                        List<Integer> intList = (List<Integer>) object;
                        for (Integer integer : intList) {
                            cpblAttrIdList.add(Long.valueOf(integer));
                        }
                    }
                }
            }
            //选择的能力集合
            selIds = (List<String>) valueMap.get("selCpblIds");
        }
        //获取设备模板下的所有能力
        EquipmentTemplate equipmentTemplate = eqpTemplService.findOne(eqpTemplId);
        List<Capability> capabilityList = equipmentTemplate.getCapabilities();
        List<CapacityPropertyDataVo> capabilityAttributes = new ArrayList<CapacityPropertyDataVo>();
        for (Capability capability : capabilityList) {
            if (selIds != null && !selIds.contains(capability.getId().toString())) {
                //非新增时获取数据：过滤未选中的能力
                continue;
            }
            //获取设备模板下能力的所有的属性
            List<CapacityPropertyDataVo> capabilityAttList = iDeviceService.getCapacityPropertyById(capability.getId());
            List<CapacityPropertyDataVo> delList = new ArrayList<CapacityPropertyDataVo>();
            for (CapacityPropertyDataVo capacityPropertyDataVo : capabilityAttList) {
                if (cpblAttrIdList != null)//编辑或者查看,需要填充设备对应能力属性是否启用
                {
                    if (!cpblAttrIdList.contains(capacityPropertyDataVo.getId())) {
                        delList.add(capacityPropertyDataVo);
                    } else {
                        EqpCpblProperty tempProperty = new EqpCpblProperty();
                        tempProperty.setCpblId(capacityPropertyDataVo.getCpblId());
                        tempProperty.setCpblPropertyId(capacityPropertyDataVo.getId());
                        tempProperty.setMaxValue(capacityPropertyDataVo.getMaxValue());
                        tempProperty.setMinValue(capacityPropertyDataVo.getMinValue());
                        thresholdMap.put(capacityPropertyDataVo.getCpblId().toString() + capacityPropertyDataVo.getId(), tempProperty);
                    }
                }
            }
            capabilityAttList.removeAll(delList);
            capabilityAttributes.addAll(capabilityAttList);
        }
        //添加属性上下限值
        //1默认填充所有打开的属性map
        //2查询设备私有配置，如果map有该key，说明启用，直接覆盖默认值，如果没有，说明该属性没有启用，属于冗余数据直接删除
        if (eqpId != 0) {
            List<EqpCpblProperty> eqpCpblProperties = iEqpCpblPropertyService.findInfoByEqpId(eqpId);
            for (EqpCpblProperty eqpCpblProperty : eqpCpblProperties) {
                String key = eqpCpblProperty.getCpblId().toString() + eqpCpblProperty.getCpblPropertyId();
                if (thresholdMap.containsKey(key)) {
                    thresholdMap.put(key, eqpCpblProperty);
                } else {
                    iEqpCpblPropertyService.delete(eqpCpblProperty);
                }
            }
        }
        Map<String, Object> result = new HashMap<>();
        result.put("threshold", thresholdMap.values());
        result.put("property", capabilityAttributes);

        return CommonResponseUtil.success(result);
    }

    @ApiOperation(httpMethod = "POST", value = "新增/编辑设备", notes = "新增/编辑设备")
    @RequestMapping(value = "/equipment-attribute", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse addEquipmentAttribute(
            @ApiParam(value = "编辑参数", required = true) @RequestBody Equipment equipment) {
        Long equipmentId = equipmentService.updateEquipmentAttribute(equipment);
        return CommonResponseUtil.success(equipmentId);
    }

    @ApiOperation(httpMethod = "GET", value = "查询设备能力的接口数据", notes = "查询设备能力的接口数据")
    @RequestMapping(value = "/capacity-intfc/{id}", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    public CommonResponse fetchCapacityInterface(@ApiParam(value = "ID", required = true, defaultValue = "1")
                                                 @PathVariable Long id) {
        List<CapacityInterfaceDataVo> capacityInterfaceDataVos = iDeviceService.getCapacityInterfaceById(id);
        if (capacityInterfaceDataVos.size() == 1) {
            Intfc intfc = intfcService.findOne(capacityInterfaceDataVos.get(0).getIntfcId());
            return CommonResponseUtil.success(intfc);
        }
        return CommonResponseUtil.success();
    }

    @ApiOperation(httpMethod = "GET", value = "查询拓扑中设备所有配置信息", notes = "查询拓扑中设备所有配置信息")
    @RequestMapping(value = "/topo-device/{id}", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    public CommonResponse fetchTopoDevice(@ApiParam(value = "ID", required = true, defaultValue = "1")
                                          @PathVariable Long id) {
        Map<String, Object> result = iDeviceService.fetchTopoDevice(id);
        return CommonResponseUtil.success(result);
    }

    @ApiOperation(httpMethod = "POST", value = "编辑设备json配置信息（单独）", notes = "编辑设备json配置信息（单独）")
    @RequestMapping(value = "/equipment/single-property", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse editEquipmentConfigInfo(
            @ApiParam(value = "需要改变的设备能力参数", required = true) @RequestBody Map<String, Object> param) {
        iDeviceService.editEquipmentConfigInfo(param);
        return CommonResponseUtil.success();
    }

    @ApiOperation(httpMethod = "POST", value = "新增编辑设备图片", notes = "新增编辑设备图片")
    @RequestMapping(value = "/eqipment-img", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse addEditEquipmentImg(
            @ApiParam(value = "设备参数", required = true) @RequestBody EquipmentParam param) {
        iDeviceService.addEditEquipmentImg(param);
        return CommonResponseUtil.success();
    }

    //查询设备型号，前端plist使用
    @ApiOperation(httpMethod = "GET", value = "查询获取设备型号", notes = "查询获取设备型号")
    @RequestMapping(value = "/equipment/modelDate", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    public CommonResponse qryEqpModel() {
        String orgCode = getCompanyOrgCode();
        List<EquipmentTemplateVo> EquipmentTemplateVos = iDeviceService.getEqpTmpModelByOrgCode(orgCode);
        return CommonResponseUtil.success(EquipmentTemplateVos);
    }

    @ApiOperation(httpMethod = "GET", value = "查询获取设备型号", notes = "查询获取设备型号")
    @RequestMapping(value = "/equipment/count/attr", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
    public CommonResponse qryEqpCountByTemplAttrs(List<String> attrName) {
        String orgCode = getCompanyOrgCode();
        List<Map> maps = iDeviceService.qryEqpCountByTemplAttrs(orgCode, attrName);
        return CommonResponseUtil.success(maps);
    }

    @ApiOperation(value = "根据类型统计设备总数和异常设备总数", notes = "统计设备总数和异常设备总数")
    @GetMapping(value = "/statisticDeviceByModel")
    public CommonResponse statisticDeviceByModel(@ApiParam(value = "组织机构编码", required = true) @RequestParam String orgCode) {
        return CommonResponseUtil.success(iDeviceService.statisticDeviceByModel(orgCode));
    }

    @ApiOperation(value = "根据告警级别统计设备总数和异常设备总数", notes = "统计设备总数和异常设备总数")
    @GetMapping(value = "/statisticDeviceByAlarmLevel")
    public CommonResponse statisticDeviceByAlarmLevel(@ApiParam(value = "组织机构编码", required = true) @RequestParam String orgCode) {
        return CommonResponseUtil.success(iDeviceService.statisticDeviceByAlarmLevel(orgCode));
    }

    @ApiOperation(value = "根据组织机构编号和设备型号查询设备列表", notes = "统计设备总数和异常设备总数")
    @GetMapping(value = "/listByOrgCodeAndModel")
    public CommonResponse listByOrgCodeAndModel(@ApiParam(value = "组织机构编码", required = true) @RequestParam String orgCode,
                                                @ApiParam(value = "设备型号", required = true) @RequestParam String model) {
        return CommonResponseUtil.success(iDeviceService.listByOrgCodeAndModel(orgCode, model));
    }

    @ApiOperation(value = "根据设备Id查询", notes = "统计设备总数和异常设备总数")
    @GetMapping(value = "/cpbl/attr")
    public CommonResponse listDeviceAndDeviceCpblAttr(@RequestParam(required = false)  Long equipmentId) {
        List<EquipmentVo> list = iDeviceService.listDeviceAndDeviceCpblAttr(equipmentId);
        return CommonResponseUtil.success(list);
    }

    @ApiOperation(value = "根据设备Id查询", notes = "根据设备Id查询模板能力")
    @GetMapping(value = "/cpbl/list/{equipmentId}")
    public CommonResponse listDeviceCpbl(@PathVariable  long equipmentId) {
        Equipment equipment = equipmentService.findOne(equipmentId);
        List<Capability> list = iCapabilityService.findByEqpTmpl(equipment.getEqpTmplId());
        return CommonResponseUtil.success(list);
    }
}
