package com.yeejoin.amos.iot.business.controller;

import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.yeejoin.amos.iot.business.entity.EquipmentTemplate;
import com.yeejoin.amos.iot.business.param.QueryMetricDataParam;
import com.yeejoin.amos.iot.business.service.intfc.IHistoryDataService;
import com.yeejoin.amos.op.core.common.response.CommonResponse;
import com.yeejoin.amos.op.core.util.CommonResponseUtil;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;

/**
 * 
 * <pre>
 * 历史数据模块
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: HistoricalDataController.java, v 0.1 2018年3月22日 上午9:44:49 as-chenjiajun Exp $
 */
@RestController
@RequestMapping("/history")
@Api(value = "history", tags = { "设备历史数据管理" })
public class HistoricalDataController extends BaseController
{
	@Autowired
	private IHistoryDataService iHistoryDataService;

	@ApiOperation(httpMethod = "POST", value = "条件查询指标数据", notes = "条件查询指标数据")
	@RequestMapping(value = "/history-condition-data", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
	public CommonResponse findMetricData(
			@ApiParam(value = "参数", required = true) @RequestBody QueryMetricDataParam param) {
		Map<String, List<Map<String, Object>>> data = iHistoryDataService.findByParam(param);
		return CommonResponseUtil.success(data);
	}
	
	@ApiOperation(httpMethod = "GET", value = "查询设备数据", notes = "查询设备数据")
	@RequestMapping(value = "/template-entity/{id}", produces = "application/json;charset=UTF-8", method = RequestMethod.GET)
	public CommonResponse fetchDeviceEntity(@ApiParam(value = "ID", required = true, defaultValue = "1")
	@PathVariable Long id) {
		EquipmentTemplate equipmentTemplate = iHistoryDataService.getDeviceById(id);
		return CommonResponseUtil.success(equipmentTemplate);
	}
}
