package com.yeejoin.amos.iot.business.controller;

import com.yeejoin.amos.iot.business.entity.Protocol;
import com.yeejoin.amos.iot.business.exceptions.ProtocolException;
import com.yeejoin.amos.iot.business.protocol.ReportData;
import com.yeejoin.amos.iot.business.service.intfc.IProtocolService;
import com.yeejoin.amos.iot.business.vo.ProtocolVo;
import com.yeejoin.amos.op.core.common.response.CommonResponse;
import com.yeejoin.amos.op.core.util.CommonResponseUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

@RestController
@RequestMapping("/reportdata")
@Api(value = "reportdata", tags = {"上报数据管理"})
public class ReportDataController extends BaseController {

    @Resource
    private IProtocolService protocolService;

    @ApiOperation(httpMethod = "POST", value = "缓存上报数据", notes = "缓存上报数据")
    @RequestMapping(value = "/add", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse add(@ApiParam(value = "参数", required = true) @RequestBody ReportData reportData) {
        return CommonResponseUtil.success();
    }

    @ApiOperation(httpMethod = "POST", value = "获取上报数据", notes = "获取上报数据")
    @RequestMapping(value = "/getByKey", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse getByKey(@ApiParam(value = "参数", required = true) @RequestBody String key) {
        ReportData reportData = new ReportData();
        return CommonResponseUtil.success(reportData);
    }

    @RequestMapping(value = "/addProtocol", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse addProtocol(@ApiParam(value = "参数", required = true) @RequestBody Protocol protocol) throws ProtocolException {
        protocolService.saveProtocol(protocol);
        return CommonResponseUtil.success();
    }

    @RequestMapping(value = "/getProtocol", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
    public CommonResponse getProtocol(@ApiParam(value = "参数", required = true) @RequestBody Long id) {
        ProtocolVo protocol = protocolService.findById(id);
        return CommonResponseUtil.success(protocol);
    }

}