package com.yeejoin.amos.iot.business.controller;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import com.yeejoin.amos.iot.business.entity.Section;
import com.yeejoin.amos.iot.business.param.SectionParam;
import com.yeejoin.amos.iot.business.service.intfc.ISectionService;
import com.yeejoin.amos.op.core.common.response.CommonResponse;
import com.yeejoin.amos.op.core.util.CommonResponseUtil;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

/**
 * 
 * <pre>
 * 插件管理
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: SectionController.java, v 0.1 2018年6月27日 下午2:13:28 as-chenjiajun Exp $
 */
@RestController
@RequestMapping("/section")
@Api(value = "section", tags = { "插件管理" })
public class SectionController extends BaseController
{
	@Autowired
	private ISectionService iSectionService;
	
	@ApiOperation(httpMethod = "POST", value = "查询插件数据", notes = "查询插件数据")
	@RequestMapping(value = "/sections-entitys", produces = "application/json;charset=UTF-8", method = RequestMethod.POST)
	public CommonResponse fetchSubgraphInfos(@RequestBody SectionParam param) {
		param.setOrgCode(getCompanyOrgCode());
		List<Section> recommend = iSectionService.getSectionsByCondition(param,5);
		param.setIsRecommend(null);
		List<Section> last = iSectionService.getSectionsByCondition(param,5);
		Map<String, List<Section>> map = new HashMap<String, List<Section>>();
		map.put("last", last);
		map.put("recommend", recommend);
		return CommonResponseUtil.success(map);
	}
}
