//package com.yeejoin.amos.iot.business.dao;
//
//import com.google.common.collect.Lists;
//import com.google.common.collect.Maps;
//import com.yeejoin.amos.op.core.common.query.DaoCriteria;
//import com.yeejoin.amos.op.core.common.query.QueryOperatorEnum;
//import org.hibernate.jpa.criteria.CriteriaBuilderImpl;
//import org.hibernate.jpa.criteria.predicate.InPredicate;
//import org.springframework.data.jpa.domain.Specification;
//
//import javax.persistence.criteria.CriteriaBuilder;
//import javax.persistence.criteria.CriteriaQuery;
//import javax.persistence.criteria.Order;
//import javax.persistence.criteria.Predicate;
//import javax.persistence.criteria.Root;
//import java.util.Iterator;
//import java.util.List;
//import java.util.Map;
//
//public class IotSpecification<T> implements Specification<T> {
//    private Map<String, List<DaoCriteria>> criterias;
//    private List<DaoCriteria> daoCriterias;
//    private Map<String, List<String>> orderbys;
//
//    public IotSpecification(List<DaoCriteria> daoCriterias) {
//        this.daoCriterias = daoCriterias;
//    }
//
//    @Override
//    public Predicate toPredicate(Root<T> root, CriteriaQuery<?> query, CriteriaBuilder builder) {
//        if (this.daoCriterias == null) {
//            return builder.and(new Predicate[0]);
//        } else {
//            this.criterias = this.classify(this.daoCriterias);
//            List<Predicate> conditions = Lists.newArrayList();
//            Iterator var5 = this.criterias.keySet().iterator();
//
//            while (true) {
//                while (var5.hasNext()) {
//                    String key = (String) var5.next();
//                    List<DaoCriteria> daoCriterias = this.criterias.get(key);
//                    if (daoCriterias.size() > 1) {
//                        List<Predicate> sameConditions = Lists.newArrayList();
//                        Iterator var16 = daoCriterias.iterator();
//
//                        while (var16.hasNext()) {
//                            DaoCriteria daoCriteria = (DaoCriteria) var16.next();
//                            Predicate predicate = this.createPredicate(root, builder, daoCriteria);
//                            if (null == predicate) {
//                                throw new IllegalArgumentException("查询条件生成错误！");
//                            }
//
//                            sameConditions.add(predicate);
//                        }
//
//                        Predicate[] predicates = new Predicate[sameConditions.size()];
//                        conditions.add(builder.or((Predicate[]) sameConditions.toArray(predicates)));
//                    } else {
//                        Iterator var8 = daoCriterias.iterator();
//
//                        while (var8.hasNext()) {
//                            DaoCriteria daoCriteria = (DaoCriteria) var8.next();
//                            Predicate predicate = this.createPredicate(root, builder, daoCriteria);
//                            if (null != predicate) {
//                                conditions.add(predicate);
//                            }
//                        }
//                    }
//                }
//                Predicate[] predicates = new Predicate[conditions.size()];
//                query.where(builder.and((Predicate[]) conditions.toArray(predicates)));
//                List<Order> orders = Lists.newArrayList();
//                this.orderbys.keySet().forEach((keyx) -> {
//                    if (keyx.toLowerCase().equals("asc") && !(this.orderbys.get(keyx)).isEmpty()) {
//                        (this.orderbys.get(keyx)).forEach(propertyName -> orders.add(builder.asc(root.get(propertyName))));
//                    } else if (keyx.toLowerCase().equals("desc") && !(this.orderbys.get(keyx)).isEmpty()) {
//                        (this.orderbys.get(keyx)).forEach((propertyName) -> orders.add(builder.desc(root.get(propertyName))));
//                    }
//                });
//                query.orderBy(orders);
//                return query.getRestriction();
//            }
//        }
//    }
//
//    private Map<String, List<DaoCriteria>> classify(List<DaoCriteria> criteraList) {
//        Map<String, List<DaoCriteria>> criteraType = Maps.newHashMap();
//        this.orderbys = Maps.newHashMap();
//        this.orderbys.put("asc", Lists.newArrayList());
//        this.orderbys.put("desc", Lists.newArrayList());
//        if (criteraList != null && criteraList.size() > 0) {
//            Iterator var3 = criteraList.iterator();
//            while (var3.hasNext()) {
//                DaoCriteria daoCriteria = (DaoCriteria) var3.next();
//                if (daoCriteria.getOperator().equals(QueryOperatorEnum.ORDER_BY.getName())) {
//                    (this.orderbys.get(daoCriteria.getValue().toString().toLowerCase())).add(daoCriteria.getPropertyName());
//                } else {
//                    List<DaoCriteria> temp = criteraType.get(daoCriteria.getPropertyName());
//                    if (temp == null) {
//                        temp = Lists.newArrayList();
//                        criteraType.put(daoCriteria.getPropertyName(), temp);
//                    }
//                    temp.add(daoCriteria);
//                }
//            }
//        }
//        return criteraType;
//    }
//
//    private Predicate createPredicate(Root<T> root, CriteriaBuilder builder, DaoCriteria daoCriteria) {
//        String name = daoCriteria.getPropertyName();
//        Object value = daoCriteria.getValue();
//        String operator = daoCriteria.getOperator();
//        if (name.equals("orgCode")) {
//            return builder.like(root.get(name).as(String.class), value + "%");
//        }
//        if (operator.equals(QueryOperatorEnum.EQUAL.getName())) {
//            return builder.equal(root.get(name).as(String.class), value);
//        } else if (operator.equals(QueryOperatorEnum.LIKE.getName())) {
//            return builder.like(root.get(name).as(String.class), value.toString());
//        } else if (operator.equals(QueryOperatorEnum.NOT_IN.getName())) {
//            return builder.not(new InPredicate((CriteriaBuilderImpl) builder, root.get(name).as(String.class), new Object[]{value}));
//        } else if (operator.equals(QueryOperatorEnum.BIGGER.getName())) {
//            return builder.greaterThan(root.get(name).as(String.class), value.toString());
//        } else if (operator.equals(QueryOperatorEnum.BIGGER_EQUAL.getName())) {
//            return builder.greaterThanOrEqualTo(root.get(name).as(String.class), value.toString());
//        } else if (operator.equals(QueryOperatorEnum.LESS.getName())) {
//            return builder.lessThan(root.get(name).as(String.class), value.toString());
//        } else if (operator.equals(QueryOperatorEnum.LESS_EQUAL.getName())) {
//            return builder.lessThanOrEqualTo(root.get(name).as(String.class), value.toString());
//        } else if (operator.equals(QueryOperatorEnum.NOT_EQUAL.getName())) {
//            return builder.notEqual(root.get(name).as(String.class), value);
//        } else {
//            return operator.equals(QueryOperatorEnum.IN.getName()) ? builder.and(new Predicate[]{new InPredicate((CriteriaBuilderImpl) builder, root.get(name).as(String.class), new Object[]{value})}) : null;
//        }
//    }
//}
