package com.yeejoin.amos.iot.business.dao.repository;

import java.util.List;

import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.yeejoin.amos.iot.business.entity.Alarm;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 告警dao
 * 
 * @author as-youjun
 *
 */
@Repository("alarmDao")
public interface IAlarmDao extends BaseDao<Alarm, Long> {
	@Modifying
	@Transactional
	@Query("UPDATE Alarm SET is_delete = 1 WHERE id = ?1")
	void delAlarmById(Long id);
	
	@Modifying(clearAutomatically = true)
	@Transactional
	@Query(value="UPDATE t_alarm SET is_delete = 1 WHERE c_eqp_id = ?1",nativeQuery = true)
	int delAlarmByEqpId(Long id);

	@Query("from Alarm WHERE c_eqp_id = ?1")
	List<Alarm> fetchAlarmsByRqpId(Long id);
}
