package com.yeejoin.amos.iot.business.dao.repository;

import java.util.List;

import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.yeejoin.amos.iot.business.entity.Capability;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 能力dao
 * 
 * @author as-youjun
 *
 */
@Repository("capabilityDao")
public interface ICapabilityDao extends BaseDao<Capability, Long>
{
	@Modifying
	@Transactional
	@Query("UPDATE Capability SET is_delete = 1 WHERE id = ?1")
	void delCapabilityById(Long id);
	@Query(value = "SELECT ca FROM Capability ca WHERE ca.eqpTmpl.id = ?1 ")
	List<Capability> findByEqpTmplId(Long id);
}
