package com.yeejoin.amos.iot.business.dao.repository;

import java.util.List;

import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import com.yeejoin.amos.iot.business.entity.CapabilityAttribute;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 
 * <pre>
 * 能力属性
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: ICapabilityPropertyDao.java, v 0.1 2018年1月30日 上午11:29:07 as-chenjiajun Exp $
 */
public interface ICapabilityPropertyDao extends BaseDao<CapabilityAttribute, Long>
{
	@Modifying
	@Transactional
	@Query("UPDATE CapabilityAttribute SET is_delete = 1 WHERE id = ?1")
	void delCapabilityAttributeById(Long id);
	@Query(value = "SELECT ca FROM CapabilityAttribute ca WHERE ca.capability.id = ?1 ")
	List<CapabilityAttribute> findByCapabilityId(Long cpId);
	
	@Modifying
	@Transactional
	@Query(value="SELECT * FROM t_cpbl_attr WHERE id IN ?1", nativeQuery = true)
	List<CapabilityAttribute> getInfoByIds(Long... ids);
	
	@Query(value = "SELECT id FROM CapabilityAttribute ca WHERE ca.capability.id = ?1 ")
	List<Long> findIdByCapabilityId(Long cpId);
}
