package com.yeejoin.amos.iot.business.dao.repository;

import java.util.List;

import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import com.yeejoin.amos.iot.business.entity.DroolsRule;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 
 * <pre>
 * drools规则dao
 * </pre>
 *
 * @author as-guowubin
 * @version $Id: IDroolsRuleDao.java, v 0.1 2018年4月20日 下午4:22:05 as-guowubin Exp $
 */
public interface IDroolsRuleDao extends BaseDao<DroolsRule, String>
{
	/**
	 * 
	 * <pre>
	 * 根据组id查询已启用的drools规则
	 * </pre>
	 *
	 * @param groupId
	 * @param isUser
	 * @return
	 */
	List<DroolsRule> findByGroupIdAndIsUser(String groupId, Boolean isUser);
	/**
	 * 
	 * <pre>
	 * 根据s所属规则id查询drools规则
	 * </pre>
	 *
	 * @param ruleId
	 * @return
	 */
	List<DroolsRule> findByRuleId(String ruleId);
	
	@Modifying
	@Transactional
	@Query("UPDATE DroolsRule SET is_delete = 1 WHERE id = ?1")
	void delDroolsRuleById(String id);
}
