package com.yeejoin.amos.iot.business.dao.repository;

import java.util.List;

import org.springframework.data.jpa.repository.Query;

import com.yeejoin.amos.iot.business.entity.EquipmentCapability;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;
/**
 * 
 * <pre>
 * 设备与能力关联关系dao
 * </pre>
 *
 * @author as-guowubin
 * @version $Id: IEqpCpblDao.java, v 0.1 2018年6月9日 上午10:51:25 as-guowubin Exp $
 */
public interface IEqpCpblDao extends BaseDao<EquipmentCapability, Long>
{
	/**
	 * 
	 * <pre>
	 * 根据eqpId查询
	 * </pre>
	 *
	 * @param eqpId
	 * @return
	 */
	List<EquipmentCapability> findByEqpId(Long eqpId);
	/**
	 * 
	 * <pre>
	 * 删除设备和能力关联关系
	 * </pre>
	 *
	 * @param eqpId
	 */
	@Query("DELETE FROM EquipmentCapability WHERE eqpId = ?1")
	void delByEqpId(Long eqpId);
	
	/**
	 * 
	 * <pre>
	 * 根据cpblId查询
	 * </pre>
	 *
	 * @param cpblId
	 * @return
	 */
	@Query("FROM EquipmentCapability WHERE eqpId = ?1 and cpblId = ?2")
	List<EquipmentCapability> findByEpbIdAndCpblId(Long eqpId,Long cpblId);
}
