package com.yeejoin.amos.iot.business.dao.repository;

import java.util.List;

import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import com.yeejoin.amos.iot.business.entity.EqpCpblProperty;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 
 * <pre>
 * 设备能力属性上下限dao
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: IEqpCpblPropertyDao.java, v 0.1 2018年7月12日 上午9:29:57 as-chenjiajun Exp $
 */
public interface IEqpCpblPropertyDao extends BaseDao<EqpCpblProperty, Long>
{

	@Modifying
	@Transactional
	@Query("DELETE FROM EqpCpblProperty WHERE eqpId = ?1")
	void deleteByEqpId(Long eqpId);

	@Query("FROM EqpCpblProperty WHERE eqpId = ?1")
	List<EqpCpblProperty> findInfoByEqpId(Long eqpId);
	/**
	 * 
	 * <pre>
	 * 查询设备及能力查询门限配置信息
	 * </pre>
	 *
	 * @param eqpId
	 * @param cpblId
	 * @return
	 */
	List<EqpCpblProperty> findByEqpIdAndCpblId(Long eqpId, Long cpblId);
}
