package com.yeejoin.amos.iot.business.dao.repository;

import java.util.List;

import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import com.yeejoin.amos.iot.business.entity.EqpTmplInterface;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;
/**
 * 
 * <pre>
 * 设备接口
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: IEqpTmplInterfaceDao.java, v 0.1 2018年1月30日 上午10:53:30 as-chenjiajun Exp $
 */
public interface IEqpTmplInterfaceDao extends BaseDao<EqpTmplInterface, Long>
{
	@Modifying
	@Transactional
	@Query("UPDATE EqpTmplInterface SET is_delete = 1 WHERE id = ?1")
	void delEqpTmplInterfaceById(Long id);

	@Query("from EqpTmplInterface WHERE intfc_id = ?1")
	List<EqpTmplInterface> getDeviceInterfaceByIntfcId(Long id);
}
