package com.yeejoin.amos.iot.business.dao.repository;

import java.util.List;

import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import com.yeejoin.amos.iot.business.entity.EqpTmplAttribute;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;
/**
 * 
 * <pre>
 * 设备属性
 * </pre>
 *
 * @author as-lixiangyang
 * @version $Id: IEqpTmplPropertyDao.java, v 0.1 2018年1月30日 下午8:13:07 as-lixiangyang Exp $
 */
public interface IEqpTmplPropertyDao extends BaseDao<EqpTmplAttribute, Long>
{
	@Modifying
	@Transactional
	@Query("UPDATE EqpTmplAttribute SET is_delete = 1 WHERE id = ?1")
	void delEqpTmplAttributeById(Long id);
	
	@Transactional
	@Query("select name, valueStr from EqpTmplAttribute where  name = ?1 and valueStr = ?2")
	public List<EqpTmplAttribute> getAttributesByNameAndValueStr(String name, String val);

}
