package com.yeejoin.amos.iot.business.dao.repository;

import java.util.List;

import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.yeejoin.amos.iot.business.entity.EquipmentTemplate;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 设备模板dao
 * 
 * @author as-youjun
 *
 */
@Repository("equipmentTemplateDao")
public interface IEquipmentTemplateDao extends BaseDao<EquipmentTemplate, Long> {

	@Query("Select id from EquipmentTemplate where type =?1")
	List<Long> findIdByType(Integer type);
	
	@Query("Select id from EquipmentTemplate where industryId =?1")
	List<Long> findIdByIndustryId(Long industryId);
	
	@Modifying
	@Transactional
	@Query("UPDATE EquipmentTemplate SET is_delete = 1 WHERE id = ?1")
	void delEquipmentTemplateById(Long id);
}
