package com.yeejoin.amos.iot.business.dao.repository;

import com.yeejoin.amos.iot.business.entity.FrameProtocol;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;
import org.springframework.stereotype.Repository;

/**
 * 报文关键字与解析协议关系dao
 *
 * @author as-youjun
 */
@Repository("frameProtocolDao")
public interface IFrameProtocolDao extends BaseDao<FrameProtocol, Long> {

    /**
     * 查询帧类型对应的FrameProtocol
     *
     * @param frameType
     * @return
     */
    FrameProtocol findByFrameType(int frameType);

    /**
     * 根据数据帧头类型和common查询对应的FrameProtocol
     * @param frameType
     * @param command
     * @return
     */
    FrameProtocol findByFrameTypeAndCommand(int frameType, String command);
}
