package com.yeejoin.amos.iot.business.dao.repository;

import java.util.List;

import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.yeejoin.amos.iot.business.entity.IntfcAttribute;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 
 * <pre>
 * 接口属性数据DAO接口
 * </pre>
 *
 * @author as-shibaobao
 * @version $Id: IIntfcAttributeDao.java, v 0.1 2018年1月26日 下午1:18:23 as-shibaobao Exp $
 */
@Repository("intfcAttributeDao")
public interface IIntfcAttributeDao extends BaseDao<IntfcAttribute, Long>
{
	/**
	 * 
	 * <pre>
	 * 根据接口ID查询接口属性
	 * </pre>
	 *
	 * @param ids
	 * @return
	 */
	List<IntfcAttribute> findAllByIntfcIdIn(List<Long> ids);
	
	@Modifying
	@Transactional
	@Query("UPDATE IntfcAttribute SET is_delete = 1 WHERE id = ?1")
	void delIntfcAttributeById(Long id);

	@Query("from IntfcAttribute WHERE intfc_id = ?1")
	List<IntfcAttribute> getPropertysById(Long id);

}
