package com.yeejoin.amos.iot.business.dao.repository;

import java.util.List;

import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.yeejoin.amos.iot.business.entity.LinkVo;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;


/**
 * 
 * <pre>
 * 界面视图线路DAO
 * </pre>
 *
 * @author AS-guowubin
 * @version $Id: ILinkVoDao.java, v 0.1 2018年4月10日 下午3:12:57 AS-guowubin Exp $
 */
@Repository
public interface ILinkVoDao extends BaseDao<LinkVo, String> {
	
	List<LinkVo> findBySourceId(String sourceId);

	List<LinkVo> findByRuleId(String id);
	
	@Modifying
	@Transactional
	@Query("UPDATE LinkVo SET is_delete = 1 WHERE id = ?1")
	void delLinkVoById(String id);
}
