package com.yeejoin.amos.iot.business.dao.repository;

import java.util.List;

import com.yeejoin.amos.iot.business.entity.mybatis.MetricDataBo;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.yeejoin.amos.iot.business.entity.MetricData;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 指标数据dao
 * 
 * @author as-youjun
 *
 */
@Repository("metricDataDao")
public interface IMetricDataDao extends BaseDao<MetricData, Long> {
	
	@Modifying
	@Transactional
	@Query("UPDATE MetricData SET is_delete = 1 WHERE id = ?1")
	void delMetricDataById(Long id);
	
	@Query(value = "SELECT * FROM t_metric_data WHERE eqp_id = ?1 ", nativeQuery = true)
	List<MetricData> findByEqpId(Long eqpId);
	
	@Query(value = "SELECT * FROM t_metric_data WHERE eqp_id = ?1 order by exe_time DESC limit 1", nativeQuery = true)
	MetricData findLastDataByEqpId(Long eqpId);
	
	@Query(value = "SELECT * FROM t_metric_data WHERE eqp_id = ?1 and cpbl_id = ?2 order by exe_time DESC limit 1", nativeQuery = true)
	MetricData findLastDataByEqpIdAndCapId(Long eqpId,Long cpblId);

}
