package com.yeejoin.amos.iot.business.dao.repository;

import java.util.List;

import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import com.yeejoin.amos.iot.business.entity.Node;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 
 * <pre>
 * 节点dao
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: INodeDao.java, v 0.1 2018年3月8日 下午1:43:57 as-chenjiajun Exp $
 */
public interface INodeDao extends BaseDao<Node, Long>
{
	@Modifying
	@Transactional
	@Query("UPDATE Node SET is_delete = 1 WHERE id = ?1")
	void delNodeById(Long id);
	
	@Query(value = "SELECT * FROM t_node WHERE subgraph_id = ?1 and is_delete = 0 ", nativeQuery = true)
	List<Node> findNodBysubgraphId(Long subgraphId);
	
	@Query(value = "SELECT * FROM t_node WHERE equipment_id = ?1 and is_delete = 0 ", nativeQuery = true)
	List<Node> findNodByEquipmentId(Long equipmentId);
	
}
