package com.yeejoin.amos.iot.business.dao.repository;

import java.util.List;

import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.yeejoin.amos.iot.business.entity.NodeVo;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 
 * <pre>
 * 视图节点元素dao
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: INodeVoDao.java, v 0.1 2018年4月10日 下午3:31:46 as-chenjiajun Exp $
 */
@Repository
public interface INodeVoDao extends BaseDao<NodeVo,String>
{
	/**
	 * 
	 * <pre>
	 * 使用ruleid查询
	 * </pre>
	 *
	 * @param id
	 * @return
	 */
	List<NodeVo> findByRuleId(String id);

	/**
	 * 
	 * <pre>
	 * 使用Key查询
	 * </pre>
	 *
	 * @param id
	 * @return
	 */
	List<NodeVo> findByViewKey(String id);
	
	@Modifying
	@Transactional
	@Query("UPDATE NodeVo SET is_delete = 1 WHERE id = ?1")
	void delNodeVoById(String id);
}
