package com.yeejoin.amos.iot.business.dao.repository;

import java.util.List;

import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.yeejoin.amos.iot.business.entity.PollingJob;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 定时任务dao
 * 
 * @author as-youjun
 *
 */
@Repository("pollingJobDao")
public interface IPollingJobDao extends BaseDao<PollingJob, Long> {

	/**
	 * 查询可用job
	 * 
	 * @return
	 */
	@Query("select p from PollingJob p where p.isDelete=false")
	List<PollingJob> findEnabledJob();
	
	@Modifying
	@Transactional
	@Query("UPDATE PollingJob SET is_delete = 1 WHERE id = ?1")
	void delPollingJobById(Long id);

}
