package com.yeejoin.amos.iot.business.dao.repository;

import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.yeejoin.amos.iot.business.entity.Protocol;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 协议dao
 * 
 * @author as-youjun
 *
 */
@Repository("protocolDao")
public interface IProtocolDao extends BaseDao<Protocol, Long> {

	/**
	 * 根据名称查询
	 * 
	 * @param name
	 * @return
	 */
	@Query(value = "from Protocol where name = ?1 AND isDelete = 0")
	Protocol findByName(String name);

	@Modifying
	@Transactional
	@Query("UPDATE Protocol SET is_delete = 1 WHERE id = ?1")
	void delProtocolById(Long id);
}
