package com.yeejoin.amos.iot.business.dao.repository;

import java.util.List;

import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.yeejoin.amos.iot.business.entity.RuleDataSource;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 
 * <pre>
 * 规则视图中数据源dao
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: IRuleDataSourceDao.java, v 0.1 2018年4月10日 下午3:27:50 as-chenjiajun Exp $
 */
@Repository
public interface IRuleDataSourceDao extends BaseDao<RuleDataSource,String>
{
	/**
	 * 
	 * <pre>
	 * 
	 * </pre>
	 *
	 * @param eqpId
	 * @return
	 */
	List<RuleDataSource> findAllByEqpId(Long eqpId);
	
	@Modifying
	@Transactional
	@Query("UPDATE RuleDataSource SET is_delete = 1 WHERE id = ?1")
	void delRuleDataSourceById(String id);
}
