package com.yeejoin.amos.iot.business.dao.repository;

import java.util.List;

import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import com.yeejoin.amos.iot.business.entity.RuleGroup;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 
 * <pre>
 * 规则组dao
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: IRuleGroupDao.java, v 0.1 2018年4月10日 下午3:51:41 as-chenjiajun Exp $
 */
public interface IRuleGroupDao extends BaseDao<RuleGroup, String>
{
	/**
	 * <pre>
	 * 根据是否启用查询规则组
	 * </pre>
	 *
	 * @param isUser
	 * @return
	 */
	List<RuleGroup> findAllByIsUser(boolean isUser);
	
	@Modifying
	@Transactional
	@Query("UPDATE RuleGroup SET is_delete = 1 WHERE id = ?1")
	void delRuleGroupById(String id);
}
