package com.yeejoin.amos.iot.business.dao.repository;

import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.yeejoin.amos.iot.business.entity.Subgraph;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;
/**
 * 
 * <pre>
 * 子图dao
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: ISubgraohDao.java, v 0.1 2018年3月8日 下午1:27:53 as-chenjiajun Exp $
 */
@Repository("subgraohDao")
public interface ISubgraohDao extends BaseDao<Subgraph, Long>
{
	@Modifying
	@Transactional
	@Query("UPDATE Subgraph SET is_delete = 1 WHERE id = ?1")
	void delSubgraphById(Long id);
	
	@Modifying
	@Transactional
	@Query(value="UPDATE t_subgraph SET enable_monitor = ?1 WHERE id = ?2", nativeQuery = true)
	void oneOpenOrClose(Boolean enableMonitor, Long id);
}
