/**
 * 
 */
package com.yeejoin.amos.iot.business.entity;

import java.util.Date;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.hibernate.annotations.Where;

import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonInclude.Include;
import com.yeejoin.amos.iot.rule.resource.RuleAIEntity;

/**
 * 告警
 * 
 * @author as-youjun
 *
 */
@JsonInclude(Include.NON_EMPTY) 
@Entity
@Table(name = "t_alarm")
@Where(clause="is_delete=0")//表示未删除的数据
public class Alarm extends RuleAIEntity {

	/**
	 * 
	 */
	private static final long serialVersionUID = -2202364109261157364L;


	/**
	 * 名称
	 */
	private String name;

	/**
	 * 描述
	 */
	private String descr;

	/**
	 * 告警类型：1表示设备掉线，2表示采集异常，3表示指标越界
	 */
	private Integer type;

	/***
	 * 二级分类，列如：连通性告警下的二级分类：TCP不通告警、SNMP不通告警
	 */
	private String secondaryType;

	/**
	 * 告警级别：1表示一级，2表示二级，3表示三级
	 */
	private Integer level;

	/**
	 * 告警状态：1表示未处理(产生)，2表示历史(清除)，3表示删除(逻辑删除)
	 */
	private Integer status;

	/**
	 * 产生时间
	 */
	private Date raiseTime;

	/**
	 * 更新时间
	 */
	private Date updateTime;

	/**
	 * 告警次数
	 */
	private Integer count;

	/**
	 * 清除类型：1表示用户清除，2表示系统清除
	 */
	private Integer clearType;

	/**
	 * 清除时间
	 */
	private Date clearTime;

	/**
	 * 清除用户id
	 */
	private String clearUserId;

	/**
	 * 清除信息
	 */
	private String clearInfo;

	/**
	 * 装备id
	 */
	private Long eqpId;

	/**
	 * 能力属性id
	 */
	private Long cpblAttrId;

	/**
	 * 备注
	 */
	private String remark;

	/**
	 * 活动记录
	 */
	private String record;
	
	/**
	 * 公司Id
	 */
	private String orgCode;

	/**
	 * 活动记录列表
	 */
	private List<String> recordList;

	/**
	 * 视图对象id
	 */
	private Long subgraphId;

	@Column(name = "c_name", length = 100, nullable = false)
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	@Column(name = "c_level", nullable = false)
	public Integer getLevel() {
		return level;
	}

	public void setLevel(Integer level) {
		this.level = level;
	}

	@Column(name = "c_status", nullable = false)
	public Integer getStatus() {
		return status;
	}

	public void setStatus(Integer status) {
		this.status = status;
	}

	@Column(name = "c_raise_time", nullable = false)
	public Date getRaiseTime() {
		return raiseTime;
	}

	public void setRaiseTime(Date raiseTime) {
		this.raiseTime = raiseTime;
	}

	@Column(name = "c_clear_time")
	public Date getClearTime() {
		return clearTime;
	}

	public void setClearTime(Date clearTime) {
		this.clearTime = clearTime;
	}

	@Column(name = "c_clear_user_id")
	public String getClearUserId() {
		return clearUserId;
	}

	public void setClearUserId(String clearUserId) {
		this.clearUserId = clearUserId;
	}

	@Column(name = "c_clear_info", length = 512)
	public String getClearInfo() {
		return clearInfo;
	}

	public void setClearInfo(String clearInfo) {
		this.clearInfo = clearInfo;
	}

	@Column(name = "c_eqp_id", nullable = false)
	public Long getEqpId() {
		return eqpId;
	}

	public void setEqpId(Long eqpId) {
		this.eqpId = eqpId;
	}

	@Column(name = "c_cpbl_attr_id", nullable = false)
	public Long getCpblAttrId() {
		return cpblAttrId;
	}

	public void setCpblAttrId(Long cpblAttrId) {
		this.cpblAttrId = cpblAttrId;
	}

	@Column(name = "c_update_time")
	public Date getUpdateTime() {
		return updateTime;
	}

	public void setUpdateTime(Date updateTime) {
		this.updateTime = updateTime;
	}

	/**
	 * @return the descr
	 */
	@Column(name = "c_descr", length = 512)
	public String getDescr() {
		return descr;
	}

	/**
	 * @param descr
	 *            the descr to set
	 */
	public void setDescr(String descr) {
		this.descr = descr;
	}

	/**
	 * @return the type
	 */
	@Column(name = "c_type", nullable = false)
	public Integer getType() {
		return type;
	}

	/**
	 * @param type
	 *            the type to set
	 */
	public void setType(Integer type) {
		this.type = type;
	}

	@Column(name = "c_secondary_type", length = 50)
	public String getSecondaryType() {
		return secondaryType;
	}

	public void setSecondaryType(String secondaryType) {
		this.secondaryType = secondaryType;
	}

	/**
	 * @return the count
	 */
	@Column(name = "c_count", nullable = false)
	public Integer getCount() {
		return count;
	}

	/**
	 * @param count
	 *            the count to set
	 */
	public void setCount(Integer count) {
		this.count = count;
	}

	/**
	 * @return the clearType
	 */
	@Column(name = "c_clear_type")
	public Integer getClearType() {
		return clearType;
	}

	/**
	 * @param clearType
	 *            the clearType to set
	 */
	public void setClearType(Integer clearType) {
		this.clearType = clearType;
	}

	/**
	 * @return the record
	 */
	@Column(name = "c_record", length = 1024)
	public String getRecord() {
		return record;
	}

	/**
	 * @param record
	 *            the record to set
	 */
	public void setRecord(String record) {
		this.record = record;
	}

	@Column(name = "c_remark", length = 512)
	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}

	/**
	 * @return the recordList
	 */
	@Transient
	public List<String> getRecordList() {
		return recordList;
	}
	@Column(name = "org_code")
	public String getOrgCode() {
		return orgCode;
	}

	public void setOrgCode(String orgCode) {
		this.orgCode = orgCode;
	}
	@Column(name = "subgraph_id")
	public Long getSubgraphId() {
		return subgraphId;
	}
	public void setSubgraphId(Long subgraphId) {
		this.subgraphId = subgraphId;
	}
	
}
