package com.yeejoin.amos.iot.business.entity;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.MappedSuperclass;
import javax.persistence.Transient;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.yeejoin.amos.op.core.entity.Resource;
import org.hibernate.annotations.NotFound;

/**
 * 基本实体类
 * 
 * @author as-youjun
 *
 */
@MappedSuperclass
public class BasicEntity extends Resource implements Serializable {

	private static final long serialVersionUID = -5464322936854328207L;

	/**
	 * ID
	 */
	private Long id;

	/**
	 * 是否删除
	 */
	private Boolean isDelete = new Boolean(false);

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name = "id", nullable = false, unique = true)
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	@Transient
	@JsonIgnore
	public Boolean isDelete() {
		return isDelete;
	}

	@Column(name = "is_delete")
	public Boolean getIsDelete() {
		return isDelete;
	}

	public void setIsDelete(Boolean isDelete) {
		this.isDelete = isDelete;
	}

}
