/**
 * 
 */
package com.yeejoin.amos.iot.business.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.Fetch;
import org.hibernate.annotations.FetchMode;
import org.hibernate.annotations.Where;

/**
 * @author as-youjun
 *
 */
@Entity
@Table(name = "t_cpbl_attr")
@Where(clause="is_delete=0")//表示未删除的数据
public class CapabilityAttribute extends BasicAttribute {

	/**
	 * 
	 */
	private static final long serialVersionUID = -7205563421542072410L;

	/**
	 * 告警级别：1表示紧急告警，2表示主要告警，3表示次要告警，4表示警告告警；默认2
	 */
	private Integer alarmLevel = 2;

	/**
	 * 能力
	 */
	private Capability capability;

	@Column(name = "alarm_level", nullable = false)
	public Integer getAlarmLevel() {
		return alarmLevel;
	}

	public void setAlarmLevel(Integer alarmLevel) {
		this.alarmLevel = alarmLevel;
	}

	@ManyToOne(targetEntity = Capability.class, fetch = FetchType.LAZY)
	@Fetch(FetchMode.JOIN)
	@JoinColumn(name = "cpbl_id", referencedColumnName = "id", updatable = false, insertable = true)
	public Capability getCapability() {
		return capability;
	}

	public void setCapability(Capability capability) {
		this.capability = capability;
	}

}
