package com.yeejoin.amos.iot.business.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.Fetch;
import org.hibernate.annotations.FetchMode;
import org.hibernate.annotations.Where;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;

/**
 * 
 * <pre>
 * 拓扑图连线对象
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: Connections.java, v 0.1 2018年3月8日 上午10:54:17 as-chenjiajun Exp $
 */
@Entity
@Table(name = "t_connection")
@JsonIgnoreProperties(value={"subgraph"})
@Where(clause="is_delete=0")//表示未删除的数据
public class Connection extends TimeEntity
{
	/**
	 * <pre>
	 * 
	 * </pre>
	 */
	private static final long serialVersionUID = -3133176090911250788L;
	
	/**
	 * 源节点ID
	 */
	private String sourceId;
	
	/**
	 * 目的节点ID
	 */
	private String targetId;
	
	/**
	 * 子图
	 */
	private Subgraph subgraph;

	@Column(name = "sourceId", length = 100)
	public String getSourceId()
	{
		return sourceId;
	}

	public void setSourceId(String sourceId)
	{
		this.sourceId = sourceId;
	}

	@Column(name = "targetId", length = 100)
	public String getTargetId()
	{
		return targetId;
	}

	public void setTargetId(String targetId)
	{
		this.targetId = targetId;
	}

	@ManyToOne(targetEntity = Subgraph.class, fetch = FetchType.LAZY)
	@Fetch(FetchMode.JOIN)
	@JoinColumn(name = "subgraph_id", referencedColumnName = "id", updatable = true, insertable = true)
	public Subgraph getSubgraph()
	{
		return subgraph;
	}

	public void setSubgraph(Subgraph subgraph)
	{
		this.subgraph = subgraph;
	}
}
