package com.yeejoin.amos.iot.business.entity;

import javax.persistence.Column;
import javax.persistence.DiscriminatorColumn;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.Inheritance;
import javax.persistence.Table;

import org.hibernate.annotations.Where;

/**
 * 系统数据字典
 * 
 * @author as-youjun
 *
 */
@Entity
@Inheritance
@Table(name = "t_dic")
@DiscriminatorColumn(name = "type", length = 100)
@DiscriminatorValue("DIC")
@Where(clause="is_delete=0")//表示未删除的数据
public class Dic extends TimeEntity {

	private static final long serialVersionUID = 1L;

	/**
	 * 编码
	 */
	private String code;

	/**
	 * 类型
	 */
	private String type;

	/**
	 * 名称
	 */
	private String name;

	/**
	 * 备注
	 * 
	 * @return
	 */
	private String remark;

	@Column(name = "code", length = 50, nullable = false)
	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	@Column(name = "type", length = 100, nullable = false, insertable = false, updatable = false)
	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	@Column(name = "name", length = 100, nullable = false)
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	@Column(name = "remark", length = 512)
	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}

	@Override
	public int hashCode() {
		return (this.code + this.type + "").hashCode();
	}

	public boolean equals(Object obj) {
		if (obj == null) {
			return false;
		}
		if (!(obj instanceof Dic)) {
			return false;
		}
		Dic other = (Dic) obj;
		return (other.getCode() + other.getType()).equals(this.code + this.type);
	}

	@Override
	public String toString() {
		return ("coe:" + this.code + ",name:" + this.name + ",type:" + this.type).toString();
	}

}
