/**
 * 
 */
package com.yeejoin.amos.iot.business.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;

import org.hibernate.annotations.Fetch;
import org.hibernate.annotations.FetchMode;
import org.hibernate.annotations.Where;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;

/**
 * 设备模板属性
 * 
 * @author as-youjun
 *
 */
@Entity
@Table(name = "t_eqp_tmpl_attr")
@JsonIgnoreProperties(value={"eqpTmpl"})
@Where(clause="is_delete=0")//表示未删除的数据
public class EqpTmplAttribute extends BasicAttribute {

	/**
	 * 
	 */
	private static final long serialVersionUID = -8821992957913195605L;

	/**
	 * 设备模板
	 */
	private EquipmentTemplate eqpTmpl;
	
	/**
     * 是否必填
     */
    private Boolean isRequired;

    @Column(name = "is_required", columnDefinition = "bit")
    public Boolean getIsRequired() {
		return isRequired;
	}

	public void setIsRequired(Boolean isRequired) {
		this.isRequired = isRequired;
	}

	@ManyToOne(targetEntity = EquipmentTemplate.class, fetch = FetchType.LAZY)
	@Fetch(FetchMode.JOIN)
	@JoinColumn(name = "eqp_tmpl_id", referencedColumnName = "id", updatable = true, insertable = true)
	public EquipmentTemplate getEqpTmpl() {
		return eqpTmpl;
	}

	public void setEqpTmpl(EquipmentTemplate eqpTmpl) {
		this.eqpTmpl = eqpTmpl;
	}

}
