/**
 * 
 */
package com.yeejoin.amos.iot.business.entity;

import java.util.HashMap;
import java.util.Map;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;

import net.sf.json.JSONObject;

import org.apache.commons.lang.StringUtils;
import org.hibernate.annotations.Where;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;

/**
 * 设备
 * 
 * @author as-youjun
 *
 */
@Entity
@Table(name = "t_equipment")
@JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
// 表示未删除的数据
@Where(clause = "is_delete=0")
public class Equipment extends TimeEntity {

	/**
	 * 
	 */
	private static final long serialVersionUID = -4417043235536861838L;

	/**
	 * 名称
	 */
	private String name;

	/**
	 * 描述
	 */
	private String descr;

	/**
	 * 用户id
	 */
	private String userId;

	/**
	 * 公司id
	 */
	private String orgCode;

	/**
	 * 设备模板id
	 */
	private Long eqpTmplId;

	/**
	 * 配置参数json数据：键值对
	 */
	private String cfgParamJson;

	/**
	 * 配置参数map
	 */
	private Map<String, Object> cfgParamMap;

	/**
	 * 设备是否有报警
	 */
	private Boolean isWarning = false;
	/**
	 * 设备类型
	 */
	private String type;

	/**
	 * 设备logo
	 */
	private String logo;

	/**
	 * logo数据
	 */
	private String icon;


	private String authOrg;

	@Column(name = "name", length = 100, nullable = false)
	public String getName() {
		return name;
	}

	public void setName(String name) {
		if(name != null){
			name = name.trim();//去掉前后空格
		}
		this.name = name;
	}

	@Column(name = "descr", length = 512)
	public String getDescr() {
		return descr;
	}

	public void setDescr(String descr) {
		this.descr = descr;
	}

	@Column(name = "user_id")
	public String getUserId() {
		return userId;
	}

	public void setUserId(String userId) {
		this.userId = userId;
	}

	@Column(name = "eqp_tmpl_id", nullable = false)
	public Long getEqpTmplId() {
		return eqpTmplId;
	}

	public void setEqpTmplId(Long eqpTmplId) {
		this.eqpTmplId = eqpTmplId;
	}

	@Column(name = "org_code")
	public String getOrgCode() {
		return orgCode;
	}

	public void setOrgCode(String orgCode) {
		this.orgCode = orgCode;
	}

	@Column(name = "cfg_param_json")
	public String getCfgParamJson() {
		return cfgParamJson;
	}

	public void setCfgParamJson(String cfgParamJson) {
		this.cfgParamJson = cfgParamJson;
	}

	@Transient
	@SuppressWarnings("unchecked")
	public Map<String, Object> getCfgParamMap() {
		// cfgParamJson转换成Map
		if (this.cfgParamMap == null
				&& StringUtils.isNotEmpty(this.cfgParamJson)) {
			Map<String,Object> classMap = new HashMap<String,Object>();
			classMap.put("quotaSelected",Map.class);
			cfgParamMap = (Map<String, Object>) JSONObject.toBean(
					JSONObject.fromObject(this.cfgParamJson), Map.class,classMap);
		}
		return cfgParamMap;
	}

	@Column(name = "is_warning", nullable = false)
	public Boolean getIsWarning() {
		return isWarning;
	}

	public void setIsWarning(Boolean isWarning) {
		this.isWarning = isWarning;
	}

	@Column(name = "logo")
	public String getLogo() {
		return logo;
	}

	public void setLogo(String logo) {
		this.logo = logo;
	}

	@Column(name = "type")
	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	/**
	 * @return the icon
	 */
	@Transient
	public String getIcon() {
		return icon;
	}

	/**
	 * @param icon
	 *            the icon to set
	 */
	public void setIcon(String icon) {
		this.icon = icon;
	}

	@Column(name="auth_org")
	public String getAuthOrg() {
		return authOrg;
	}

	public void setAuthOrg(String authOrg) {
		this.authOrg = authOrg;
	}
}
