/**
 * 
 */
package com.yeejoin.amos.iot.business.entity;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;

/**
 * 
 * <pre>
 * 设备与能力关联关系
 * </pre>
 *
 * @author as-guowubin
 * @version $Id: EquipmentCapability.java, v 0.1 2018年6月8日 下午4:00:40 as-guowubin
 *          Exp $
 */
@Entity
@Table(name = "t_eqp_cpbl")
// 表示未删除的数据
public class EquipmentCapability implements Serializable {

	/**
	 * ID
	 */
	private Long id;

	/**
	 * 
	 */
	private static final long serialVersionUID = -6989889651928071549L;

	/**
	 * 设备id
	 */
	private Long eqpId;

	/**
	 * 能力id
	 */
	private Long cpblId;

	/**
	 * 监测方式：1表示监听，2表示采集
	 */
	private Integer monitorType = 1;

	/**
	 * 监测周期(秒)
	 */
	private Integer monitorPeriod = 30;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Column(name = "id", nullable = false, unique = true)
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}
	
	@Column(name = "eqp_id", nullable = false)
	public Long getEqpId() {
		return eqpId;
	}

	public void setEqpId(Long eqpId) {
		this.eqpId = eqpId;
	}

	@Column(name = "cpbl_id", nullable = false)
	public Long getCpblId() {
		return cpblId;
	}

	public void setCpblId(Long cpblId) {
		this.cpblId = cpblId;
	}

	@Column(name = "monitor_type")
	public Integer getMonitorType() {
		return monitorType;
	}

	public void setMonitorType(Integer monitorType) {
		this.monitorType = monitorType;
	}

	@Column(name = "monitor_period")
	public Integer getMonitorPeriod() {
		return monitorPeriod;
	}

	public void setMonitorPeriod(Integer monitorPeriod) {
		this.monitorPeriod = monitorPeriod;
	}

}
