/**
 * 
 */
package com.yeejoin.amos.iot.business.entity;

import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.hibernate.annotations.Fetch;
import org.hibernate.annotations.FetchMode;
import org.hibernate.annotations.Where;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.yeejoin.amos.iot.business.dic.CommunityProtocol;

/**
 * 接口
 * 
 * @author as-youjun
 *
 */
@Entity
@Table(name = "t_interface")
@Where(clause="is_delete=0")//表示未删除的数据
@JsonIgnoreProperties(value = { "hibernateLazyInitializer"})
public class Intfc extends TimeEntity {

	/**
	 * 
	 */
	private static final long serialVersionUID = -2664347849406442842L;

	/**
	 * 名称(英文、数字、下划线)
	 */
	private String name;

	/**
	 * 显示名称
	 */
	private String displayName;

	/**
	 * 可见性：0表示公共，1表示私有
	 */
	private Integer visibility;

	/**
	 * 备注
	 * 
	 * @return
	 */
	private String remark;

	/**
	 * 通信协议外键ID
	 */
	private Long dicIdCommMode;
	/**
	 * 通信协议/模式
	 */
	private CommunityProtocol communityProtocol;

	/**
	 * 用户id
	 */
	private String userId;

	/**
	 * 接口属性
	 */
	private List<IntfcAttribute> attributes;

	
	/**
	 * 组织机构
	 */
	private String orgCode;
	/**
	 * 设备是否启用，默认启用
	 */
	private Boolean isUser = true;


	@Column(name = "name", length = 100, nullable = false)
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	@Column(name = "display_name", length = 100, nullable = false)
	public String getDisplayName() {
		return displayName;
	}

	public void setDisplayName(String displayName) {
		this.displayName = displayName;
	}

	@Column(name = "visibility", nullable = false)
	public Integer getVisibility() {
		return visibility;
	}

	public void setVisibility(Integer visibility) {
		this.visibility = visibility;
	}

	@Column(name = "remark", length = 512)
	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}

	@Column(name = "dic_id_comm_mode")
	public Long getDicIdCommMode()
	{
		return dicIdCommMode;
	}

	public void setDicIdCommMode(Long dicIdCommMode)
	{
		this.dicIdCommMode = dicIdCommMode;
	}

	@OneToOne(targetEntity = CommunityProtocol.class, fetch = FetchType.LAZY)
	@Fetch(FetchMode.JOIN)
	@JoinColumn(name = "dic_id_comm_mode", referencedColumnName = "id", updatable = false, insertable = false)
	public CommunityProtocol getCommunityProtocol() {
		return communityProtocol;
	}

	public void setCommunityProtocol(CommunityProtocol communityProtocol) {
		this.communityProtocol = communityProtocol;
	}

	@Column(name = "user_id")
	public String getUserId() {
		return userId;
	}

	public void setUserId(String userId) {
		this.userId = userId;
	}

	@OneToMany(mappedBy = "intfc", fetch = FetchType.LAZY, cascade = { CascadeType.REMOVE })
	@Where(clause="is_delete=0")//表示未删除的数据
	public List<IntfcAttribute> getAttributes() {
		return attributes;
	}

	public void setAttributes(List<IntfcAttribute> attributes) {
		this.attributes = attributes;
	}
	
	
	@Column(name = "org_code", length = 100, nullable = false)
	public String getOrgCode() {
		return orgCode;
	}

	public void setOrgCode(String orgCode) {
		this.orgCode = orgCode;
	}

	@Transient
	public Boolean getIsUser()
	{
		return isUser;
	}

	public void setIsUser(Boolean isUser)
	{
		this.isUser = isUser;
	}

	@Override
	public String toString() {
		return "Intfc{" +
				"name='" + name + '\'' +
				", displayName='" + displayName + '\'' +
				", visibility=" + visibility +
				", remark='" + remark + '\'' +
				", dicIdCommMode=" + dicIdCommMode +
				", communityProtocol=" + communityProtocol +
				", userId='" + userId + '\'' +
				", attributes=" + attributes +
				", orgCode='" + orgCode + '\'' +
				", isUser=" + isUser +
				'}';
	}
}
