/**
 *
 */
package com.yeejoin.amos.iot.business.entity;

import com.fasterxml.jackson.annotation.JsonBackReference;
import org.apache.log4j.Logger;
import org.hibernate.annotations.Fetch;
import org.hibernate.annotations.FetchMode;
import org.hibernate.annotations.Where;

import javax.persistence.*;
import java.io.Serializable;

/**
 * 接口属性
 *
 * @author as-youjun
 */
@Entity
@Table(name = "t_intfc_attr")
@Where(clause = "is_delete=0")//表示未删除的数据
public class IntfcAttribute extends BasicAttribute implements Serializable, Cloneable {

    /**
     *
     */
    private static final long serialVersionUID = 6818794079648782928L;

    /**
     * 日志记录器
     */
    private static final Logger logger = Logger
            .getLogger(IntfcAttribute.class);

    /**
     * 接口
     */
    private Intfc intfc;
    
    /**
     * 是否必填
     */
    private Boolean isRequired;

    @Column(name = "is_required", columnDefinition = "bit")
    public Boolean getIsRequired() {
		return isRequired;
	}

	public void setIsRequired(Boolean isRequired) {
		this.isRequired = isRequired;
	}

	/**
     * 接口外键ID
     */
    private Long intfcId;

    @ManyToOne(targetEntity = Intfc.class, fetch = FetchType.LAZY)
    @Fetch(FetchMode.JOIN)
    @JoinColumn(name = "intfc_id", referencedColumnName = "id", updatable = false, insertable = false)
    public Intfc getIntfc() {
        return intfc;
    }

    @JsonBackReference
    public void setIntfc(Intfc intfc) {
        this.intfc = intfc;
    }

    @Column(name = "intfc_id")
    public Long getIntfcId() {
        return intfcId;
    }

    public void setIntfcId(Long intfcId) {
        this.intfcId = intfcId;
    }

    @Override
    public Object clone() {
        IntfcAttribute newObj = null;
        try {
            newObj = (IntfcAttribute) super.clone();
        } catch (CloneNotSupportedException e) {
            logger.error(e);
        }
        return newObj;
    }

}
