/**
 * 
 */
package com.yeejoin.amos.iot.business.entity;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

import org.hibernate.annotations.Where;

/**
 * 指标数据
 * 
 * @author as-youjun
 *
 */
@Entity
@Table(name = "t_metric_data")
@Where(clause = "is_delete=0")
// 表示未删除的数据
public class MetricData extends BasicEntity {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1114651191968769224L;

	/**
	 * 入库时间
	 */
	private Date exeTime;

	/**
	 * 周期
	 */
	private Integer period;

	/**
	 * 装备id
	 */
	private Long eqpId;

	/**
	 *创建时间
	 */
	private Date createTime;
	@Column(name = "create_time")
	public Date getCreateTime() {
		return createTime;
	}

	public void setCreateTime(Date createTime) {
		this.createTime = createTime;
	}
	/**
	 * 能力id
	 */
	private Long cpblId;

	/**
	 * 设备模板id
	 */
	private Long eqpTmplId;

	/**
	 * 指标数据唯一标识；例如，"类名" 唯一标识指标(集合)数据
	 */
	private String metricKey;

	/**
	 * json格式数据:需要时，根据metricKey自行解析
	 */
	private String metricJson;

	/**
	 * 视图对象id
	 */
	private Long subgraphId;

	@Column(name = "exe_time", nullable = false)
	public Date getExeTime() {
		return exeTime;
	}

	public void setExeTime(Date exeTime) {
		this.exeTime = exeTime;
	}

	/**
	 * @return the period
	 */
	@Column(name = "period", nullable = false)
	public Integer getPeriod() {
		return period;
	}

	/**
	 * @param period
	 *            the period to set
	 */
	public void setPeriod(Integer period) {
		this.period = period;
	}

	@Column(name = "eqp_id", nullable = false)
	public Long getEqpId() {
		return eqpId;
	}

	public void setEqpId(Long eqpId) {
		this.eqpId = eqpId;
	}

	@Column(name = "cpbl_id", nullable = false)
	public Long getCpblId() {
		return cpblId;
	}

	public void setCpblId(Long cpblId) {
		this.cpblId = cpblId;
	}

	@Column(name = "eqp_tmpl_id", nullable = false)
	public Long getEqpTmplId() {
		return eqpTmplId;
	}

	public void setEqpTmplId(Long eqpTmplId) {
		this.eqpTmplId = eqpTmplId;
	}

	/**
	 * @return the metricKey
	 */
	@Column(name = "metric_key", nullable = false)
	public String getMetricKey() {
		return metricKey;
	}

	/**
	 * @param metricKey
	 *            the metricKey to set
	 */
	public void setMetricKey(String metricKey) {
		this.metricKey = metricKey;
	}

	/**
	 * @return the metricJson
	 */
	@Column(name = "metric_json")
	public String getMetricJson() {
		return metricJson;
	}

	/**
	 * @param metricJson
	 *            the metricJson to set
	 */
	public void setMetricJson(String metricJson) {
		this.metricJson = metricJson;
	}

	@Column(name = "subgraph_id")
	public Long getSubgraphId() {
		return subgraphId;
	}

	public void setSubgraphId(Long subgraphId) {
		this.subgraphId = subgraphId;
	}

	@Override
	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("exeTime:").append(exeTime).append(",period:").append(period)
				.append(",eqpId:").append(eqpId).append(",cpblId:")
				.append(cpblId).append(",eqpTmplId:").append(eqpTmplId)
				.append(",metricKey:").append(metricKey).append(",metricJson:")
				.append(metricJson);
		return sb.toString();
	}

}
