/**
 * 
 */
package com.yeejoin.amos.iot.business.entity;

import java.util.List;

import com.yeejoin.amos.iot.rule.resource.RuleAIEntity;
import org.springframework.util.ObjectUtils;

/**
 * 
 * <pre>
 * 指标数据规则对象
 * </pre>
 *
 * @author as-guowubin
 * @version $Id: MetricDataRo.java, v 0.1 2018年5月4日 下午5:38:40 as-guowubin Exp $
 */
public class MetricDataRo extends RuleAIEntity {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1114651191968769224L;
	
	public MetricDataRo(List<MetricData> metricDatas)
	{
		this.metricDatas = metricDatas;
	}
	
	/**
	 * 指标数据集合
	 */
	private List<MetricData> metricDatas;
	/**
	 * 装备id
	 */
	private Long eqpId;
	
	private String eqpName;
	  
   /**
    * 视图对象id
    */
	private Long subgraphId;
	/**
	 * 公司code
	 */
	private String orgCode;

	private Long cpblId;

	private Object eqpConfigMap;
	
	private String[] authOrg;
	
	
	public Object getEqpConfigMap() {
		return eqpConfigMap;
	}

	public void setEqpConfigMap(Object eqpConfigMap) {
		this.eqpConfigMap = eqpConfigMap;
	}

	public String getEqpName() {
		return eqpName;
	}

	public void setEqpName(String eqpName) {
		this.eqpName = eqpName;
	}

	public List<MetricData> getMetricDatas()
	{
		return metricDatas;
	}

	public void setMetricDatas(List<MetricData> metricDatas)
	{
		this.metricDatas = metricDatas;
	}

	public Long getEqpId()
	{
		return eqpId;
	}

	public void setEqpId(Long eqpId)
	{
		this.eqpId = eqpId;
	}

	public Long getSubgraphId()
	{
		return subgraphId;
	}

	public void setSubgraphId(Long subgraphId)
	{
		this.subgraphId = subgraphId;
	}

	public String getOrgCode()
	{
		return orgCode;
	}

	public void setOrgCode(String orgCode)
	{
		this.orgCode = orgCode;
	}

	public Long getCpblId() {
		return cpblId;
	}

	public void setCpblId(Long cpblId) {
		this.cpblId = cpblId;
	}

	public String[] getAuthOrg() {
		return authOrg;
	}

	public void setAuthOrg(String authOrg) {
		if (!ObjectUtils.isEmpty(authOrg)) {
			String str = authOrg.replace("[", "");
			str = str.replace("]", "");
			str = str.replace(" ", "");
			this.authOrg = str.split(",");
			return;
		}
		this.authOrg = null;
	}

	@Override
	public String toString() {
		return "MetricDataRo{" +
				"metricDatas=" + metricDatas +
				", eqpId=" + eqpId +
				", subgraphId=" + subgraphId +
				", orgCode='" + orgCode + '\'' +
				", cpblId=" + cpblId +
				'}';
	}
}
