package com.yeejoin.amos.iot.business.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.hibernate.annotations.Fetch;
import org.hibernate.annotations.FetchMode;
import org.hibernate.annotations.Where;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;

/**
 * 
 * <pre>
 * 拓扑图节点对象
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: Node.java, v 0.1 2018年3月8日 上午11:02:39 as-chenjiajun Exp $
 */
@Entity
@Table(name = "t_node")
@JsonIgnoreProperties(value={"subgraph"})
@Where(clause="is_delete=0")//表示未删除的数据
public class Node extends TimeEntity
{

	/**
	 * <pre>
	 * 
	 * </pre>
	 */
	private static final long serialVersionUID = -1521295197026009618L;
	
	/**
	 * 界面node id
	 */
	private String nodeId;
	/**
	 * 配置信息
	 */
	private String config;
	
	/**
	 * 子图
	 */
	private Subgraph subgraph;
	
	/**
	 * 对应的设备ID
	 */
	private Long equipmentId;
	
	//设备参数
	private String equipmentParam;
	
	@Column(name = "nodeId", length = 100)
	public String getNodeId()
	{
		return nodeId;
	}
	public void setNodeId(String nodeId)
	{
		this.nodeId = nodeId;
	}
	
	@Column(name = "config", length = 512)
	public String getConfig()
	{
		return config;
	}
	public void setConfig(String config)
	{
		this.config = config;
	}
	
	@ManyToOne(targetEntity = Subgraph.class, fetch = FetchType.LAZY)
	@Fetch(FetchMode.JOIN)
	@JoinColumn(name = "subgraph_id", referencedColumnName = "id", updatable = true, insertable = true)
	public Subgraph getSubgraph()
	{
		return subgraph;
	}
	public void setSubgraph(Subgraph subgraph)
	{
		this.subgraph = subgraph;
	}
	
	@Column(name = "equipment_id")
	public Long getEquipmentId()
	{
		return equipmentId;
	}
	
	public void setEquipmentId(Long equipmentId)
	{
		this.equipmentId = equipmentId;
	}
	
	@Transient
	public String getEquipmentParam()
	{
		return equipmentParam;
	}
	public void setEquipmentParam(String equipmentParam)
	{
		this.equipmentParam = equipmentParam;
	}
}
