/**
 * 
 */
package com.yeejoin.amos.iot.business.entity;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.OneToOne;
import javax.persistence.Table;

import org.hibernate.annotations.Fetch;
import org.hibernate.annotations.FetchMode;
import org.hibernate.annotations.Where;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.yeejoin.amos.iot.business.dic.ScriptLang;

/**
 * 协议
 * 
 * @author as-youjun
 *
 */
@JsonIgnoreProperties(value = { "hibernateLazyInitializer", "handler" })
@Entity
@Table(name = "t_protocol")
@Where(clause="is_delete=0")//表示未删除的数据
public class Protocol extends TimeEntity implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = 8527042435843794622L;

	/**
	 * 名称(英文、数字、下划线)
	 */
	private String name;

	/**
	 * 显示名称
	 */
	private String displayName;

	/**
	 * 可见性：0表示公共，1表示私有
	 */
	private Integer visibility = 1;

	/**
	 * 版本
	 * 
	 * @return
	 */
	private String version;

	/**
	 * 协议解析脚步语言外键ID
	 */
	private Long dicIdScriptLang;

	/**
	 * 协议解析脚本语言
	 */
	private ScriptLang scriptLang;

	/**
	 * 协议解析代码
	 */
	private String scriptCode;

	/**
	 * 用户id
	 */
	private String userId;

	/**
	 * 描述
	 */
	private String descr;
	
	/**
	 * 公司id
	 */
	private String orgCode;

	@Column(name = "name", length = 100, nullable = false)
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	@Column(name = "display_name", length = 100, nullable = false)
	public String getDisplayName() {
		return displayName;
	}

	public void setDisplayName(String displayName) {
		this.displayName = displayName;
	}

	@Column(name = "visibility", nullable = false)
	public Integer getVisibility() {
		return visibility;
	}

	public void setVisibility(Integer visibility) {
		this.visibility = visibility;
	}

	@Column(name = "version", length = 50)
	public String getVersion() {
		return version;
	}

	public void setVersion(String version) {
		this.version = version;
	}

	@Column(name = "dic_id_script_lang")
	public Long getDicIdScriptLang() {
		return dicIdScriptLang;
	}

	public void setDicIdScriptLang(Long dicIdScriptLang) {
		this.dicIdScriptLang = dicIdScriptLang;
	}

	@OneToOne(targetEntity = ScriptLang.class, fetch = FetchType.LAZY)
	@Fetch(FetchMode.JOIN)
	@JoinColumn(name = "dic_id_script_lang", referencedColumnName = "id", updatable = false, insertable = false)
	public ScriptLang getScriptLang() {
		return scriptLang;
	}

	public void setScriptLang(ScriptLang scriptLang) {
		this.scriptLang = scriptLang;
	}

	@Column(name = "script_code")
	public String getScriptCode() {
		return scriptCode;
	}

	public void setScriptCode(String scriptCode) {
		this.scriptCode = scriptCode;
	}

	@Column(name = "user_id")
	public String getUserId() {
		return userId;
	}

	public void setUserId(String userId) {
		this.userId = userId;
	}

	/**
	 * @return the descr
	 */
	@Column(name = "descr")
	public String getDescr() {
		return descr;
	}

	/**
	 * @param descr
	 *            the descr to set
	 */
	public void setDescr(String descr) {
		this.descr = descr;
	}
	
	@Column(name = "org_code")
	public String getOrgCode() {
		return orgCode;
	}

	public void setOrgCode(String orgCode) {
		this.orgCode = orgCode;
	}

}
