package com.yeejoin.amos.iot.business.entity;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Where;
import org.hibernate.validator.constraints.NotBlank;
import org.hibernate.validator.constraints.NotEmpty;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.yeejoin.amos.op.core.entity.BusinessEntity;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
/**
 * 
 * <pre>
 * 规则
 * </pre>
 *
 * @author AS-guowubin
 * @version $Id: Rule.java, v 0.1 2018年4月10日 下午1:27:22 AS-guowubin Exp $
 */
@Entity
@ApiModel
@Table(name = "t_rm_rule")
@Where(clause="is_delete=0")//表示未删除的数据
@JsonIgnoreProperties(value = { "hibernateLazyInitializer"})
public class Rule extends BusinessEntity implements Serializable
{

	private static final long serialVersionUID = -4230791185458128702L;

	@Id
    @GeneratedValue(generator = "uuid")
    @GenericGenerator(name = "uuid", strategy = "uuid2")
	@Column(name = "id", nullable = false, length = 36)
	private String id;
	
	@ApiModelProperty(notes = "规则名")
	@NotBlank(message = "规则名不能为空！")
	@NotEmpty(message = "规则名不能为空！")
	private String name;
	
	@ApiModelProperty(notes = "是否启用")
	@Column(name = "is_user")
	private Boolean isUser = false;
	
	@ApiModelProperty(notes = "状态")
	private String status = "1";//1：未发布 2:已发布
	
	@ApiModelProperty(notes = "描述")
	private String descr;
	/**
	 * 公司Id
	 */
	private String orgCode;

	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Boolean getIsUser()
	{
		return isUser;
	}

	public void setIsUser(Boolean isUser)
	{
		this.isUser = isUser;
	}

	public String getStatus()
	{
		return status;
	}

	public void setStatus(String status)
	{
		this.status = status;
	}

	public String getDescr()
	{
		if (null != descr) {
			return descr.trim();
		}
		
		return null;
	}

	public void setDescr(String descr)
	{
		this.descr = descr;
	}
	
	@Column(name = "org_code")
	public String getOrgCode() {
		return orgCode;
	}

	public void setOrgCode(String orgCode) {
		this.orgCode = orgCode;
	}

	public String getId()
	{
		return id;
	}

	public void setId(String id)
	{
		this.id = id;
	}
}