package com.yeejoin.amos.iot.business.entity;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Where;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.yeejoin.amos.op.core.entity.Resource;

/**
 * 
 * <pre>
 * 规则视图中数据源信息
 * </pre>
 *
 * @author AS-guowubin
 * @version $Id: RuleDataSource.java, v 0.1 2018年4月10日 上午11:10:33 AS-guowubin Exp $
 */
@Entity
@Table(name = "t_rm_datasource")
@Where(clause="is_delete=0")//表示未删除的数据
@JsonIgnoreProperties(value = { "hibernateLazyInitializer", "handler" })
public class RuleDataSource extends Resource implements Serializable
{

	/**
	 * <pre>
	 *
	 * </pre>
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * id
	 */
	@Id
    @GeneratedValue(generator = "uuid")
    @GenericGenerator(name = "uuid", strategy = "uuid2")
	@Column(name = "id", nullable = false, length = 36)
	protected String id;
	/**
	 * 名称
	 */
	@Column(name = "name")
	private String name;
	/**
	 * 显示名
	 */
	@Column(name = "display_name")
	private String displayName;
	/**
	 * 用户类型
	 */
	@Column(name = "user_type")
	private String user_type;
	/**
	 * 子用户
	 */
	@Column(name = "sub_user")
	private String sub_user;
	/**
	 * 视图
	 */
	@Column(name = "view")
	private String view;
	/**
	 * 监测规则Id
	 */
	@Column(name = "monitor_Rule_id")
	private Long monitorRuleId;

	@Column(name = "cpbl_id")
	private long cpblId;
	
	/**
	 * 是否删除
	 */
	private Boolean isDelete = false;
	
	/**
	 * 对应的设备
	 */
	private Long eqpId;
	
	/**
	 * 对应的公司code
	 */
	private String orgCode;
	
	public String getId()
	{
		return id;
	}
	public void setId(String id)
	{
		this.id = id;
	}
	public String getName()
	{
		return name;
	}
	public void setName(String name)
	{
		this.name = name;
	}
	public String getDisplayName()
	{
		return displayName;
	}
	public void setDisplayName(String displayName)
	{
		this.displayName = displayName;
	}
	public String getUser_type()
	{
		return user_type;
	}
	public void setUser_type(String user_type)
	{
		this.user_type = user_type;
	}
	public String getSub_user()
	{
		return sub_user;
	}
	public void setSub_user(String sub_user)
	{
		this.sub_user = sub_user;
	}
	public String getView()
	{
		return view;
	}
	public void setView(String view)
	{
		this.view = view;
	}
	@Transient
	@JsonIgnore
	public Boolean isDelete() {
		return isDelete;
	}

	@Column(name = "is_delete")
	public Boolean getIsDelete() {
		return isDelete;
	}

	public void setIsDelete(Boolean isDelete) {
		this.isDelete = isDelete;
	}
	
	@Column(name = "eqp_id")
	public Long getEqpId()
	{
		return eqpId;
	}
	public void setEqpId(Long eqpId)
	{
		this.eqpId = eqpId;
	}
	@Column(name = "org_code")
	public String getOrgCode()
	{
		return orgCode;
	}
	public void setOrgCode(String orgCode)
	{
		this.orgCode = orgCode;
	}
	public Long getMonitorRuleId()
	{
		return monitorRuleId;
	}
	public void setMonitorRuleId(Long monitorRuleId)
	{
		this.monitorRuleId = monitorRuleId;
	}

	public long getCpblId() {
		return cpblId;
	}

	public void setCpblId(long cpblId) {
		this.cpblId = cpblId;
	}
}
 