package com.yeejoin.amos.iot.business.entity;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.MappedSuperclass;

import com.yeejoin.amos.op.core.entity.Resource;

/**
 * 
 * <pre>
 * 视图基本元素类
 * </pre>
 *
 * @author AS-guowubin
 * @version $Id: RuleElement.java, v 0.1 2018年4月10日 上午10:33:45 AS-guowubin Exp $
 */
@MappedSuperclass
public abstract class RuleElement extends Resource implements Serializable
{
	/**
	 * <pre>
	 * 
	 * </pre>
	 */
	private static final long serialVersionUID = 8337246439914325872L;
	/**
	 * id
	 */
	@Id
	@Column(name = "id", nullable = false, length = 36)
	protected String id;
	/**
	 * 显示名
	 */
	@Column(name = "display_name")
	private String displayName;
	/**
	 * 元素key
	 */
	@Column(name = "view_key")
	private String viewKey;
	/**
	 * 类型
	 */
	@Column(name = "type")
	private String type;
	
	/**
	 * 类型
	 */
	@Column(name = "node_type")
	private String nodeType;
	/**
	 * 父元素key
	 */
	@Column(name = "parent_key")
	private String parentKey;
	/**
	 * 父元素类型
	 */
	@Column(name = "parent_type")
	private String parentType;
	
	/**
	 * 所属规则Id
	 */
	@Column(name = "rule_id")
	private String ruleId;
	
	
	/**
	 * 是否删除
	 */
	@Column(name = "is_delete")
	private Boolean isDelete = false;
	
	public String getDisplayName()
	{
		return displayName;
	}
	public void setDisplayName(String displayName)
	{
		this.displayName = displayName;
	}
	public String getViewKey()
	{
		return viewKey;
	}
	public void setViewKey(String viewKey)
	{
		this.viewKey = viewKey;
	}
	public String getType()
	{
		return type;
	}
	public void setType(String type)
	{
		this.type = type;
	}
	public String getParentKey()
	{
		return parentKey;
	}
	public void setParentKey(String parentKey)
	{
		this.parentKey = parentKey;
	}
	public String getParentType()
	{
		return parentType;
	}
	public void setParentType(String parentType)
	{
		this.parentType = parentType;
	}
	public String getRuleId()
	{
		return ruleId;
	}
	public void setRuleId(String ruleId)
	{
		this.ruleId = ruleId;
	}
	public String getId()
	{
		return id;
	}
	public void setId(String id)
	{
		this.id = id;
	}
	public String getNodeType() {
		return nodeType;
	}
	public void setNodeType(String nodeType) {
		this.nodeType = nodeType;
	}
	public Boolean getIsDelete()
	{
		return isDelete;
	}
	public void setIsDelete(Boolean isDelete)
	{
		this.isDelete = isDelete;
	}
}