package com.yeejoin.amos.iot.business.entity;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Where;

import com.fasterxml.jackson.annotation.JsonIgnore;

/**
 * 
 * <pre>
 * 规则视图中email信息
 * </pre>
 *
 * @author AS-guowubin
 * @version $Id: RuleEmail.java, v 0.1 2018年4月10日 上午11:11:15 AS-guowubin Exp $
 */
@Entity
@Table(name = "t_rm_email")
@Where(clause="is_delete=0")//表示未删除的数据
public class RuleEmail implements Serializable
{
	
	/**
	 * <pre>
	 * 
	 * </pre>
	 */
	private static final long serialVersionUID = 853297157740075669L;

	/**
	 * id
	 */
	@Id
    @GeneratedValue(generator = "uuid")
    @GenericGenerator(name = "uuid", strategy = "uuid2")
	@Column(name = "id", nullable = false, length = 36)
	protected String id;
	/**
	 * 名称
	 */
	@Column(name = "name")
	private String name;
	/**
	 * 显示名
	 */
	@Column(name = "display_name")
	private String displayName;
	/**
	 * 收件邮箱地址
	 */
	@Column(name = "to_email")
	private String toEmail;
	/**
	 * 邮箱服务器
	 */
	@Column(name = "server")
	private String server;
	/**
	 * 邮箱服务端口
	 */
	@Column(name = "port")
	private String port;
	/**
	 * 发件邮箱地址
	 */
	@Column(name = "from_email")
	private String fromEmail;
	/**
	 * 发件邮箱密码
	 */
	@Column(name = "from_password")
	private String fromPassword;
	
	/**
	 * 是否删除
	 */
	private Boolean isDelete = false;
	/**
	 * 是否使用安全链接（SSL）
	 */
	@Column(name = "is_ssl")
	private Boolean isSSL;
	
	public String getId()
	{
		return id;
	}
	public void setId(String id)
	{
		this.id = id;
	}
	public String getName()
	{
		return name;
	}
	public void setName(String name)
	{
		this.name = name;
	}
	public String getDisplayName()
	{
		return displayName;
	}
	public void setDisplayName(String displayName)
	{
		this.displayName = displayName;
	}
	public String getToEmail()
	{
		return toEmail;
	}
	public void setToEmail(String toEmail)
	{
		this.toEmail = toEmail;
	}
	public String getServer()
	{
		return server;
	}
	public void setServer(String server)
	{
		this.server = server;
	}
	public String getPort()
	{
		return port;
	}
	public void setPort(String port)
	{
		this.port = port;
	}
	public String getFromEmail()
	{
		return fromEmail;
	}
	public void setFromEmail(String fromEmail)
	{
		this.fromEmail = fromEmail;
	}
	public String getFromPassword()
	{
		return fromPassword;
	}
	public void setFromPassword(String fromPassword)
	{
		this.fromPassword = fromPassword;
	}
	@Transient
	@JsonIgnore
	public Boolean isDelete() {
		return isDelete;
	}

	@Column(name = "is_delete")
	public Boolean getIsDelete() {
		return isDelete;
	}

	public void setIsDelete(Boolean isDelete) {
		this.isDelete = isDelete;
	}
	
	public Boolean getIsSSL()
	{
		return isSSL;
	}
	public void setIsSSL(Boolean isSSL)
	{
		this.isSSL = isSSL;
	}
	
}
 