package com.yeejoin.amos.iot.business.entity;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Where;

import com.yeejoin.amos.op.core.entity.BusinessEntity;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * 
 * <pre>
 * 规则组
 * </pre>
 *
 * @author AS-guowubin
 * @version $Id: RuleGroup.java, v 0.1 2018年4月10日 下午1:27:49 AS-guowubin Exp $
 */
@Entity
@ApiModel
@Table(name = "t_rm_rulegroup")
@Where(clause="is_delete=0")//表示未删除的数据
public class RuleGroup extends BusinessEntity implements Serializable
{

	private static final long serialVersionUID = -7996968532376390369L;

	@Id
    @GeneratedValue(generator = "uuid")
    @GenericGenerator(name = "uuid", strategy = "uuid2")
	@Column(name = "id", nullable = false, length = 36)
	private String id;
	@ApiModelProperty(notes = "规则组名称")
	private String name;
	@ApiModelProperty(notes = "组中文名")
	private String displayName;
	@ApiModelProperty(notes = "是否启用")
	@Column(name = "is_user")
	private Boolean isUser ;

	public Boolean getIsUser()
	{
		return isUser;
	}

	public void setIsUser(Boolean isUser)
	{
		this.isUser = isUser;
	}

	public String getDisplayName()
	{
		return displayName;
	}

	public void setDisplayName(String displayName)
	{
		this.displayName = displayName;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getName() {
		return name;
	}
	
	public String getId()
	{
		return id;
	}

	public void setId(String id)
	{
		this.id = id;
	}
}