package com.yeejoin.amos.iot.business.entity;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Proxy;
import org.hibernate.annotations.Where;

import com.fasterxml.jackson.annotation.JsonIgnore;

/**
 * 
 * <pre>
 * 规则视图中mqtt信息
 * </pre>
 *
 * @author as-guowubin
 * @version $Id: RuleMqtt.java, v 0.1 2018年5月4日 下午2:14:15 as-guowubin Exp $
 */
@Entity
@Table(name = "t_rm_mqtt")
@Where(clause="is_delete=0")//表示未删除的数据
@Proxy(lazy = false)
@JsonIgnoreProperties(value = { "hibernateLazyInitializer", "handler" })
public class RuleMqtt implements Serializable
{
	

	/**
	 * <pre>
	 * 
	 * </pre>
	 */
	private static final long serialVersionUID = -6073325771676450198L;
	/**
	 * id
	 */
	@Id
    @GeneratedValue(generator = "uuid")
    @GenericGenerator(name = "uuid", strategy = "uuid2")
	@Column(name = "id", nullable = false, length = 36)
	protected String id;
	/**
	 * 名称
	 */
	@Column(name = "name")
	private String name;
	/**
	 * 显示名
	 */
	@Column(name = "display_name")
	private String displayName;
	/**
	 * mqtt服务所在服务器IP
	 */
	@Column(name = "server_ip")
	private String serverIp;
	/**
	 * mqtt服务端口号
	 */
	@Column(name = "port")
	private String port;
	/**
	 * mqtt是根据主题推送和定于消息的
	 */
	@Column(name = "theme")
	private String theme;
	/**
	 * 用户名
	 */
	@Column(name = "user_name")
	private String userName;
	/**
	 * 密码
	 */
	@Column(name = "password")
	private String password;
	/**
	 * 是否删除
	 */
	@Column(name = "is_delete")
	private Boolean isDelete = false;
	
	
	public String getId()
	{
		return id;
	}
	public void setId(String id)
	{
		this.id = id;
	}
	public String getName()
	{
		return name;
	}
	public void setName(String name)
	{
		this.name = name;
	}
	public String getDisplayName()
	{
		return displayName;
	}
	public void setDisplayName(String displayName)
	{
		this.displayName = displayName;
	}
	public String getServerIp()
	{
		return serverIp;
	}
	public void setServerIp(String serverIp)
	{
		this.serverIp = serverIp;
	}
	public String getPort()
	{
		return port;
	}
	public void setPort(String port)
	{
		this.port = port;
	}
	public String getTheme()
	{
		return theme;
	}
	public void setTheme(String theme)
	{
		this.theme = theme;
	}
	@Transient
	@JsonIgnore
	public Boolean isDelete() {
		return isDelete;
	}

	public Boolean getIsDelete() {
		return isDelete;
	}

	public void setIsDelete(Boolean isDelete) {
		this.isDelete = isDelete;
	}
	public String getUserName()
	{
		return userName;
	}
	public void setUserName(String userName)
	{
		this.userName = userName;
	}
	public String getPassword()
	{
		return password;
	}
	public void setPassword(String password)
	{
		this.password = password;
	}

	@Override
	public String toString() {
		return "RuleMqtt{" +
				"id='" + id + '\'' +
				", name='" + name + '\'' +
				", displayName='" + displayName + '\'' +
				", serverIp='" + serverIp + '\'' +
				", port='" + port + '\'' +
				", theme='" + theme + '\'' +
				", userName='" + userName + '\'' +
				", password='" + password + '\'' +
				", isDelete=" + isDelete +
				'}';
	}
}
 