package com.yeejoin.amos.iot.business.entity;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Where;

import com.fasterxml.jackson.annotation.JsonIgnore;

/**
 * 
 * <pre>
 * 规则视图中tcp信息
 * </pre>
 *
 * @author as-guowubin
 * @version $Id: RuleTcp.java, v 0.1 2018年5月4日 下午2:16:13 as-guowubin Exp $
 */
@Entity
@Table(name = "t_rm_tcp")
@Where(clause="is_delete=0")//表示未删除的数据
public class RuleTcp implements Serializable
{

	/**
	 * <pre>
	 * 
	 * </pre>
	 */
	private static final long serialVersionUID = -2872103022433683491L;
	/**
	 * id
	 */
	@Id
    @GeneratedValue(generator = "uuid")
    @GenericGenerator(name = "uuid", strategy = "uuid2")
	@Column(name = "id", nullable = false, length = 36)
	protected String id;
	/**
	 * 名称
	 */
	@Column(name = "name")
	private String name;
	/**
	 * 显示名
	 */
	@Column(name = "display_name")
	private String displayName;
	/**
	 * tcp服务所在服务器IP
	 */
	@Column(name = "server_ip")
	private String serverIp;
	/**
	 * tcp服务端口号
	 */
	@Column(name = "port")
	private String port;
	/**
	 * 是否删除
	 */
	@Column(name = "is_delete")
	private Boolean isDelete = false;
	
	public String getId()
	{
		return id;
	}
	public void setId(String id)
	{
		this.id = id;
	}
	public String getName()
	{
		return name;
	}
	public void setName(String name)
	{
		this.name = name;
	}
	public String getDisplayName()
	{
		return displayName;
	}
	public void setDisplayName(String displayName)
	{
		this.displayName = displayName;
	}
	public String getServerIp()
	{
		return serverIp;
	}
	public void setServerIp(String serverIp)
	{
		this.serverIp = serverIp;
	}
	public String getPort()
	{
		return port;
	}
	public void setPort(String port)
	{
		this.port = port;
	}
	
	@Transient
	@JsonIgnore
	public Boolean isDelete() {
		return isDelete;
	}

	public Boolean getIsDelete() {
		return isDelete;
	}

	public void setIsDelete(Boolean isDelete) {
		this.isDelete = isDelete;
	}
}
 