package com.yeejoin.amos.iot.business.entity;

import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.hibernate.annotations.Where;

/**
 * 
 * <pre>
 * 拓扑图子图
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: Subgraph.java, v 0.1 2018年3月8日 上午11:31:48 as-chenjiajun Exp $
 */
@Entity
@Table(name = "t_subgraph") 
@Where(clause="is_delete=0")//表示未删除的数据
public class Subgraph extends TimeEntity
{

	/**
	 * <pre>
	 * 
	 * </pre>
	 */
	private static final long serialVersionUID = -1712541687209069561L;
	
	/**
	 * 名称
	 */
	private String name;

	/**
	 * 对应前端的key
	 */
	private String remark;

	/**
	 * 父子图 key
	 */
	private String parentKey;
	
	/**
	 * 当前节点key
	 */
	private String currentKey;

	/**
	 * 用户id
	 */
	private String userId;
	
	/**
	 * 公司id
	 */
	private String orgCode;
	
	/**
	 * 连线
	 */
	private List<Connection> connections;
	
	/**
	 * 节点
	 */
	private List<Node> nodes;
	
	/**
	 * 图片名
	 */
	private String imgName;
	
	/**
	 * 背景图二进制信息
	 */
	private String binaryImg;
	
	/**
	 * 是否启用监测
	 */
	private Boolean enableMonitor = false;
	
	/**
	 * 图片透明度
	 */
	private Float imgOpacity;
	
	/**
	 * 背景样式
	 */
	private Integer imgLayout;

	@Column(name = "name", length = 100)
	public String getName()
	{
		return name;
	}

	public void setName(String name)
	{
		this.name = name;
	}

	@Column(name = "remark", length = 100)
	public String getRemark()
	{
		return remark;
	}

	public void setRemark(String remark)
	{
		this.remark = remark;
	}

	@Column(name = "parentKey", length = 100)
	public String getParentKey()
	{
		return parentKey;
	}
	
	public void setParentKey(String parentKey)
	{
		this.parentKey = parentKey;
	}
	

	@Column(name = "user_id")
	public String getUserId()
	{
		return userId;
	}


	public void setUserId(String userId)
	{
		this.userId = userId;
	}

	//支持一对多的级联更新/新增(除删除外所有)，配置orphanRemoval去除孤子
	@OneToMany(mappedBy = "subgraph", fetch = FetchType.LAZY, cascade = { CascadeType.DETACH,
			CascadeType.MERGE,CascadeType.PERSIST,CascadeType.REFRESH },orphanRemoval = true)
	@Where(clause="is_delete=0")//表示未删除的数据
	public List<Connection> getConnections()
	{
		return connections;
	}

	public void setConnections(List<Connection> connections)
	{
		this.connections = connections;
	}

	@OneToMany(mappedBy = "subgraph", fetch = FetchType.LAZY, cascade = { CascadeType.DETACH,
			CascadeType.MERGE,CascadeType.PERSIST,CascadeType.REFRESH },orphanRemoval = true)
	@Where(clause="is_delete=0")//表示未删除的数据
	public List<Node> getNodes()
	{
		return nodes;
	}

	public void setNodes(List<Node> nodes)
	{
		this.nodes = nodes;
	}

	@Column(name = "currentKey", length = 100)
	public String getCurrentKey()
	{
		return currentKey;
	}

	public void setCurrentKey(String currentKey)
	{
		this.currentKey = currentKey;
	}
		
	@Column(name = "org_code")
	public String getOrgCode() {
		return orgCode;
	}

	public void setOrgCode(String orgCode) {
		this.orgCode = orgCode;
	}

	@Column(name = "imgname")
	public String getImgName()
	{
		return imgName;
	}

	public void setImgName(String imgName)
	{
		this.imgName = imgName;
	}

	@Column(name = "enable_monitor")
	public Boolean getEnableMonitor() {
		return enableMonitor;
	}

	public void setEnableMonitor(Boolean enableMonitor) {
		this.enableMonitor = enableMonitor;
	}

	@Transient
	public String getBinaryImg()
	{
		return binaryImg;
	}

	public void setBinaryImg(String binaryImg)
	{
		this.binaryImg = binaryImg;
	}

	@Column(name = "img_opacity")
	public Float getImgOpacity()
	{
		return imgOpacity;
	}

	public void setImgOpacity(Float imgOpacity)
	{
		this.imgOpacity = imgOpacity;
	}

	@Column(name = "img_layout")
	public Integer getImgLayout()
	{
		return imgLayout;
	}

	public void setImgLayout(Integer imgLayout)
	{
		this.imgLayout = imgLayout;
	}
}
