package com.yeejoin.amos.iot.business.entity;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Where;

import com.yeejoin.amos.iot.rule.log.LoggerIgnore;
import com.yeejoin.amos.op.core.entity.BusinessEntity;


/**
 * 
 * <pre>
 * 日志实体
 * </pre>
 *
 * @author as-guowubin
 * @version $Id: SystemLog.java, v 0.1 2018年4月23日 下午5:39:10 as-guowubin Exp $
 */
@Entity
@Table(name = "t_sys_log")
@LoggerIgnore
@Where(clause="is_delete=0")//表示未删除的数据
public class SystemLog extends BusinessEntity
{

	/**
	 * <pre>
	 * 
	 * </pre>
	 */
	private static final long serialVersionUID = -4633712954902787071L;

	/**
	 * id
	 */
	@Id
    @GeneratedValue(generator = "uuid")
    @GenericGenerator(name = "uuid", strategy = "uuid2")
	@Column(name = "id", nullable = false, length = 36)
	private String id;
	/**
	 * 时间
	 */
	private Date time = new Date();
	/**
	 * 内容
	 */
	private String context;
	/**
	 * 类型
	 */
	private String type;
	/**
	 * ip
	 */
	private String ip;
	/**
	 * 结果
	 */
	private String result;
	/**
	 * 备注
	 */
	private String remark;

	public Date getTime()
	{
		return time;
	}

	public void setTime(Date time)
	{
		this.time = time;
	}

	public String getContext()
	{
		return context;
	}

	public void setContext(String context)
	{
		this.context = context;
	}

	public String getType()
	{
		return type;
	}

	public void setType(String type)
	{
		this.type = type;
	}

	public String getIp()
	{
		return ip;
	}

	public void setIp(String ip)
	{
		this.ip = ip;
	}

	public String getResult()
	{
		return result;
	}

	public void setResult(String result)
	{
		this.result = result;
	}

	public String getRemark()
	{
		return remark;
	}

	public void setRemark(String remark)
	{
		this.remark = remark;
	}

	public String getId()
	{
		return id;
	}

	public void setId(String id)
	{
		this.id = id;
	}
}
