/**
 * 
 */
package com.yeejoin.amos.iot.business.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Table;

/**
 * vertx的verticle数据
 * 
 * @author as-youjun
 *
 */
@Entity
@Table(name = "t_verticle")
public class Verticle {

	/**
	 * ID
	 */
	private Long id;

	/**
	 * 类名
	 */
	private String name;

	/**
	 * 实例数量
	 */
	private int instanceNum;

	/**
	 * 描述
	 */
	private String descr;

	/**
	 * ip
	 */
	private String host;

	/**
	 * 端口
	 */
	private int port;

	/**
	 * idle时长
	 */
	private int idleTimeout;

	@Id
	@GeneratedValue(strategy = GenerationType.AUTO)
	@Column(name = "id", nullable = false, unique = true)
	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	/**
	 * @return the name
	 */
	@Column(name = "c_name", length = 512, nullable = false)
	public String getName() {
		return name;
	}

	/**
	 * @param name
	 *            the name to set
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the instanceNum
	 */
	@Column(name = "c_instance_num", nullable = false)
	public int getInstanceNum() {
		return instanceNum;
	}

	/**
	 * @param instanceNum
	 *            the instanceNum to set
	 */
	public void setInstanceNum(int instanceNum) {
		this.instanceNum = instanceNum;
	}

	/**
	 * @return the descr
	 */
	@Column(name = "c_descr", length = 512)
	public String getDescr() {
		return descr;
	}

	/**
	 * @param descr
	 *            the descr to set
	 */
	public void setDescr(String descr) {
		this.descr = descr;
	}

	/**
	 * @return the host
	 */
	@Column(name = "c_host", length = 100, nullable = false)
	public String getHost() {
		return host;
	}

	/**
	 * @param host
	 *            the host to set
	 */
	public void setHost(String host) {
		this.host = host;
	}

	/**
	 * @return the port
	 */
	@Column(name = "c_port", nullable = false)
	public int getPort() {
		return port;
	}

	/**
	 * @param port
	 *            the port to set
	 */
	public void setPort(int port) {
		this.port = port;
	}

	/**
	 * @return the idleTimeout
	 */
	@Column(name = "idle_timeout", nullable = false)
	public int getIdleTimeout() {
		return idleTimeout;
	}

	/**
	 * @param idleTimeout
	 *            the idleTimeout to set
	 */
	public void setIdleTimeout(int idleTimeout) {
		this.idleTimeout = idleTimeout;
	}

}
