/**
 *
 */
package com.yeejoin.amos.iot.business.entity.mybatis;

import org.apache.log4j.Logger;

import java.io.Serializable;
import java.util.List;

/**
 * 能力业务对象
 *
 * @author as-youjun
 */
public class CapabilityBo implements Serializable, Cloneable {

    /**
     * 日志记录器
     */
    private static final Logger logger = Logger
            .getLogger(CapabilityBo.class);

    /**
     * 能力id
     */
    private Long id;

    /**
     * 名称(英文、数字、下划线)
     */
    private String name;

    /**
     * 能力分类：1表示采集；2表示控制；3表示诊断
     */
    private Integer type;

    /**
     * 计算公式
     */
    private String formula;

    /**
     * 装备id
     */
    private Long eqpId;

    /**
     * 装备模板id
     */
    private Long eqpTmplId;

    /**
     * 协议实现语言
     */
    private String scriptLang;

    /**
     * 协议实现代码
     */
    private String scriptCode;

    /**
     * 协议id
     */
    private Long protocolId;

    /**
     * 监测方式：1表示监听，2表示采集
     */
    private Integer monitorType = 1;

    /**
     * 监测周期(秒)
     */
    private Integer monitorPeriod = 30;

    /**
     * 能力属性
     */
    private List<CapacityPropertyDataVo> cpblAttrs;

    /**
     * 接口
     */
    private List<IntfcBo> intfcBos;

    /**
     * @return the id
     */
    public Long getId() {
        return id;
    }

    /**
     * @param id the id to set
     */
    public void setId(Long id) {
        this.id = id;
    }

    /**
     * @return the name
     */
    public String getName() {
        return name;
    }

    /**
     * @param name the name to set
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * @return the type
     */
    public Integer getType() {
        return type;
    }

    /**
     * @param type the type to set
     */
    public void setType(Integer type) {
        this.type = type;
    }

    /**
     * @return the formula
     */
    public String getFormula() {
        return formula;
    }

    /**
     * @param formula the formula to set
     */
    public void setFormula(String formula) {
        this.formula = formula;
    }

    /**
     * @return the eqpId
     */
    public Long getEqpId() {
        return eqpId;
    }

    /**
     * @param eqpId the eqpId to set
     */
    public void setEqpId(Long eqpId) {
        this.eqpId = eqpId;
    }

    /**
     * @return the eqpTmplId
     */
    public Long getEqpTmplId() {
        return eqpTmplId;
    }

    /**
     * @param eqpTmplId the eqpTmplId to set
     */
    public void setEqpTmplId(Long eqpTmplId) {
        this.eqpTmplId = eqpTmplId;
    }

    /**
     * @return the scriptLang
     */
    public String getScriptLang() {
        return scriptLang;
    }

    /**
     * @param scriptLang the scriptLang to set
     */
    public void setScriptLang(String scriptLang) {
        this.scriptLang = scriptLang;
    }

    /**
     * @return the scriptCode
     */
    public String getScriptCode() {
        return scriptCode;
    }

    /**
     * @param scriptCode the scriptCode to set
     */
    public void setScriptCode(String scriptCode) {
        this.scriptCode = scriptCode;
    }

    /**
     * @return the protocolId
     */
    public Long getProtocolId() {
        return protocolId;
    }

    /**
     * @param protocolId the protocolId to set
     */
    public void setProtocolId(Long protocolId) {
        this.protocolId = protocolId;
    }

    /**
     * @return the cpblAttrs
     */
    public List<CapacityPropertyDataVo> getCpblAttrs() {
        return cpblAttrs;
    }

    /**
     * @param cpblAttrs the cpblAttrs to set
     */
    public void setCpblAttrs(List<CapacityPropertyDataVo> cpblAttrs) {
        this.cpblAttrs = cpblAttrs;
    }

    /**
     * @return the intfcBos
     */
    public List<IntfcBo> getIntfcBos() {
        return intfcBos;
    }

    /**
     * @param intfcBos the intfcBos to set
     */
    public void setIntfcBos(List<IntfcBo> intfcBos) {
        this.intfcBos = intfcBos;
    }

    /**
     * @return the monitorType
     */
    public Integer getMonitorType() {
        return monitorType;
    }

    /**
     * @param monitorType the monitorType to set
     */
    public void setMonitorType(Integer monitorType) {
        this.monitorType = monitorType;
    }

    /**
     * @return the monitorPeriod
     */
    public Integer getMonitorPeriod() {
        return monitorPeriod;
    }

    /**
     * @param monitorPeriod the monitorPeriod to set
     */
    public void setMonitorPeriod(Integer monitorPeriod) {
        this.monitorPeriod = monitorPeriod;
    }

    @Override
    public Object clone() {
        CapabilityBo newObj = null;
        try {
            newObj = (CapabilityBo) super.clone();
        } catch (CloneNotSupportedException e) {
            logger.error(e);
        }
        return newObj;
    }

}
