package com.yeejoin.amos.iot.business.entity.mybatis;

import org.apache.log4j.Logger;

import java.io.Serializable;

/**
 * <pre>
 * 能力属性
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: CapacityPropertyDataVo.java, v 0.1 2018年2月1日 下午6:03:59
 * as-chenjiajun Exp $
 */
public class CapacityPropertyDataVo implements Serializable, Cloneable {

    /**
     * 日志记录器
     */
    private static final Logger logger = Logger
            .getLogger(CapacityPropertyDataVo.class);

    /**
     * 能力id
     */
    private Long cpblId;

    /**
     * id
     */
    private Long id;

    /**
     * 属性名称(英文、数字、下划线)
     */
    private String name;

    /**
     * 属性分类：1表示变量，2表示常量，3表示标签
     */
    private Integer type = 1;

    /**
     * 显示名称
     */
    private String displayName;

    /**
     * 计量单位
     */
    private String unit;

    /**
     * 描述
     */
    private String descr;

    /**
     * 数据类型：1表示整型，2表示浮点型，3表示布尔型，4表示枚举，5表示字符串，6表示密码
     */
    private Integer dataType = 5;

    /**
     * 字符串值
     */
    private String valueStr;

    /**
     * 数值型值
     */
    private Double valueNumeric;

    /**
     * 最小值
     */
    private Double minValue;

    /**
     * 最大值
     */
    private Double maxValue;

    /**
     * 枚举范围，使用逗号分隔
     */
    private String enumRange;

    /**
     * float/double类型精度
     */
    private Integer precision;
    /**
     * 告警级别
     */
    private Integer alarmLevel;
    /**
     * 能力名称
     */
    private String cpblName;
    /**
     * 设备是否启用，默认启用
     */
    private Boolean isUser = true;

    /**
     * @return the cpblId
     */
    public Long getCpblId() {
        return cpblId;
    }

    /**
     * @param cpblId the cpblId to set
     */
    public void setCpblId(Long cpblId) {
        this.cpblId = cpblId;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    public String getDisplayName() {
        return displayName;
    }

    public void setDisplayName(String displayName) {
        this.displayName = displayName;
    }

    public String getUnit() {
        return unit;
    }

    public void setUnit(String unit) {
        this.unit = unit;
    }

    public String getDescr() {
        return descr;
    }

    public void setDescr(String descr) {
        this.descr = descr;
    }

    public Integer getDataType() {
        return dataType;
    }

    public void setDataType(Integer dataType) {
        this.dataType = dataType;
    }

    public String getValueStr() {
        return valueStr;
    }

    public void setValueStr(String valueStr) {
        this.valueStr = valueStr;
    }

    public Double getValueNumeric() {
        return valueNumeric;
    }

    public void setValueNumeric(Double valueNumeric) {
        this.valueNumeric = valueNumeric;
    }

    public Double getMinValue() {
        return minValue;
    }

    public void setMinValue(Double minValue) {
        this.minValue = minValue;
    }

    public Double getMaxValue() {
        return maxValue;
    }

    public void setMaxValue(Double maxValue) {
        this.maxValue = maxValue;
    }

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getEnumRange() {
        return enumRange;
    }

    public void setEnumRange(String enumRange) {
        this.enumRange = enumRange;
    }

    public Integer getPrecision() {
        return precision;
    }

    public void setPrecision(Integer precision) {
        this.precision = precision;
    }

    public Integer getAlarmLevel() {
        return alarmLevel;
    }

    public void setAlarmLevel(Integer alarmLevel) {
        this.alarmLevel = alarmLevel;
    }

    public String getCpblName() {
        return cpblName;
    }

    public void setCpblName(String cpblName) {
        this.cpblName = cpblName;
    }

    public Boolean getIsUser() {
        return isUser;
    }

    public void setIsUser(Boolean isUser) {
        this.isUser = isUser;
    }

    @Override
    public Object clone() {
        CapacityPropertyDataVo newObj = null;
        try {
            newObj = (CapacityPropertyDataVo) super.clone();
        } catch (CloneNotSupportedException e) {
            logger.error(e);
        }
        return newObj;
    }

}
