/**
 *
 */
package com.yeejoin.amos.iot.business.entity.mybatis;

import com.yeejoin.amos.iot.business.entity.IntfcAttribute;
import org.apache.log4j.Logger;

import java.io.Serializable;
import java.util.List;

/**
 * 设备模板接口bo
 *
 * @author as-youjun
 */
public class EqpTmplIntfcBo implements Serializable, Cloneable {

    /**
     * 日志记录器
     */
    private static final Logger logger = Logger
            .getLogger(EqpTmplIntfcBo.class);

    /**
     * ID
     */
    private Long id;

    /**
     * 设备模板id
     */
    private Long eqpTmplId;

    /**
     * 是否删除
     */
    private Boolean isDelete = false;

    /**
     * 接口id
     */
    private Long intfcId;

    /**
     * 接口名称
     */
    private String intfcName;

    /**
     * 接口显示名称
     */
    private String intfcDisplayName;

    /**
     * 接口方向
     */
    private Integer intfcDirection = 2;

    /**
     * 通信方式字典id
     */
    private Long commId;

    /**
     * 通信方式
     */
    private String commMode;

    /**
     * 通信方式名称
     */
    private String commName;

    /**
     * 接口属性
     */
    private List<IntfcAttribute> intfcAttrs;

    /**
     * @return the id
     */
    public Long getId() {
        return id;
    }

    /**
     * @param id the id to set
     */
    public void setId(Long id) {
        this.id = id;
    }

    /**
     * @return the eqpTmplId
     */
    public Long getEqpTmplId() {
        return eqpTmplId;
    }

    /**
     * @param eqpTmplId the eqpTmplId to set
     */
    public void setEqpTmplId(Long eqpTmplId) {
        this.eqpTmplId = eqpTmplId;
    }

    /**
     * @return the isDelete
     */
    public Boolean getIsDelete() {
        return isDelete;
    }

    /**
     * @param isDelete the isDelete to set
     */
    public void setIsDelete(Boolean isDelete) {
        this.isDelete = isDelete;
    }

    /**
     * @return the intfcId
     */
    public Long getIntfcId() {
        return intfcId;
    }

    /**
     * @param intfcId the intfcId to set
     */
    public void setIntfcId(Long intfcId) {
        this.intfcId = intfcId;
    }

    /**
     * @return the intfcName
     */
    public String getIntfcName() {
        return intfcName;
    }

    /**
     * @param intfcName the intfcName to set
     */
    public void setIntfcName(String intfcName) {
        this.intfcName = intfcName;
    }

    /**
     * @return the intfcDisplayName
     */
    public String getIntfcDisplayName() {
        return intfcDisplayName;
    }

    /**
     * @param intfcDisplayName the intfcDisplayName to set
     */
    public void setIntfcDisplayName(String intfcDisplayName) {
        this.intfcDisplayName = intfcDisplayName;
    }

    /**
     * @return the intfcDirection
     */
    public Integer getIntfcDirection() {
        return intfcDirection;
    }

    /**
     * @param intfcDirection the intfcDirection to set
     */
    public void setIntfcDirection(Integer intfcDirection) {
        this.intfcDirection = intfcDirection;
    }

    public Boolean getDelete() {
        return isDelete;
    }

    public void setDelete(Boolean delete) {
        isDelete = delete;
    }

    public Long getCommId() {
        return commId;
    }

    public void setCommId(Long commId) {
        this.commId = commId;
    }

    public String getCommMode() {
        return commMode;
    }

    public void setCommMode(String commMode) {
        this.commMode = commMode;
    }

    public String getCommName() {
        return commName;
    }

    public void setCommName(String commName) {
        this.commName = commName;
    }

    public List<IntfcAttribute> getIntfcAttrs() {
        return intfcAttrs;
    }

    public void setIntfcAttrs(List<IntfcAttribute> intfcAttrs) {
        this.intfcAttrs = intfcAttrs;
    }

    @Override
    public Object clone() {
        EqpTmplIntfcBo newObj = null;
        try {
            newObj = (EqpTmplIntfcBo) super.clone();
        } catch (CloneNotSupportedException e) {
            logger.error(e);
        }
        return newObj;
    }

}
