package com.yeejoin.amos.iot.business.entity.mybatis;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import com.yeejoin.amos.iot.business.entity.Capability;
import com.yeejoin.amos.iot.business.entity.EqpTmplAttribute;

/**
 * 
 * <pre>
 * 设备模板vo
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: EquipmentTemplateVo.java, v 0.1 2018年4月27日 下午1:44:55 as-chenjiajun Exp $
 */
public class EquipmentTemplateVo implements Serializable
{
	/**
	 * <pre>
	 * 
	 * </pre>
	 */
	private static final long serialVersionUID = 4527094215484525441L;

	/**
	 * 名称
	 */
	private String name;

	/**
	 * 型号
	 */
	private String model;

	/**
	 * 设备类别：1表示采集设备，2表示传感设备，3表示控制设备
	 */
	private Integer type;
	
	private String typeImg;

	/**
	 * 图片
	 */
	private String img;

	/**
	 * 描述
	 */
	private String descr;

	/**
	 * 可见性：0表示公共，1表示私有
	 */
	private Integer visibility;

	/**
	 * 用户id
	 */
	private String userId;
	
	/**
	 * 公司id
	 */
	private String orgCode;
	
	/**
	 * 视图路径
	 */
	private String viewPath;

	/**
	 * 设备模板属性
	 */
	private List<EqpTmplAttribute> attributes;

	/**
	 * 能力
	 */
	private List<Capability> capabilities;
	
	/**
	 * 创建时间
	 */
	private Date createTime;

	/**
	 * 更新时间
	 */
	private Date updateTime;
	
	/**
	 * ID
	 */
	private Long id;

	private Long eqpTmplId;
	
	private String cfgParamJson;
	
	/**
	 * 是否删除
	 */
	private Boolean isDelete = false;
	
	/**
	 * 所属行业名称
	 */
	private String industryName;
	
	/**
	 * 所属行业编码
	 * @return
	 */
	private String industryCode;
	
	public String getName()
	{
		return name;
	}

	public void setName(String name)
	{
		this.name = name;
	}

	public String getModel()
	{
		return model;
	}

	public void setModel(String model)
	{
		this.model = model;
	}

	public Integer getType()
	{
		return type;
	}

	public void setType(Integer type)
	{
		this.type = type;
	}

	public String getTypeImg()
	{
		return typeImg;
	}

	public void setTypeImg(String typeImg)
	{
		this.typeImg = typeImg;
	}

	public String getImg()
	{
		return img;
	}

	public void setImg(String img)
	{
		this.img = img;
	}

	public String getDescr()
	{
		return descr;
	}

	public void setDescr(String descr)
	{
		this.descr = descr;
	}

	public Integer getVisibility()
	{
		return visibility;
	}

	public void setVisibility(Integer visibility)
	{
		this.visibility = visibility;
	}

	public String getUserId()
	{
		return userId;
	}

	public void setUserId(String userId)
	{
		this.userId = userId;
	}

	public String getOrgCode()
	{
		return orgCode;
	}

	public void setOrgCode(String orgCode)
	{
		this.orgCode = orgCode;
	}

	public String getViewPath()
	{
		return viewPath;
	}

	public void setViewPath(String viewPath)
	{
		this.viewPath = viewPath;
	}

	public List<EqpTmplAttribute> getAttributes()
	{
		return attributes;
	}

	public void setAttributes(List<EqpTmplAttribute> attributes)
	{
		this.attributes = attributes;
	}

	public List<Capability> getCapabilities()
	{
		return capabilities;
	}

	public void setCapabilities(List<Capability> capabilities)
	{
		this.capabilities = capabilities;
	}

	public Date getCreateTime()
	{
		return createTime;
	}

	public void setCreateTime(Date createTime)
	{
		this.createTime = createTime;
	}

	public Date getUpdateTime()
	{
		return updateTime;
	}

	public void setUpdateTime(Date updateTime)
	{
		this.updateTime = updateTime;
	}

	public Long getId()
	{
		return id;
	}

	public void setId(Long id)
	{
		this.id = id;
	}

	public Boolean getIsDelete()
	{
		return isDelete;
	}

	public void setIsDelete(Boolean isDelete)
	{
		this.isDelete = isDelete;
	}

	public String getIndustryName() {
		return industryName;
	}

	public void setIndustryName(String industryName) {
		this.industryName = industryName;
	}

	public String getIndustryCode() {
		return industryCode;
	}

	public void setIndustryCode(String industryCode) {
		this.industryCode = industryCode;
	}

	public Long getEqpTmplId() {
		return eqpTmplId;
	}

	public void setEqpTmplId(Long eqpTmplId) {
		this.eqpTmplId = eqpTmplId;
	}

	public String getCfgParamJson() {
		return cfgParamJson;
	}

	public void setCfgParamJson(String cfgParamJson) {
		this.cfgParamJson = cfgParamJson;
	}
	
}
