package com.yeejoin.amos.iot.business.enums;

/**
 * 告警清除类型枚举
 * 
 * @author as-lichenglong
 *
 */
public enum AlarmClearType {

	HAND("用户清除", 1),AUTO("自动清除", 2);

	/**
	 * 名称
	 */
	private String name;

	/**
	 * 值
	 */
	private int value;

	// 构造方法
	private AlarmClearType(String name, int value) {
		this.name = name;
		this.value = value;
	}

	/**
	 * 
	 * <pre>
	 * 获取索引名称
	 * </pre>
	 *
	 * @param value
	 * @return
	 */
	public static String getName(int value) {
		for (AlarmClearType c : AlarmClearType.values()) {
			if (c.getValue() == value) {
				return c.name;
			}
		}
		return null;
	}

	/**
	 * 
	 * <pre>
	 * 获取索引
	 * </pre>
	 *
	 * @param value
	 * @return
	 */
	public static AlarmClearType getEnum(int value) {
		for (AlarmClearType c : AlarmClearType.values()) {
			if (c.getValue() == value) {
				return c;
			}
		}
		return null;
	}

	/**
	 * 
	 * <pre>
	 * 获取索引
	 * </pre>
	 *
	 * @param name
	 * @return
	 */
	public static AlarmClearType getEnum(String name) {
		for (AlarmClearType c : AlarmClearType.values()) {
			if (c.getName().equals(name)) {
				return c;
			}
		}
		return null;
	}

	/**
	 * Getter method for property <tt>name</tt>.
	 * 
	 * @return property value of name
	 */
	public String getName() {
		return name;
	}

	/**
	 * Setter method for property <tt>name</tt>.
	 * 
	 * @param name
	 *            value to be assigned to property name
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Getter method for property <tt>value</tt>.
	 * 
	 * @return property value of value
	 */
	public int getValue() {
		return value;
	}

	/**
	 * Setter method for property <tt>value</tt>.
	 * 
	 * @param value
	 *            value to be assigned to property value
	 */
	public void setValue(int value) {
		this.value = value;
	}

}
