package com.yeejoin.amos.iot.business.enums;

/**
 * 告警类型枚举
 * 
 * @author as-lichenglong
 *
 */
public enum AlarmType {

	// 告警类型：1指标越界，2采集异常，3设备掉线
	OVER("指标越界", 1), EXCEPTION("采集异常", 2), DOWN("设备掉线", 3);

	/**
	 * 名称
	 */
	private String name;

	/**
	 * 值
	 */
	private int value;

	// 构造方法
	private AlarmType(String name, int value) {
		this.name = name;
		this.value = value;
	}

	/**
	 * 
	 * <pre>
	 * 获取索引名称
	 * </pre>
	 *
	 * @param value
	 * @return
	 */
	public static String getName(int value) {
		for (AlarmType c : AlarmType.values()) {
			if (c.getValue() == value) {
				return c.name;
			}
		}
		return null;
	}

	/**
	 * 
	 * <pre>
	 * 获取索引
	 * </pre>
	 *
	 * @param value
	 * @return
	 */
	public static AlarmType getEnum(int value) {
		for (AlarmType c : AlarmType.values()) {
			if (c.getValue() == value) {
				return c;
			}
		}
		return null;
	}

	/**
	 * 
	 * <pre>
	 * 获取索引
	 * </pre>
	 *
	 * @param name
	 * @return
	 */
	public static AlarmType getEnum(String name) {
		for (AlarmType c : AlarmType.values()) {
			if (c.getName().equals(name)) {
				return c;
			}
		}
		return null;
	}

	/**
	 * Getter method for property <tt>name</tt>.
	 * 
	 * @return property value of name
	 */
	public String getName() {
		return name;
	}

	/**
	 * Setter method for property <tt>name</tt>.
	 * 
	 * @param name
	 *            value to be assigned to property name
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Getter method for property <tt>value</tt>.
	 * 
	 * @return property value of value
	 */
	public int getValue() {
		return value;
	}

	/**
	 * Setter method for property <tt>value</tt>.
	 * 
	 * @param value
	 *            value to be assigned to property value
	 */
	public void setValue(int value) {
		this.value = value;
	}

}
