package com.yeejoin.amos.iot.business.enums;

/**
 * 能力分类枚举
 * 
 * @author as-youjun
 *
 */
public enum CapabilityType {

	// 能力分类：1表示采集；2表示控制；3表示诊断
	COLLECT("采集", 1), CONTROL("控制", 2), DIAGNOSE("诊断", 3);

	/**
	 * 名称
	 */
	private String name;

	/**
	 * 值
	 */
	private int value;

	// 构造方法
	private CapabilityType(String name, int value) {
		this.name = name;
		this.value = value;
	}

	/**
	 * 
	 * <pre>
	 * 获取索引名称
	 * </pre>
	 *
	 * @param value
	 * @return
	 */
	public static String getName(int value) {
		for (CapabilityType c : CapabilityType.values()) {
			if (c.getValue() == value) {
				return c.name;
			}
		}
		return null;
	}

	/**
	 * 
	 * <pre>
	 * 获取索引
	 * </pre>
	 *
	 * @param value
	 * @return
	 */
	public static CapabilityType getEnum(int value) {
		for (CapabilityType c : CapabilityType.values()) {
			if (c.getValue() == value) {
				return c;
			}
		}
		return null;
	}

	/**
	 * 
	 * <pre>
	 * 获取索引
	 * </pre>
	 *
	 * @param name
	 * @return
	 */
	public static CapabilityType getEnum(String name) {
		for (CapabilityType c : CapabilityType.values()) {
			if (c.getName().equals(name)) {
				return c;
			}
		}
		return null;
	}

	/**
	 * Getter method for property <tt>name</tt>.
	 * 
	 * @return property value of name
	 */
	public String getName() {
		return name;
	}

	/**
	 * Setter method for property <tt>name</tt>.
	 * 
	 * @param name
	 *            value to be assigned to property name
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Getter method for property <tt>value</tt>.
	 * 
	 * @return property value of value
	 */
	public int getValue() {
		return value;
	}

	/**
	 * Setter method for property <tt>value</tt>.
	 * 
	 * @param value
	 *            value to be assigned to property value
	 */
	public void setValue(int value) {
		this.value = value;
	}

}
