package com.yeejoin.amos.iot.business.enums;

/**
 * 数据类型枚举
 * 
 * @author as-youjun
 *
 */
public enum DataType {

	// 数据类型：1表示整型，2表示浮点型，3表示布尔型，4表示枚举，5表示字符串，6表示密码
	VARIABLE("整型", 1,"VARIABLE"), FLOAT("浮点型", 2,"FLOAT"), BOOLEAN("布尔型", 3,"BOOLEAN"), ENUMERATION("枚举", 4,"ENUMERATION"), STRING("字符串", 5,"STRING"), PASSWORD("密码", 6,"PASSWORD");

	/**
	 * 名称
	 */
	private String name;

	/**
	 * 值
	 */
	private int value;
	/**
	 * 英文名
	 */
	private String vname;

	// 构造方法
	private DataType(String name, int value,String vname) {
		this.name = name;
		this.value = value;
		this.vname = vname;
	}

	/**
	 * 
	 * <pre>
	 * 获取索引名称
	 * </pre>
	 *
	 * @param value
	 * @return
	 */
	public static String getName(int value) {
		for (DataType c : DataType.values()) {
			if (c.getValue() == value) {
				return c.name;
			}
		}
		return null;
	}
	/**
	 * 
	 * <pre>
	 * 获取索引英文名称名称
	 * </pre>
	 *
	 * @param value
	 * @return
	 */
	public static String getVName(int value) {
		for (DataType c : DataType.values()) {
			if (c.getValue() == value) {
				return c.vname;
			}
		}
		return null;
	}
	/**
	 * 
	 * <pre>
	 * 获取索引
	 * </pre>
	 *
	 * @param value
	 * @return
	 */
	public static DataType getEnum(int value) {
		for (DataType c : DataType.values()) {
			if (c.getValue() == value) {
				return c;
			}
		}
		return null;
	}

	/**
	 * 
	 * <pre>
	 * 获取索引
	 * </pre>
	 *
	 * @param name
	 * @return
	 */
	public static DataType getEnum(String name) {
		for (DataType c : DataType.values()) {
			if (c.getName().equals(name)) {
				return c;
			}
		}
		return null;
	}

	/**
	 * Getter method for property <tt>name</tt>.
	 * 
	 * @return property value of name
	 */
	public String getName() {
		return name;
	}

	/**
	 * Setter method for property <tt>name</tt>.
	 * 
	 * @param name
	 *            value to be assigned to property name
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Getter method for property <tt>value</tt>.
	 * 
	 * @return property value of value
	 */
	public int getValue() {
		return value;
	}

	/**
	 * Setter method for property <tt>value</tt>.
	 * 
	 * @param value
	 *            value to be assigned to property value
	 */
	public void setValue(int value) {
		this.value = value;
	}

	public String getVname() {
		return vname;
	}

	public void setVname(String vname) {
		this.vname = vname;
	}
}
