package com.yeejoin.amos.iot.business.enums;

/**
 * 设备类别枚举
 * 
 * @author as-youjun
 *
 */
public enum EquipmentType {

	// 设备类别：1表示传输设备，2表示传感设备，3表示控制设备
	COLLECTOR("传输设备", 1, "transDevice"), SENSOR("传感设备", 2, "sensorDevice"),
	CONTROLLER("控制设备", 3, "controlDevice"), OTHER("其他", 4, "otherDevice");

	/**
	 * 名称
	 */
	private String name;

	/**
	 * 值
	 */
	private int value;
	
	private String type;

	// 构造方法
	private EquipmentType(String name, int value, String type) {
		this.name = name;
		this.value = value;
		this.type = type;
	}

	/**
	 * 
	 * <pre>
	 * 获取索引名称
	 * </pre>
	 *
	 * @param value
	 * @return
	 */
	public static String getName(int value) {
		for (EquipmentType c : EquipmentType.values()) {
			if (c.getValue() == value) {
				return c.name;
			}
		}
		return null;
	}

	/**
	 * 
	 * <pre>
	 * 获取索引
	 * </pre>
	 *
	 * @param value
	 * @return
	 */
	public static EquipmentType getEnum(int value) {
		for (EquipmentType c : EquipmentType.values()) {
			if (c.getValue() == value) {
				return c;
			}
		}
		return null;
	}

	/**
	 * 
	 * <pre>
	 * 获取索引
	 * </pre>
	 *
	 * @param name
	 * @return
	 */
	public static EquipmentType getEnum(String name) {
		for (EquipmentType c : EquipmentType.values()) {
			if (c.getName().equals(name)) {
				return c;
			}
		}
		return null;
	}

	/**
	 * Getter method for property <tt>name</tt>.
	 * 
	 * @return property value of name
	 */
	public String getName() {
		return name;
	}

	/**
	 * Setter method for property <tt>name</tt>.
	 * 
	 * @param name
	 *            value to be assigned to property name
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Getter method for property <tt>value</tt>.
	 * 
	 * @return property value of value
	 */
	public int getValue() {
		return value;
	}

	/**
	 * Setter method for property <tt>value</tt>.
	 * 
	 * @param value
	 *            value to be assigned to property value
	 */
	public void setValue(int value) {
		this.value = value;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

}
