package com.yeejoin.amos.iot.business.param;

import java.util.List;

/**
 * 
 * <pre>
 * 设备能力
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: EquipmentCapacityParam.java, v 0.1 2018年1月30日 上午10:04:01 as-chenjiajun Exp $
 */
public class EquipmentCapacityParam
{
	
	/**
	 * 主键ID
	 */
	private Long id;
	/**
	 * 所属设备模板id
	 */
	private Long equipmentId;
	/**
	 * 名称(英文、数字、下划线)
	 */
	private String name;

	/**
	 * 能力分类：1表示采集；2表示控制；3表示诊断
	 */
	private Integer type;

	/**
	 * 描述
	 */
	private String descr;
	
	/**
	 * 接口id-接口方向
	 */
	private List<String> intfcIds;
	
	/**
	 * 协议id
	 */
	private Long protocolId;
	
	/**
	 * 能力属性
	 */
	private List<CapacityPropertyParam> capacityPropertyParams;
	
	/**
	 * 计算公式
	 */
	private String formula;
	
	/**
	 * 监测方式：1表示监听，2表示采集
	 */
	private Integer monitortype = 1;

	/**
	 * 监测周期(秒)
	 */
	private Integer period = 30;

	public String getMongodb() {
		return mongodb;
	}

	public void setMongodb(String mongodb) {
		this.mongodb = mongodb;
	}

	private String mongodb;
	
	public Long getId()
	{
		return id;
	}

	public void setId(Long id)
	{
		this.id = id;
	}

	public Long getEquipmentId()
	{
		return equipmentId;
	}

	public void setEquipmentId(Long equipmentId)
	{
		this.equipmentId = equipmentId;
	}

	public String getName()
	{
		return name;
	}

	public void setName(String name)
	{
		this.name = name;
	}

	public Integer getType()
	{
		return type;
	}

	public void setType(Integer type)
	{
		this.type = type;
	}

	public String getDescr()
	{
		return descr;
	}

	public void setDescr(String descr)
	{
		this.descr = descr;
	}

	public List<String> getIntfcIds()
	{
		return intfcIds;
	}

	public void setIntfcIds(List<String> intfcIds)
	{
		this.intfcIds = intfcIds;
	}

	public Long getProtocolId()
	{
		return protocolId;
	}

	public void setProtocolId(Long protocolId)
	{
		this.protocolId = protocolId;
	}

	public List<CapacityPropertyParam> getCapacityPropertyParams()
	{
		return capacityPropertyParams;
	}

	public void setCapacityPropertyParams(
			List<CapacityPropertyParam> capacityPropertyParams)
	{
		this.capacityPropertyParams = capacityPropertyParams;
	}

	/**
	 * @return the formula
	 */
	public String getFormula() {
		return formula;
	}

	/**
	 * @param formula the formula to set
	 */
	public void setFormula(String formula) {
		this.formula = formula;
	}

	public Integer getMonitortype()
	{
		return monitortype;
	}

	public void setMonitortype(Integer monitortype)
	{
		this.monitortype = monitortype;
	}

	public Integer getPeriod()
	{
		return period;
	}

	public void setPeriod(Integer period)
	{
		this.period = period;
	}
}
