package com.yeejoin.amos.iot.business.param;

import java.util.List;

/**
 * 
 * <pre>
 * 设备参数
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: EquipmentParam.java, v 0.1 2018年1月29日 下午1:15:37 as-chenjiajun Exp $
 */
public class EquipmentParam
{
	
	/**
	 * 设备模板ID
	 */
	private Long id;
	/**
	 * 图片二进制码（Blob）
	 */
	private String binaryImg;
	
	/**
	 * 图片路径
	 */
	private String imgName;
	
	/**
	 * 名称
	 */
	private String name;

	/**
	 * 型号
	 */
	private String model;

	/**
	 * 设备类别：1表示采集设备，2表示传感设备，3表示控制设备
	 */
	private Integer type;

	/**
	 * 描述
	 */
	private String desc;
	
	/**
	 * 视图路径
	 */
	private String viewPath;
	
	/**
	 * 可见性：0表示公共，1表示私有
	 */
	private Integer visibility;
	
	/**
	 * 所属行业id
	 */
	private Long industryId;
	
	
	/**
	 * 组织机构
	 */
	private String orgCode;
	
	/**
	 * 设备类型
	 */
	private String eqpType;
	
	/**
	 * 设备属性集合
	 */
	private List<EquipmentPropertyParam> equipmentPropertyParams;
	
	/**
	 * 设备接口集合
	 */
	private List<EquipmentInterfaceParam> equipmentInterfaceParams;
	
	/**
	 * 设备能力集合
	 */
	private List<EquipmentCapacityParam> equipmentCapacityParams;

	public Long getId()
	{
		return id;
	}

	public void setId(Long id)
	{
		this.id = id;
	}

	public String getBinaryImg()
	{
		return binaryImg;
	}

	public void setBinaryImg(String binaryImg)
	{
		this.binaryImg = binaryImg;
	}

	public String getImgName()
	{
		return imgName;
	}

	public void setImgName(String imgName)
	{
		this.imgName = imgName;
	}

	public String getName()
	{
		return name;
	}

	public void setName(String name)
	{
		this.name = name;
	}

	public String getModel()
	{
		return model;
	}

	public void setModel(String model)
	{
		this.model = model;
	}

	public Integer getType()
	{
		return type;
	}

	public void setType(Integer type)
	{
		this.type = type;
	}

	public String getDesc()
	{
		return desc;
	}

	public void setDesc(String desc)
	{
		this.desc = desc;
	}

	public Integer getVisibility()
	{
		return visibility;
	}

	public void setVisibility(Integer visibility)
	{
		this.visibility = visibility;
	}

	public List<EquipmentPropertyParam> getEquipmentPropertyParams()
	{
		return equipmentPropertyParams;
	}

	public void setEquipmentPropertyParams(
			List<EquipmentPropertyParam> equipmentPropertyParams)
	{
		this.equipmentPropertyParams = equipmentPropertyParams;
	}

	public List<EquipmentInterfaceParam> getEquipmentInterfaceParams()
	{
		return equipmentInterfaceParams;
	}

	public void setEquipmentInterfaceParams(
			List<EquipmentInterfaceParam> equipmentInterfaceParams)
	{
		this.equipmentInterfaceParams = equipmentInterfaceParams;
	}

	public List<EquipmentCapacityParam> getEquipmentCapacityParams()
	{
		return equipmentCapacityParams;
	}

	public void setEquipmentCapacityParams(
			List<EquipmentCapacityParam> equipmentCapacityParams)
	{
		this.equipmentCapacityParams = equipmentCapacityParams;
	}

	public String getViewPath() {
		return viewPath;
	}

	public void setViewPath(String viewPath) {
		this.viewPath = viewPath;
	}

	public String getOrgCode() {
		return orgCode;
	}

	public void setOrgCode(String orgCode) {
		this.orgCode = orgCode;
	}

	public Long getIndustryId() {
		return industryId;
	}

	public void setIndustryId(Long industryId) {
		this.industryId = industryId;
	}

	public String getEqpType()
	{
		return eqpType;
	}

	public void setEqpType(String eqpType)
	{
		this.eqpType = eqpType;
	}
}
