package com.yeejoin.amos.iot.business.param;

import javax.persistence.Column;

/**
 * 
 * <pre>
 * 设备属性
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: EquipmentProperty.java, v 0.1 2018年1月29日 下午6:08:58 as-chenjiajun Exp $
 */
public class EquipmentPropertyParam
{
	/**
	 * 属性id
	 */
	private Long id;
	/**
	 * 所属设备模板id
	 */
	private Long equipmentId;
	/**
	 * 属性名称(英文、数字、下划线)
	 */
	private String name;

	/**
	 * 属性分类：1表示变量，2表示常量，3表示标签
	 */
	private Integer type;

	/**
	 * 显示名称
	 */
	private String displayName;

	/**
	 * 计量单位
	 */
	private String unit;

	/**
	 * 描述
	 */
	private String descr;

	/**
	 * 数据类型：1表示整型，2表示浮点型，3表示布尔型，4表示枚举，5表示字符串，6表示密码
	 */
	private Integer dataType;

	/**
	 * 字符串值
	 */
	private String valueStr;

	/**
	 * 数值型值
	 */
	private Double valueNumeric;

	/**
	 * 最小值
	 */
	private Double minValue;

	/**
	 * 最大值
	 */
	private Double maxValue;
	
	/**
	 * 枚举范围，使用逗号分隔
	 */
	private String enumRange;
	
	/**
	 * float/double类型精度
	 */
	private Integer precision;
	
	/**
     * 是否必填
     */
    private Boolean isRequired;

    public Boolean getIsRequired() {
		return isRequired;
	}

	public void setIsRequired(Boolean isRequired) {
		this.isRequired = isRequired;
	}

	public Long getId()
	{
		return id;
	}

	public void setId(Long id)
	{
		this.id = id;
	}

	public Long getEquipmentId()
	{
		return equipmentId;
	}

	public void setEquipmentId(Long equipmentId)
	{
		this.equipmentId = equipmentId;
	}

	public String getName()
	{
		return name;
	}

	public void setName(String name)
	{
		this.name = name;
	}

	public Integer getType()
	{
		return type;
	}

	public void setType(Integer type)
	{
		this.type = type;
	}

	public String getDisplayName()
	{
		return displayName;
	}

	public void setDisplayName(String displayName)
	{
		this.displayName = displayName;
	}

	public String getUnit()
	{
		return unit;
	}

	public void setUnit(String unit)
	{
		this.unit = unit;
	}

	public String getDescr()
	{
		return descr;
	}

	public void setDescr(String descr)
	{
		this.descr = descr;
	}

	public Integer getDataType()
	{
		return dataType;
	}

	public void setDataType(Integer dataType)
	{
		this.dataType = dataType;
	}

	public String getValueStr()
	{
		return valueStr;
	}

	public void setValueStr(String valueStr)
	{
		this.valueStr = valueStr;
	}

	public Double getValueNumeric()
	{
		return valueNumeric;
	}

	public void setValueNumeric(Double valueNumeric)
	{
		this.valueNumeric = valueNumeric;
	}

	public Double getMinValue()
	{
		return minValue;
	}

	public void setMinValue(Double minValue)
	{
		this.minValue = minValue;
	}

	public Double getMaxValue()
	{
		return maxValue;
	}

	public void setMaxValue(Double maxValue)
	{
		this.maxValue = maxValue;
	}

	public String getEnumRange()
	{
		return enumRange;
	}

	public void setEnumRange(String enumRange)
	{
		this.enumRange = enumRange;
	}

	public Integer getPrecision()
	{
		return precision;
	}

	public void setPrecision(Integer precision)
	{
		this.precision = precision;
	}
}
