/**
 * 
 */
package com.yeejoin.amos.iot.business.param;

import java.text.ParseException;
import java.util.Date;

import org.apache.commons.lang.StringUtils;
import org.apache.log4j.Logger;

import com.yeejoin.amos.iot.business.constants.IotConstant;

/**
 * 查询指标数据参数
 * 
 * @author as-youjun
 *
 */
public class QueryMetricDataParam {

	/**
	 * 设备类别：1表示采集设备，2表示传感设备，3表示控制设备
	 */
	private Integer eqpType;

	/**
	 * 设备名称
	 */
	private String equipName;

	/**
	 * 能力分类：1表示采集；2表示控制；3表示诊断
	 */
	private Integer cpblType;

	/**
	 * 能力名称(英文、数字、下划线)
	 */
	private String cpblName;

	/**
	 * 一组指标数据的唯一标识,例如："类名" 唯一标识指标(集合)数据
	 */
	private String metricKey;

	/**
	 * 开始时间
	 */
	private String startTimeStr;

	/**
	 * 结束时间
	 */
	private String endTimeStr;

	/**
	 * 页号
	 */
	private Integer page;

	/**
	 * 页大小
	 */
	private Integer size;
	
	/**
	 * 设备id
	 */
	private Long eqpId;
	
	/**
	 * 能力id
	 */
	private Long cpblId;

	/**
	 * @return the eqpType
	 */
	public Integer getEqpType() {
		return eqpType;
	}

	/**
	 * @param eqpType
	 *            the eqpType to set
	 */
	public void setEqpType(Integer eqpType) {
		this.eqpType = eqpType;
	}

	/**
	 * @return the equipName
	 */
	public String getEquipName() {
		return equipName;
	}

	/**
	 * @param equipName
	 *            the equipName to set
	 */
	public void setEquipName(String equipName) {
		this.equipName = equipName;
	}

	/**
	 * @return the cpblType
	 */
	public Integer getCpblType() {
		return cpblType;
	}

	/**
	 * @param cpblType
	 *            the cpblType to set
	 */
	public void setCpblType(Integer cpblType) {
		this.cpblType = cpblType;
	}

	/**
	 * @return the cpblName
	 */
	public String getCpblName() {
		return cpblName;
	}

	/**
	 * @param cpblName
	 *            the cpblName to set
	 */
	public void setCpblName(String cpblName) {
		this.cpblName = cpblName;
	}

	/**
	 * @return the metricKey
	 */
	public String getMetricKey() {
		return metricKey;
	}

	/**
	 * @param metricKey
	 *            the metricKey to set
	 */
	public void setMetricKey(String metricKey) {
		this.metricKey = metricKey;
	}

	/**
	 * @return the startTime
	 */
	public Date getStartTime() {
		if (StringUtils.isEmpty(this.startTimeStr)) {
			return null;
		}
		Date startTime = null;
		try {
			startTime = IotConstant.SIMPLEDATAFORMAT_YMDHMS.parse(this.startTimeStr);
		} catch (ParseException e) {
			Logger.getLogger(this.getClass()).error(e);
		}
		return startTime;
	}

	/**
	 * @return the endTime
	 */
	public Date getEndTime() {
		if (StringUtils.isEmpty(this.endTimeStr)) {
			return null;
		}
		Date endTime = null;
		try {
			endTime = IotConstant.SIMPLEDATAFORMAT_YMDHMS.parse(this.endTimeStr);
		} catch (ParseException e) {
			Logger.getLogger(this.getClass()).error(e);
		}
		return endTime;
	}

	/**
	 * @return the startTimeStr
	 */
	public String getStartTimeStr() {
		return startTimeStr;
	}

	/**
	 * @param startTimeStr
	 *            the startTimeStr to set
	 */
	public void setStartTimeStr(String startTimeStr) {
		this.startTimeStr = startTimeStr;
	}

	/**
	 * @return the endTimeStr
	 */
	public String getEndTimeStr() {
		return endTimeStr;
	}

	/**
	 * @param endTimeStr
	 *            the endTimeStr to set
	 */
	public void setEndTimeStr(String endTimeStr) {
		this.endTimeStr = endTimeStr;
	}

	/**
	 * @return the page
	 */
	public Integer getPage() {
		return page;
	}

	/**
	 * @param page
	 *            the page to set
	 */
	public void setPage(Integer page) {
		this.page = page;
	}

	/**
	 * @return the size
	 */
	public Integer getSize() {
		return size;
	}

	/**
	 * @param size
	 *            the size to set
	 */
	public void setSize(Integer size) {
		this.size = size;
	}

	public Long getEqpId()
	{
		return eqpId;
	}

	public void setEqpId(Long eqpId)
	{
		this.eqpId = eqpId;
	}

	public Long getCpblId()
	{
		return cpblId;
	}

	public void setCpblId(Long cpblId)
	{
		this.cpblId = cpblId;
	}

}
