/**
 * 
 */
package com.yeejoin.amos.iot.business.polling;

import java.util.List;
import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yeejoin.amos.iot.business.dao.repository.IPollingJobDao;
import com.yeejoin.amos.iot.business.entity.PollingJob;

/**
 * 定时job启动器
 * 
 * @author as-youjun
 *
 */
@Service("pollingJobStarter")
public class PollingJobStarter {

	@Autowired
	private IPollingJobDao pollingJobDao;

	/**
	 * 启动时运行
	 */
	public void start() {
		List<PollingJob> pollingJobs = pollingJobDao.findEnabledJob();
		if (CollectionUtils.isEmpty(pollingJobs)) {
			return;
		}
		// 一个线程管理pollingjob
		final ScheduledExecutorService service = Executors.newSingleThreadScheduledExecutor();
		pollingJobs.forEach(pollingJob -> {
			// 从现在开始
			// pollingJob.getDelay()秒钟之后，每隔pollingJob.getPeriod()秒钟执行一次job
			service.scheduleAtFixedRate(new PollingScheduledExecutor(pollingJob), pollingJob.getDelay(),
					pollingJob.getPeriod(), TimeUnit.SECONDS);
		});
	}

}
