/**
 * 
 */
package com.yeejoin.amos.iot.business.polling.test;

import java.util.HashMap;
import java.util.Map;

import net.sf.json.JSONObject;

import org.apache.log4j.Logger;

import com.yeejoin.amos.iot.business.constants.IotConstant;
import com.yeejoin.amos.iot.context.IotContext;
import com.yeejoin.amos.iot.socket.websocket.CommonMessage;
import com.yeejoin.amos.iot.socket.websocket.WebsocketService;

/**
 * @author as-youjun
 *
 */
public class Test123 {

	/**
	 * 日志记录器
	 */
	private static final Logger logger = Logger.getLogger(Test123.class);

	/**
	 * 发送消息
	 * 
	 * @param message
	 */
	private void sendMessage(CommonMessage message) {
		try {
			WebsocketService websocketService = (WebsocketService) IotContext
					.getInstance().getBean("websocketService");
			websocketService.sendMessage(message);
			logger.debug("sendMessage successful: " + message);
		} catch (Exception e) {
			logger.error(e);
		}
	}

	/**
	 * 测试完一个接口
	 * 
	 * @param testIntfc
	 */
	public void finishOneIntfc(TestIntfc testIntfc, String token,
			int finishedCount, int totalIntfcCount) {
		try {
			logger.debug("enter finishOneIntfc... " + testIntfc);
			Double percentage = Double.valueOf(finishedCount)
					/ Double.valueOf(totalIntfcCount) * 100.0;
			int percent = percentage.intValue();
			// 发送一个接口测试完成消息
			if (percent >= 100) {
				// 所有接口测试完成
				percent = 100;
			}
			testIntfc.setPercent(percent);
			CommonMessage message = new CommonMessage();
			message.setKey(IotConstant.EquipmentConstant.TEST_EQUIPMENT
					+ IotConstant.SHARP + token);
			Map<String, TestIntfc> dataMap = new HashMap<String, TestIntfc>();
			dataMap.put(IotConstant.EquipmentConstant.CONNECTDATA, testIntfc);
			message.setJsonData(JSONObject.fromObject(dataMap).toString());
			logger.debug("finishOneIntfc message: " + message);
			logger.debug("before send intfc message!");
			sendMessage(message);
			logger.debug("after send intfc message!");
		} catch (Exception e) {
			logger.error("finishAIntfc error! " + e);
		}
	}

	/**
	 * 测试完成一个指标
	 * 
	 * @param testCapablility
	 */
	public void finishOneCpbl(TestCapablility testCapablility, String token,
			int finishedCount, int totalCpblCount) {
		try {
			logger.debug("enter finishOneCpbl... " + testCapablility);
			Double percentage = Double.valueOf(finishedCount)
					/ Double.valueOf(totalCpblCount) * 100.0;
			int percent = percentage.intValue();
			// 发送一个指标测试完成消息
			if (percent >= 100) {
				// 所有指标测试完成
				percent = 100;
			}
			testCapablility.setPercent(percent);
			CommonMessage message = new CommonMessage();
			message.setKey(IotConstant.EquipmentConstant.TEST_EQUIPMENT
					+ IotConstant.SHARP + token);
			Map<String, TestCapablility> dataMap = new HashMap<String, TestCapablility>();
			dataMap.put(IotConstant.EquipmentConstant.METRICDATA,
					testCapablility);
			message.setJsonData(JSONObject.fromObject(dataMap).toString());
			logger.debug("finishOneIntfc message: " + message);
			logger.debug("before send intfc message!");
			sendMessage(message);
			logger.debug("after send intfc message!");
		} catch (Exception e) {
			logger.error("finishAIntfc error! " + e);
		}
	}

}
