package com.yeejoin.amos.iot.business.polling.test;

import com.yeejoin.amos.iot.business.constants.IotConstant;
import com.yeejoin.amos.iot.business.controller.param.TestEqpParam;
import com.yeejoin.amos.iot.business.dao.mapper.DeviceMapper;
import com.yeejoin.amos.iot.business.dao.mapper.MonitorMapper;
import com.yeejoin.amos.iot.business.dao.repository.*;
import com.yeejoin.amos.iot.business.entity.Capability;
import com.yeejoin.amos.iot.business.entity.Intfc;
import com.yeejoin.amos.iot.business.entity.MetricData;
import com.yeejoin.amos.iot.business.entity.mybatis.CapacityPropertyDataVo;
import com.yeejoin.amos.iot.business.enums.CapabilityAttributeType;
import com.yeejoin.amos.iot.core.util.DateUtil;
import net.sf.json.JSONObject;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.collections.MapUtils;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.*;

@Service
public class Test123Service {

    /**
     * 日志记录器
     */
    private static final Logger logger = Logger.getLogger(Test123Service.class);

    @Autowired
    private MonitorMapper monitorMapper;

    @Autowired
    private DeviceMapper deviceMapper;

    @Autowired
    private IIntfcAttributeDao intfcAttributeDao;

    @Autowired
    private IMetricDataDao metricDataDao;

    @Autowired
    private IEquipmentDao iEquipmentDao;

    @Autowired
    private IIntfcDao intfcDao;

    @Autowired
    private ICapabilityDao iCapabilityDao;

    /**
     * 模拟数据测试
     *
     * @param
     */
    @SuppressWarnings("unchecked")
    public void test123(TestEqpParam testEqpParam, String token, String flag) {
        Test123 test123 = new Test123();
        Long eqpId = 9991L;
        // Equipment equipment = iEquipmentDao.getOne(eqpId);
        if (IotConstant.EquipmentConstant.CONNECT.equals(flag)
                && MapUtils.isNotEmpty(testEqpParam.getPropertyMap())) {
            List<String> intfcIdStrs = (List<String>) testEqpParam
                    .getPropertyMap().get("selIntfcIds");
            if (CollectionUtils.isNotEmpty(intfcIdStrs)) {
                int finishedCount = 0;
                int totalIntfcCount = intfcIdStrs.size();
                for (int i = 0; i < totalIntfcCount; i++) {
                    finishedCount++;
                    long intfcId = Long.valueOf(intfcIdStrs.get(i));
                    Intfc intfc = intfcDao.findById(intfcId).get();
                    TestIntfc testIntfc = new TestIntfc();
                    testIntfc.setId(intfc.getId());
                    testIntfc.setName(intfc.getName());
                    testIntfc.setResult("ok");
                    test123.finishOneIntfc(testIntfc, token, finishedCount,
                            totalIntfcCount);
                    try {
                        Thread.sleep(2000);
                    } catch (InterruptedException e) {
                        logger.error(e);
                    }
                }
            }
        }
        if (IotConstant.EquipmentConstant.METRIC.equals(flag)
                && MapUtils.isNotEmpty(testEqpParam.getPropertyMap())) {
            List<String> selCpblIdStrs = (List<String>) testEqpParam
                    .getPropertyMap().get("selCpblIds");
            Map<String, List<Integer>> cpblAttrMap = (Map<String, List<Integer>>) testEqpParam
                    .getPropertyMap().get("quotaSelected");
            if (CollectionUtils.isNotEmpty(selCpblIdStrs)) {
                if (testEqpParam.getBasicInfo().getEqpTmplId() == 1) {
                    //融合终端
                    eqpId = 9991L;
                }else if(testEqpParam.getBasicInfo().getEqpTmplId() == 4){
                    //云服务器
                    eqpId = 9993L;
                }
                List<MetricData> metricDatas = metricDataDao.findByEqpId(eqpId);
                Map<Long, MetricData> mericDataMap = new HashMap<Long, MetricData>();
                if (CollectionUtils.isNotEmpty(metricDatas)) {
                    metricDatas.forEach(md -> {
                        mericDataMap.put(md.getCpblId(), md);
                    });
                }
                int finishedCount = 0;
                int totalCpblCount = selCpblIdStrs.size();
                for (int i = 0; i < totalCpblCount; i++) {
                    finishedCount++;
                    long cpblId = Long.valueOf(selCpblIdStrs.get(i));
                    Capability capability = iCapabilityDao.findById(cpblId).get();
                    TestCapablility testCapablility = new TestCapablility();
                    testCapablility.setId(capability.getId());
                    testCapablility.setName(capability.getName());
                    MetricData metricData = mericDataMap
                            .get(capability.getId());
                    if (metricData != null) {
                        metricData.setExeTime(new Date());
                        List<Long> cpblIds = new ArrayList<Long>();
                        cpblIds.add(capability.getId());
                        List<CapacityPropertyDataVo> cpblAttrs = deviceMapper
                                .getCapacityPropertyByCpblIds(cpblIds);
                        List<TestCpblAttr> attributes = buildTestCpblAttr(
                                metricData.getMetricJson(), cpblAttrs,
                                capability.getId(), cpblAttrMap);
                        testCapablility.setAttributes(attributes);
                    }
                    test123.finishOneCpbl(testCapablility, token,
                            finishedCount, totalCpblCount);
                    try {
                        Thread.sleep(1000);
                    } catch (InterruptedException e) {
                        logger.error(e);
                    }
                }
            }
        }
    }

    /**
     * 构建测试指标属性数据
     *
     * @param metricJson
     * @param cpblAttrs
     * @param cpblId
     * @param cpblAttrMap
     * @return
     */
    @SuppressWarnings("unchecked")
    private List<TestCpblAttr> buildTestCpblAttr(String metricJson,
                                                 List<CapacityPropertyDataVo> cpblAttrs, Long cpblId,
                                                 Map<String, List<Integer>> cpblAttrMap) {
        List<TestCpblAttr> testCpblAttrs = new ArrayList<TestCpblAttr>();
        Map<String, Object> dataMap = (Map<String, Object>) JSONObject.toBean(
                JSONObject.fromObject(metricJson), Map.class);
        if (MapUtils.isEmpty(dataMap)) {
            return testCpblAttrs;
        }
        Set<Long> cpblAttrIds = new HashSet<Long>();
        List<Integer> ss = cpblAttrMap.get(cpblId + "");
        if (CollectionUtils.isNotEmpty(ss)) {
            ss.forEach(s -> {
                cpblAttrIds.add(Long.valueOf(s));
            });
        }
        for (CapacityPropertyDataVo item : cpblAttrs) {
            if (item.getType().intValue() != CapabilityAttributeType.CONSTANT
                    .getValue()) {
                if (CollectionUtils.isEmpty(cpblAttrIds)
                        || cpblAttrIds.contains(item.getId())) {
                    Object objValue = dataMap.get(item.getName());
                    String attrValue = objValue == null ? "" : objValue
                            .toString();
                    TestCpblAttr testCpblAttr = new TestCpblAttr();
                    if ("formatTime".equals(item.getName())) {
                        testCpblAttr.setId(item.getId());
                        testCpblAttr.setName(item.getDisplayName());
                        testCpblAttr.setValue(DateUtil.getLongCurrentDate());
                    } else {
                        testCpblAttr.setId(item.getId());
                        testCpblAttr.setName(item.getDisplayName());
                        testCpblAttr.setValue(attrValue);
                    }
                    testCpblAttrs.add(testCpblAttr);
                }
            }
        }
        return testCpblAttrs;
    }

}
