package com.yeejoin.amos.iot.business.polling.test;

import java.util.HashMap;
import java.util.Map;

import org.apache.log4j.Logger;

import com.yeejoin.amos.iot.business.constants.IotConstant;

/**
 * 保存一次测试设备结果数据
 * 
 * @author tianbo
 *
 */
public class TestResultStoreUtil {
	
	/**
     * 日志记录器
     */
    private static final Logger logger = Logger
            .getLogger(TestResultStoreUtil.class);
	
    /**
     * 单例
     */
    private static TestResultStoreUtil instance;
    
    /**
     * 保存测试结果
     */
    private static Map<String, Object> resultMap = new HashMap<String, Object>();
    
    /**
     * 返回结果集
     * @return
     */
    public Map<String, Object> getResultMap() {
		return resultMap;
	}

	/**
     * 构造方法
     */
    private TestResultStoreUtil() {
        logger.debug(IotConstant.CONSTRUCTOR);
    }
	
    /**
     * 获取单例
     *
     * @return
     */
    public static TestResultStoreUtil getInstance() {
        if (instance == null) {
            synchronized (TestResultStoreUtil.class) {
                if (instance == null) {
                    instance = new TestResultStoreUtil();
                }
            }
        }
        return instance;
    }
  
}
