package com.yeejoin.amos.iot.business.remote;

import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import com.yeejoin.amos.component.feign.model.FeignClientResult;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.typroject.tyboot.core.foundation.context.RequestContext;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.google.common.collect.Lists;
import com.yeejoin.amos.component.feign.config.InnerInvokException;
import com.yeejoin.amos.feign.privilege.Privilege;
import com.yeejoin.amos.feign.privilege.model.AgencyUserModel;
import com.yeejoin.amos.feign.privilege.model.CompanyModel;
import com.yeejoin.amos.feign.privilege.model.DepartmentModel;
import com.yeejoin.amos.feign.systemctl.Systemctl;
import com.yeejoin.amos.feign.systemctl.model.DictionarieValueModel;
import com.yeejoin.amos.iot.business.param.ReginParams;
import com.yeejoin.amos.op.core.common.response.CommonResponse;

@Service("remoteSecurityService")
public class RemoteSecurityService {
	
    private static final Logger log = org.apache.log4j.Logger.getLogger(RemoteSecurityService.class);

	@Autowired
	protected HttpServletRequest request;

	public List<DepartmentModel> getDepartmentTreeByCompanyId(String toke,String product,String appKey,String companyId) {
		if (companyId == null || companyId.equals("")) {
			return null;
		}

		RequestContext.setToken(toke);
		RequestContext.setProduct(product);
		RequestContext.setAppKey(appKey);
		List<DepartmentModel> departmentModel=null;
		FeignClientResult feignClientResult;
		try {
			feignClientResult = Privilege.departmentClient.queryDeptTree(null,Long.valueOf(companyId));
			departmentModel = (List<DepartmentModel>)feignClientResult.getResult();

		} catch (InnerInvokException e) {
			e.printStackTrace();
		}
		return departmentModel;
		// CommonResponse commonResponse = iAmosSecurityServer.getDepartmentTreeByCompanyId(companyId);
		// return handleArray(commonResponse, DepartmentBo.class);
	}

	/**
	 * 当前登录用户信息
	 */
	public AgencyUserModel getUserInfo() {

		try {
			String token = request.getHeader("token");
			String product = request.getHeader("product");
			String appKey = request.getHeader("appKey");
			RequestContext.setToken(token);
			RequestContext.setProduct(product);
			RequestContext.setAppKey(appKey);
			AgencyUserModel result = Privilege.agencyUserClient.getme().getResult();
			return result;
		} catch (InnerInvokException e) {
			System.err.println("get user info fail");
		}
		return null;

	}
	
    public String getUserId() {
		return getUserInfo().getUserId();
	}

}
