package com.yeejoin.amos.iot.business.service.impl;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.stereotype.Service;

import com.yeejoin.amos.iot.business.dao.mapper.Capacity_Intfc_protocolMapper;
import com.yeejoin.amos.iot.business.dao.repository.ICapabilityDao;
import com.yeejoin.amos.iot.business.entity.Capability;
import com.yeejoin.amos.iot.business.entity.EquipmentTemplate;
import com.yeejoin.amos.iot.business.service.intfc.ICapabilityService;
import com.yeejoin.amos.op.core.entity.Resource;
import com.yeejoin.amos.op.core.entity.handler.EntityChangeHandler;
import com.yeejoin.amos.op.core.jpa.GenericManagerImpl;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 
 * <pre>
 * 设备能力Service实现
 * </pre>
 *
 * @author as-guowubin
 * @version $Id: CapabilityServiceImpl.java, v 0.1 2018年5月4日 下午5:12:47 as-guowubin Exp $
 */
@Service("CapabilityService")
public class CapabilityServiceImpl 
implements ICapabilityService
{

	@Autowired
	private ICapabilityDao iCapabilityDao;
	
	@Autowired
	private Capacity_Intfc_protocolMapper capacity_Intfc_protocolMapper;
	
	@Override
	public void delCapabilityById(Long id)
	{
		EntityChangeHandler.fireResourceReomoved(iCapabilityDao.getOne(id));
		iCapabilityDao.delCapabilityById(id);
		capacity_Intfc_protocolMapper.delCaIntfProRelation(id);
	}
	
//	@Override
	public void fireResourceReomoved(Resource resource)
	{
		if (resource instanceof EquipmentTemplate)
		{
			EquipmentTemplate device = (EquipmentTemplate)resource;
			Specification<Capability> capabilitySpec = new Specification<Capability>() {
				public Predicate toPredicate(Root<Capability> root, CriteriaQuery<?> query, CriteriaBuilder cb) {
					List<Predicate> list = new ArrayList<Predicate>();
					Predicate id = cb.equal(root.get("eqpTmpl").as(EquipmentTemplate.class), device);
					list.add(id);
					Predicate[] p = new Predicate[list.size()];
					return cb.and(list.toArray(p));
				}
			};
			List<Capability> capabilities = iCapabilityDao.findAll(capabilitySpec);
			if (capabilities != null) {
				for (Capability capability : capabilities) {
					delCapabilityById(capability.getId());
				}
			}
		}
	}

	@Override
	public List<Capability> findByEqpTmpl(Long id) {
		return iCapabilityDao.findByEqpTmplId(id);
	}

	@Override
	public Capability findOne(Long cpblId) {
		return iCapabilityDao.getOne(cpblId);
	}

}
