package com.yeejoin.amos.iot.business.service.impl;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.stereotype.Service;

import com.yeejoin.amos.iot.business.dao.repository.ICapabilityInterfaceDao;
import com.yeejoin.amos.iot.business.entity.Capability;
import com.yeejoin.amos.iot.business.entity.CapabilitylInterface;
import com.yeejoin.amos.iot.business.entity.Intfc;
import com.yeejoin.amos.iot.business.service.intfc.ICapacityInterfaceService;
import com.yeejoin.amos.op.core.entity.Resource;
import com.yeejoin.amos.op.core.entity.handler.EntityChangeHandler;
import com.yeejoin.amos.op.core.jpa.GenericManagerImpl;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 
 * <pre>
 * 能力接口
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: CapacityInterfaceServiceImpl.java, v 0.1 2018年5月29日 下午5:55:32 as-chenjiajun Exp $
 */
@Service
public class CapacityInterfaceServiceImpl 
implements ICapacityInterfaceService
{
	@Autowired
	private ICapabilityInterfaceDao iCapabilitylInterfaceDao;

	@Override
	public void deleteCapacityInterface(Long id) {
		iCapabilitylInterfaceDao.delCapabilitylInterfaceById(id);
	}
	
//	@Override
	public void fireResourceReomoved(Resource resource)
	{
		if (resource instanceof Capability)
		{
			Capability capacity = (Capability)resource;
			Specification<CapabilitylInterface> capabilityIntfcSpec = new Specification<CapabilitylInterface>() {
				public Predicate toPredicate(Root<CapabilitylInterface> root, CriteriaQuery<?> query,
						CriteriaBuilder cb) {
					List<Predicate> list = new ArrayList<Predicate>();
					Predicate id = cb.equal(root.get("cpblId").as(Long.class), capacity.getId());
					list.add(id);
					Predicate[] p = new Predicate[list.size()];
					return cb.and(list.toArray(p));
				}
			};
			List<CapabilitylInterface> capabilitylInterfaces = iCapabilitylInterfaceDao
					.findAll(capabilityIntfcSpec);
			if (capabilitylInterfaces != null) {
				capabilitylInterfaces.forEach(i->iCapabilitylInterfaceDao.delCapabilitylInterfaceById(i.getId()));
			}
		} else if (resource instanceof Intfc)
		{
			Intfc intfc = (Intfc)resource;
			List<CapabilitylInterface> capabilitylInterfaces = iCapabilitylInterfaceDao.getCapacityIntfcByIntfc(intfc.getId());
			if (capabilitylInterfaces != null)
			{
				capabilitylInterfaces.forEach(i->iCapabilitylInterfaceDao.delCapabilitylInterfaceById(i.getId()));
			}
		}
	}

}
