/**
 * 
 */
package com.yeejoin.amos.iot.business.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.log4j.Logger;

import com.yeejoin.amos.iot.business.constants.IotConstant;
import com.yeejoin.amos.iot.business.entity.CapabilityAttribute;
import com.yeejoin.amos.iot.business.entity.mybatis.CapacityPropertyDataVo;
import com.yeejoin.amos.iot.netty.vehicle.dic.VehicleDic.CommonDic;

import net.sf.json.JSONObject;

/**
 * 设备服务助手类
 * 
 * @author as-youjun
 *
 */
public class DeviceServiceHelper {

	private DeviceServiceHelper() {
		Logger.getLogger(CommonDic.class).debug(IotConstant.CONSTRUCTOR);
	}

	/**
	 * 构建能指标数据
	 * 
	 * @param json
	 * @param capabilityAttributes
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public static Map<String, String> buildCpblAttrData(String json,
			List<CapacityPropertyDataVo> capabilityAttributes) {
		Map<String, String> dataMap = new HashMap<>();
		if (CollectionUtils.isNotEmpty(capabilityAttributes)) {
			Map<String, Object> sourceDataMap = (Map<String, Object>) JSONObject.toBean(JSONObject.fromObject(json),
					Map.class);
			// Map<能力属性英文名,能力属性中文名>
			Map<String, String> attrNameMap = new HashMap<>();
			capabilityAttributes.forEach(attr -> {
				attrNameMap.put(attr.getName(), attr.getDisplayName());
			});
			//
			sourceDataMap.forEach((key, value) -> {
				if (StringUtils.isNotEmpty(attrNameMap.get(key))) {
					dataMap.put(attrNameMap.get(key), value == null ? "" : value.toString());
				}
			});
		}
		return dataMap;
	}
	/**
	 * 构建能指标数据
	 * 
	 * @param json
	 * @param capabilityAttributes
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public static Map<String, String> buildCpblAttrDatas(String json,
			List<CapabilityAttribute> capabilityAttributes) {
		Map<String, String> dataMap = new HashMap<>();
		if (CollectionUtils.isNotEmpty(capabilityAttributes)) {
			Map<String, Object> sourceDataMap = (Map<String, Object>) JSONObject.toBean(JSONObject.fromObject(json),
					Map.class);
			// Map<能力属性英文名,能力属性中文名>
			Map<String, String> attrNameMap = new HashMap<>();
			capabilityAttributes.forEach(attr -> {
				attrNameMap.put(attr.getName(), attr.getDisplayName());
			});
			//
			sourceDataMap.forEach((key, value) -> {
				if (StringUtils.isNotEmpty(attrNameMap.get(key))) {
					dataMap.put(attrNameMap.get(key), value == null ? "" : value.toString());
				}
			});
		}
		return dataMap;
	}
	/**
	 * 构建能指标数据
	 * 
	 * @param json
	 * @param capabilityAttributes
	 * @return
	 */
	public static Map<String, Object> buildCpblAttrData(Map<String, Object> sourceDataMap,
			List<CapacityPropertyDataVo> capabilityAttributes) {
		Map<String, Object> dataMap = new HashMap<>();
		if (CollectionUtils.isNotEmpty(capabilityAttributes)) {
			// Map<能力属性英文名,能力属性中文名>
			Map<String, String> attrNameMap = new HashMap<>();
			capabilityAttributes.forEach(attr -> {
				attrNameMap.put(attr.getName(), attr.getDisplayName()+"-"+attr.getUnit());
			});
			sourceDataMap.forEach((key, value) -> {
				if (StringUtils.isNotEmpty(attrNameMap.get(key))) {
					dataMap.put(attrNameMap.get(key), value == null ? "" : value.toString());
				}
			});
		}
		return dataMap;
	}
}
