package com.yeejoin.amos.iot.business.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yeejoin.amos.iot.business.dao.repository.IDroolsRuleDao;
import com.yeejoin.amos.iot.business.entity.DroolsRule;
import com.yeejoin.amos.iot.business.entity.Rule;
import com.yeejoin.amos.iot.business.service.intfc.IDroolsRuleService;
import com.yeejoin.amos.op.core.entity.Resource;
import com.yeejoin.amos.op.core.entity.handler.EntityChangeHandler;
import com.yeejoin.amos.op.core.jpa.GenericManagerImpl;

/**
 * 
 * <pre>
 * drools规则Service实现
 * </pre>
 *
 * @author as-guowubin
 * @version $Id: DroolsRuleServiceImpl.java, v 0.1 2018年4月20日 下午4:25:59 as-guowubin Exp $
 */
@Service("DroolsRuleService")
public class DroolsRuleServiceImpl 
implements IDroolsRuleService
{
	@Autowired
	IDroolsRuleDao droolsRuleDao;
	
//	public DroolsRuleServiceImpl(IDroolsRuleDao droolsRuleDao)
//	{
//		super(droolsRuleDao);
//		this.droolsRuleDao = droolsRuleDao;
//		EntityChangeHandler.addModel(this);
//	}
	
	@Override
	public List<DroolsRule> findByGroupIdAndIsUser(String groupId, Boolean isUser)
	{
		return droolsRuleDao.findByGroupIdAndIsUser(groupId, isUser);
	}


	@Override
	public List<DroolsRule> findByRuleId(String ruleId)
	{
		return droolsRuleDao.findByRuleId(ruleId);
	}

	@Override
	public void delDroolsRuleById(String id)
	{
		droolsRuleDao.delDroolsRuleById(id);
	}
	
//	@Override
	public void fireResourceReomoved(Resource resource)
	{
		if (resource instanceof Rule)
		{
			Rule rule = (Rule)resource;
			//删droolsRule规则
			List<DroolsRule> droolsRuleList = findByRuleId(rule.getId());
			for (DroolsRule droolsRule : droolsRuleList)
			{
				delDroolsRuleById(droolsRule.getId());
			}
		}
	}


	@Override
	public void saveAll(List<DroolsRule> newDroolsRules) {
		droolsRuleDao.saveAll(newDroolsRules);
	}
}
