package com.yeejoin.amos.iot.business.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yeejoin.amos.iot.business.dao.repository.IEqpCpblDao;
import com.yeejoin.amos.iot.business.entity.EquipmentCapability;
import com.yeejoin.amos.iot.business.service.intfc.IEqpCpblService;
import com.yeejoin.amos.op.core.jpa.GenericManagerImpl;

/**
 * 
 * <pre>
 * 设备与能力关联关系服务
 * </pre>
 *
 * @author as-guowubin
 * @version $Id: EqpIntfcServiceImpl.java, v 0.1 2018年6月9日 上午10:50:02 as-guowubin Exp $
 */
@Service("EqpCpblService")
public class EqpCpblServiceImpl 
implements IEqpCpblService
{
	@Autowired
	IEqpCpblDao eqpCpblDao;

//	public EqpCpblServiceImpl(IEqpCpblDao eqpCpblDao)
//	{
//		super(eqpCpblDao);
//		this.eqpCpblDao = eqpCpblDao;
//	}

	@Override
	public List<EquipmentCapability> findByEqpId(Long eqpId)
	{
		return eqpCpblDao.findByEqpId(eqpId);
	}

	@Override
	public void delByEqpId(Long eqpId)
	{
		eqpCpblDao.delByEqpId(eqpId);
	}

	@Override
	public List<EquipmentCapability> findByEpbIdAndCpblId(Long eqpId,Long cpblId)
	{
		return eqpCpblDao.findByEpbIdAndCpblId(eqpId,cpblId);
	}

	@Override
	public void delete(EquipmentCapability equipmentCapability) {
		eqpCpblDao.delete(equipmentCapability);
	}

	@Override
	public void save(EquipmentCapability eqpCapability) {
		eqpCpblDao.save(eqpCapability);
	}
}
