package com.yeejoin.amos.iot.business.service.impl;


import java.util.HashMap;
import java.util.List;
import java.util.stream.Collectors;

import com.yeejoin.amos.iot.business.dao.mapper.EqpTmplAttrMapper;
import com.yeejoin.amos.iot.business.dao.mapper.EqpTmplMapper;
import com.yeejoin.amos.iot.business.dao.repository.IDicDao;
import com.yeejoin.amos.iot.business.dao.repository.IEqpTmplPropertyDao;
import com.yeejoin.amos.iot.business.dao.repository.IEquipTemplateIndustryDao;
import com.yeejoin.amos.iot.business.dic.EquipTemplateIndustry;
import com.yeejoin.amos.iot.business.entity.Dic;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yeejoin.amos.iot.business.dao.repository.IEquipmentTemplateDao;

import com.yeejoin.amos.iot.business.entity.EquipmentTemplate;
import com.yeejoin.amos.iot.business.service.intfc.IEqpTemplService;
import com.yeejoin.amos.iot.core.util.query.BaseQuerySpecification;
import com.yeejoin.amos.op.core.common.query.DaoCriteria;

import javax.annotation.PostConstruct;


/**
 * 
 * <pre>
 * 设备模板服务
 * </pre>
 *
 * @author as-guowubin
 * @version $Id: EqpTemplServiceImpl.java, v 0.1 2018年6月6日 下午5:41:44 as-guowubin Exp $
 */
@Service("EqpTemplService")
public class EqpTemplServiceImpl 
implements IEqpTemplService
{
	
	@Autowired
	IEquipmentTemplateDao equipmentTemplateDao;
	@Autowired
	EqpTmplMapper EqpTmplMapper;
	@Autowired
	IDicDao dicDao;
	@Autowired
	EqpTmplAttrMapper eqpTmplAttrMapper;


	@Override
	public List<EquipmentTemplate> findAll(List<DaoCriteria> daoCriterias) {
		BaseQuerySpecification<EquipmentTemplate> spec = new BaseQuerySpecification<>(daoCriterias);
		return equipmentTemplateDao.findAll(spec);
	}

	@Override
	public List<EquipmentTemplate> findAllMybatis(HashMap<String, Object> param) {
		List<Dic> list = dicDao.findAllByType("EquipTemplateIndustry");
		List<EquipmentTemplate> equipmentTemplates = EqpTmplMapper.findAll(param).stream().map(item->{
			for (Dic dic : list) {
				if (dic.getId() == item.getIndustryId()) {
					item.setEquipTemplateIndustry((EquipTemplateIndustry) dic);
					break;
				}
			}
			item.setAttributes(eqpTmplAttrMapper.findAllByEqpTmplId(item.getId()));
			return item;
		}).collect(Collectors.toList());
		return equipmentTemplates;
	}

	@PostConstruct
	public void test() {
		HashMap<String, Object> paramMap = new HashMap<>();
		paramMap.put("orgCode", "1*2");
		findAllMybatis(paramMap);
	}

	@Override
	public EquipmentTemplate findOne(Long id) {
		return equipmentTemplateDao.getOne(id);
	}

//	public EqpTemplServiceImpl(IEquipmentTemplateDao equipmentTemplateDao)
//	{
//		super(equipmentTemplateDao);
//		this.equipmentTemplateDao = equipmentTemplateDao;
//	}
}
