package com.yeejoin.amos.iot.business.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yeejoin.amos.iot.business.dao.mapper.DeviceMapper;
import com.yeejoin.amos.iot.business.dao.repository.IEqpTmplInterfaceDao;
import com.yeejoin.amos.iot.business.entity.EqpTmplInterface;
import com.yeejoin.amos.iot.business.entity.EquipmentTemplate;
import com.yeejoin.amos.iot.business.entity.Intfc;
import com.yeejoin.amos.iot.business.entity.MetricData;
import com.yeejoin.amos.iot.business.entity.mybatis.DeviceInterfaceDataVo;
import com.yeejoin.amos.iot.business.service.intfc.IEqpTmplInterfaceService;
import com.yeejoin.amos.iot.core.util.query.BaseQuerySpecification;
import com.yeejoin.amos.op.core.common.query.DaoCriteria;
import com.yeejoin.amos.op.core.entity.Resource;
import com.yeejoin.amos.op.core.entity.handler.EntityChangeHandler;
import com.yeejoin.amos.op.core.jpa.GenericManagerImpl;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 
 * <pre>
 * 设备模板接口
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: EqpTmplInterfaceServiceImpl.java, v 0.1 2018年5月29日 下午5:28:09 as-chenjiajun Exp $
 */
@Service
public class EqpTmplInterfaceServiceImpl 
implements IEqpTmplInterfaceService
{
	
	@Autowired
	private IEqpTmplInterfaceDao iEqpTmplInterfaceDao;
	
	@Autowired
	private DeviceMapper deviceMapper;

	@Override
	public void deleteDeviceInterface(Long id) {
		iEqpTmplInterfaceDao.delEqpTmplInterfaceById(id);
	}
	
//	@Override
	public void fireResourceReomoved(Resource resource)
	{
		if (resource instanceof EquipmentTemplate)
		{
			EquipmentTemplate device = (EquipmentTemplate)resource;
			List<DeviceInterfaceDataVo> deviceInterfaceDataVos = deviceMapper.getDeviceInterfaceById(device.getId());
			if (deviceInterfaceDataVos != null) {
				for (DeviceInterfaceDataVo deviceInterfaceDataVo : deviceInterfaceDataVos) {
					iEqpTmplInterfaceDao.delEqpTmplInterfaceById(deviceInterfaceDataVo.getDevIntfcID());
				}
			}
		} else if (resource instanceof Intfc)
		{
			Intfc intfc = (Intfc)resource;
			List<EqpTmplInterface> eqpTmplInterfaces = iEqpTmplInterfaceDao.getDeviceInterfaceByIntfcId(intfc.getId());
			if (eqpTmplInterfaces != null)
			{
				eqpTmplInterfaces.forEach(i->iEqpTmplInterfaceDao.delEqpTmplInterfaceById(i.getId()));
			}
		}
	}

	@Override
	public List<EqpTmplInterface> findAll(List<DaoCriteria> daoCriterias) {
		BaseQuerySpecification<EqpTmplInterface> spec = new BaseQuerySpecification<>(daoCriterias);
		return iEqpTmplInterfaceDao.findAll(spec);
	}

}
