package com.yeejoin.amos.iot.business.service.impl;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.persistence.criteria.CriteriaBuilder;
import javax.persistence.criteria.CriteriaQuery;
import javax.persistence.criteria.Predicate;
import javax.persistence.criteria.Root;

import com.yeejoin.amos.iot.business.dao.mapper.DeviceMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.stereotype.Service;

import com.yeejoin.amos.iot.business.dao.repository.IEqpTmplPropertyDao;
import com.yeejoin.amos.iot.business.entity.EqpTmplAttribute;
import com.yeejoin.amos.iot.business.entity.EquipmentTemplate;
import com.yeejoin.amos.iot.business.service.intfc.IEqpTmplPropertyService;
import com.yeejoin.amos.op.core.entity.Resource;
import com.yeejoin.amos.op.core.entity.handler.EntityChangeHandler;
import com.yeejoin.amos.op.core.jpa.GenericManagerImpl;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 
 * <pre>
 * 设备模板属性
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: EqpTmplPropertyServiceImpl.java, v 0.1 2018年5月29日 下午5:29:55 as-chenjiajun Exp $
 */
@Service
public class EqpTmplPropertyServiceImpl 
implements IEqpTmplPropertyService
{

	@Autowired
	private IEqpTmplPropertyDao iEqpTmplPropertyDao;

	@javax.annotation.Resource
	private DeviceMapper deviceMapper;

	@Override
	public void deleteDeviceProperty(Long id) {
		iEqpTmplPropertyDao.delEqpTmplAttributeById(id);
	}

	@Override
	public List<Map> findAllByTempId(Long eqpId) {
		return deviceMapper.findTempAttr(eqpId);
	}

//	@Override
	public void fireResourceReomoved(Resource resource)
	{
		if (resource instanceof EquipmentTemplate)
		{
			EquipmentTemplate device = (EquipmentTemplate)resource;
			Specification<EqpTmplAttribute> deviceAttrSpec = new Specification<EqpTmplAttribute>() {
				public Predicate toPredicate(Root<EqpTmplAttribute> root, CriteriaQuery<?> query, CriteriaBuilder cb) {
					List<Predicate> list = new ArrayList<Predicate>();
					Predicate id = cb.equal(root.get("eqpTmpl").as(EquipmentTemplate.class), device);
					list.add(id);
					Predicate[] p = new Predicate[list.size()];
					return cb.and(list.toArray(p));
				}
			};
			List<EqpTmplAttribute> eqpTmplAttributes = iEqpTmplPropertyDao.findAll(deviceAttrSpec);
			if (eqpTmplAttributes != null) {
				eqpTmplAttributes.forEach(a->iEqpTmplPropertyDao.delEqpTmplAttributeById(a.getId()));
			}
		}
	}

}
