package com.yeejoin.amos.iot.business.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.yeejoin.amos.iot.business.dao.repository.IEquipmentDao;
import com.yeejoin.amos.iot.business.dao.repository.IIntfcDao;
import com.yeejoin.amos.iot.business.entity.Equipment;
import com.yeejoin.amos.iot.business.entity.Intfc;
import com.yeejoin.amos.iot.business.entity.IntfcAttribute;
import com.yeejoin.amos.iot.business.service.intfc.IEquipmentService;
import com.yeejoin.amos.iot.core.util.query.BaseQuerySpecification;
import com.yeejoin.amos.iot.core.util.query.QuerySpecificationHelper;
import com.yeejoin.amos.op.core.common.query.DaoCriteria;
import com.yeejoin.amos.op.core.entity.handler.EntityChangeHandler;
import com.yeejoin.amos.op.core.jpa.GenericManagerImpl;

/**
 * 
 * <pre>
 * 设备服务
 * </pre>
 *
 * @author as-guowubin
 * @version $Id: EquipmentServiceImpl.java, v 0.1 2018年6月6日 下午6:15:07 as-guowubin Exp $
 */
@Service("EquipmentService")
public class EquipmentServiceImpl 
implements IEquipmentService
{
	@Autowired
	IEquipmentDao equipmentDao;
	
//	public EquipmentServiceImpl(IEquipmentDao equipmentDao)
//	{
//		super(equipmentDao);
//		this.equipmentDao = equipmentDao;
//	}
	
	@Override
	public List<Equipment> findByEqpTmplId(Long eqpTmplId)
	{
		return equipmentDao.findByEqpTmplId(eqpTmplId);
	}

	@Override
	public long countByEqpTmplId(Long eqpTmplId, String orgCode)
	{
		return equipmentDao.countByEqpTmplId(eqpTmplId, orgCode, orgCode+"*%");
	}

	@Override
	public void delEquipmentById(List<Long> ids)
	{
		ids.forEach(i -> {
			EntityChangeHandler.fireResourceReomoved(equipmentDao.findById(i).get());
			equipmentDao.delEquipmentById(i);
		});
	}
	
	@Override
	public Long updateEquipmentAttribute(Equipment equipment) {
		equipment = equipmentDao.save(equipment);
		return equipment == null ? null : equipment.getId();
	}

	@Override
	public boolean checkNameConflict(Equipment equipment)
	{

		Long count = equipmentDao.count(QuerySpecificationHelper.getDuplicationNameEquipment(equipment));
		if (count > 0)
		{			
			return true;
		} else {
			return false;
		}
	}

	@Override
	public Equipment save(Equipment equipment) {
		return equipmentDao.save(equipment);
	}

	@Override
	public Equipment findOne(Long id) {
		return equipmentDao.getOne(id);
	}

	@Override
	public List<Equipment> findAll(List<DaoCriteria> daoCriterias) {
		BaseQuerySpecification<Equipment> spec = new BaseQuerySpecification<>(daoCriterias);
		return equipmentDao.findAll(spec);
	}
}
