package com.yeejoin.amos.iot.business.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yeejoin.amos.iot.business.dao.repository.IIntfcAttributeDao;
import com.yeejoin.amos.iot.business.entity.Intfc;
import com.yeejoin.amos.iot.business.entity.IntfcAttribute;
import com.yeejoin.amos.iot.business.service.intfc.IInterfacePropertyService;
import com.yeejoin.amos.op.core.entity.Resource;
import com.yeejoin.amos.op.core.entity.handler.EntityChangeHandler;
import com.yeejoin.amos.op.core.jpa.GenericManagerImpl;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 
 * <pre>
 * 接口属性
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: InterfacePropertyServiceImpl.java, v 0.1 2018年5月30日 上午10:09:23 as-chenjiajun Exp $
 */
@Service
public class InterfacePropertyServiceImpl 
implements IInterfacePropertyService
{
	@Autowired
	private IIntfcAttributeDao intfcAttributeDao;

	@Override
	public List<IntfcAttribute> getPropertysById(Long id)
	{
		return intfcAttributeDao.getPropertysById(id);
	}
	
	@Override
	public void delOneAttribute(Long id){
		intfcAttributeDao.delIntfcAttributeById(id);
	}
	
	@Override
	public void delAttribute(List<Long> ids){
		List<IntfcAttribute> attributes = intfcAttributeDao.findAllById(ids);
		attributes.forEach(attr -> delOneAttribute(attr.getId()));
	}
	
//	@Override
	public void fireResourceReomoved(Resource resource)
	{
		if (resource instanceof Intfc)
		{
			Intfc intfc = (Intfc)resource;
			List<IntfcAttribute> intfcAttributes = getPropertysById(intfc.getId());
			if (intfcAttributes != null)
			{
				intfcAttributes.forEach(i->intfcAttributeDao.delIntfcAttributeById(i.getId()));
			}
		}
	}
}
