package com.yeejoin.amos.iot.business.service.impl;

import java.util.Collections;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yeejoin.amos.iot.business.dao.repository.ILinkVoDao;
import com.yeejoin.amos.iot.business.entity.LinkVo;
import com.yeejoin.amos.iot.business.entity.NodeVo;
import com.yeejoin.amos.iot.business.entity.Rule;
import com.yeejoin.amos.iot.business.service.intfc.ILinkVoService;
import com.yeejoin.amos.iot.core.util.query.QuerySpecificationHelper;
import com.yeejoin.amos.op.core.entity.Resource;
import com.yeejoin.amos.op.core.entity.handler.EntityChangeHandler;
import com.yeejoin.amos.op.core.jpa.GenericManagerImpl;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 
 * <pre>
 * 视图线路服务实现
 * </pre>
 *
 * @author amos
 * @version $Id: LinkVoServiceImpl.java, v 0.1 2018年1月26日 上午11:16:15 amos Exp $
 */
@Service("LinkVoService")
public class LinkVoServiceImpl 
implements ILinkVoService
{
	@Autowired
	private ILinkVoDao iLinkVoDao;

//	public LinkVoServiceImpl(IBaseRepository<LinkVo, String> repository)
//	{
//		super(repository);
//		EntityChangeHandler.addModel(this);
//	}

	@Override
	public List<LinkVo> findLinkVosbySourceId(String sourceId)
	{
		return iLinkVoDao.findBySourceId(sourceId);
	}

	@Override
	public List<LinkVo> findByRuleId(String id)
	{
		List<LinkVo> linkVos =  iLinkVoDao.findByRuleId(id);
		return linkVos == null ? Collections.emptyList() : linkVos;
	}

	@Override
	public void delLinkVoById(String id)
	{
		iLinkVoDao.delLinkVoById(id);
	}
	
//	@Override
	public void fireResourceReomoved(Resource resource)
	{
		if (resource instanceof Rule)
		{
			Rule rule = (Rule)resource;
			findByRuleId(rule.getId()).forEach(linkVo -> {
				delLinkVoById(linkVo.getId());
			});
			
		} else if (resource instanceof NodeVo)
		{
			//删除线路
			NodeVo nodeVo = (NodeVo)resource;
			List<LinkVo> linkList = iLinkVoDao.findAll(QuerySpecificationHelper.getNodeLinks(nodeVo.getId()));
			linkList.forEach(l->delLinkVoById(l.getId()));
		}
	}

	@Override
	public void save(LinkVo link) {
		iLinkVoDao.save(link);
	}
}