/**
 * 
 */
package com.yeejoin.amos.iot.business.service.impl;

import org.apache.log4j.Logger;

import com.yeejoin.amos.iot.business.constants.IotConstant;
import com.yeejoin.amos.iot.business.entity.Protocol;
import com.yeejoin.amos.iot.business.vo.ProtocolVo;

/**
 * 协议助手类
 * 
 * @author as-youjun
 *
 */
public class ProtocolHelper {

	private ProtocolHelper() {
		Logger.getLogger(this.getClass()).debug(IotConstant.CONSTRUCTOR);
	}

	/**
	 * 构建ProtocolVo
	 * 
	 * @param protocol
	 * @return
	 */
	public static ProtocolVo buildProtocolVo(Protocol protocol) {
		ProtocolVo protocolVo = new ProtocolVo();
		protocolVo.setId(protocol.getId());
		protocolVo.setCreateTime(protocol.getCreateTime());
		protocolVo.setDescription(protocol.getDescr());
		protocolVo.setDicIdScriptLang(protocol.getDicIdScriptLang());
//		protocolVo.setDisplayName(protocol.getDisplayName());
		protocolVo.setIsDelete(protocol.getIsDelete());
		protocolVo.setName(protocol.getName());
		protocolVo.setScriptCode(protocol.getScriptCode());
//		protocolVo.setScriptName(protocol.getScriptLang().getName());
		protocolVo.setUpdateTime(protocol.getUpdateTime());
		protocolVo.setUserId(protocol.getUserId());
		protocolVo.setVisibility(protocol.getVisibility());
		protocolVo.setVersion(protocol.getVersion());
		return protocolVo;
	}

}
