package com.yeejoin.amos.iot.business.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yeejoin.amos.iot.business.dao.repository.IRuleEmailDao;
import com.yeejoin.amos.iot.business.entity.NodeVo;
import com.yeejoin.amos.iot.business.entity.RuleEmail;
import com.yeejoin.amos.iot.business.enums.RuleNodeType;
import com.yeejoin.amos.iot.business.service.intfc.IRuleEmailService;
import com.yeejoin.amos.op.core.entity.Resource;
import com.yeejoin.amos.op.core.entity.handler.EntityChangeHandler;
import com.yeejoin.amos.op.core.jpa.GenericManagerImpl;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 
 * <pre>
 * 规则视图中email信息Service实现
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: RuleEmailServiceImpl.java, v 0.1 2018年4月10日 下午3:57:46 as-chenjiajun Exp $
 */
@Service("ruleEmailService")
public class RuleEmailServiceImpl 
implements IRuleEmailService
{
	
	@Autowired
	private IRuleEmailDao iRuleEmailDao;

	@Override
	public void delRuleEmailById(String id)
	{
		iRuleEmailDao.delRuleEmailById(id);
	}

//	@Override
	public void fireResourceReomoved(Resource resource)
	{
		if (resource instanceof NodeVo)
		{
			NodeVo nodeVo = (NodeVo) resource;
			if (RuleNodeType.OUTPUT_EMAIL.equals(nodeVo.getType()))
			{
				String key = nodeVo.getViewKey();
				if (key != null)
				{
					delRuleEmailById(key);
				}
			}
		}}

	@Override
	public RuleEmail findOne(String id) {
		return iRuleEmailDao.getOne(id);
	}

	@Override
	public RuleEmail save(RuleEmail ruleEmail) {
		return iRuleEmailDao.save(ruleEmail);
	}
}
