package com.yeejoin.amos.iot.business.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yeejoin.amos.iot.business.dao.repository.IRuleMqttDao;
import com.yeejoin.amos.iot.business.entity.NodeVo;
import com.yeejoin.amos.iot.business.entity.RuleMqtt;
import com.yeejoin.amos.iot.business.enums.RuleNodeType;
import com.yeejoin.amos.iot.business.service.intfc.IRuleMqttService;
import com.yeejoin.amos.op.core.entity.Resource;
import com.yeejoin.amos.op.core.entity.handler.EntityChangeHandler;
import com.yeejoin.amos.op.core.jpa.GenericManagerImpl;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 
 * <pre>
 * 规则视图中mqtt信息Service实现
 * </pre>
 *
 * @author as-guowubin
 * @version $Id: RuleMqttServiceImpl.java, v 0.1 2018年5月4日 下午2:34:31 as-guowubin Exp $
 */
@Service("RuleMqttService")
public class RuleMqttServiceImpl 
implements IRuleMqttService
{
	
	@Autowired
	private IRuleMqttDao iRuleMqttDao;

	@Override
	public void delRuleMqttById(String id)
	{
		iRuleMqttDao.delRuleMqttById(id);
	}
	
//	@Override
	public void fireResourceReomoved(Resource resource)
	{
		if (resource instanceof NodeVo)
		{
			NodeVo nodeVo = (NodeVo) resource;
			if (RuleNodeType.OUTPUT_MQTT.equals(nodeVo.getType()))
			{
				String key = nodeVo.getViewKey();
				if (key != null)
				{
					delRuleMqttById(key);
				}
			}
		}
	}

	@Override
	public RuleMqtt findOne(String id) {
		return iRuleMqttDao.getOne(id);
	}

	@Override
	public RuleMqtt save(RuleMqtt ruleMqtt) {
		return iRuleMqttDao.save(ruleMqtt);
	}
}
