package com.yeejoin.amos.iot.business.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yeejoin.amos.iot.business.dao.repository.IRuleTcpDao;
import com.yeejoin.amos.iot.business.entity.NodeVo;
import com.yeejoin.amos.iot.business.entity.RuleTcp;
import com.yeejoin.amos.iot.business.enums.RuleNodeType;
import com.yeejoin.amos.iot.business.service.intfc.IRuleTcpService;
import com.yeejoin.amos.op.core.entity.Resource;
import com.yeejoin.amos.op.core.entity.handler.EntityChangeHandler;
import com.yeejoin.amos.op.core.jpa.GenericManagerImpl;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 
 * <pre>
 * 规则视图中ftp信息Service实现
 * </pre>
 *
 * @author as-guowubin
 * @version $Id: RuleFtpServiceImpl.java, v 0.1 2018年5月4日 下午2:32:17 as-guowubin Exp $
 */
@Service("RuleTcpService")
public class RuleTcpServiceImpl 
implements IRuleTcpService
{
	@Autowired
	private IRuleTcpDao iRuleTcpDao;

	@Override
	public void delRuleTcpById(String id)
	{
		iRuleTcpDao.delRuleTcpById(id);
	}
	
//	@Override
	public void fireResourceReomoved(Resource resource)
	{
		if (resource instanceof NodeVo)
		{
			NodeVo nodeVo = (NodeVo) resource;
			if (RuleNodeType.OUTPUT_TCP.equals(nodeVo.getType()))
			{
				String key = nodeVo.getViewKey();
				if (key != null)
				{
					delRuleTcpById(key);
				}
			}
		}}

	@Override
	public RuleTcp findOne(String id) {
		return iRuleTcpDao.getOne(id);
	}

	@Override
	public RuleTcp save(RuleTcp ruleTcp) {
		// TODO Auto-generated method stub
		return null;
	}

}
