package com.yeejoin.amos.iot.business.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;

import com.yeejoin.amos.iot.business.dao.repository.ISectionDao;
import com.yeejoin.amos.iot.business.entity.Section;
import com.yeejoin.amos.iot.business.param.SectionParam;
import com.yeejoin.amos.iot.business.service.intfc.ISectionService;
import com.yeejoin.amos.iot.core.util.query.QuerySpecificationHelper;
import com.yeejoin.amos.op.core.common.query.CommonPageable;
import com.yeejoin.amos.op.core.jpa.GenericManagerImpl;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 
 * <pre>
 * 插件管理
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: SectionServiceImpl.java, v 0.1 2018年6月27日 下午2:11:53 as-chenjiajun Exp $
 */
@Service("sectionService")
public class SectionServiceImpl 
implements ISectionService
{
	@Autowired
	private ISectionDao sectionDao;

	@Override
	public List<Section> getSectionsByCondition(SectionParam param)
	{
		List<Section> sections = sectionDao.findAll(QuerySpecificationHelper.getSectionParam(param));
		return sections;
	}

	@Override
	public List<Section> getSectionsByCondition(SectionParam param, int count)
	{
		Pageable pageable = new CommonPageable(0,count,new Sort(Sort.Direction.DESC,"createTime"));
		Page<Section> sections = sectionDao.findAll(QuerySpecificationHelper.getSectionParam(param),pageable);
		return sections.getContent();
	}
	
}
