package com.yeejoin.amos.iot.business.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yeejoin.amos.iot.business.dao.repository.IConnectionDao;
import com.yeejoin.amos.iot.business.entity.Connection;
import com.yeejoin.amos.iot.business.entity.Subgraph;
import com.yeejoin.amos.iot.business.service.intfc.ITopoConnectionService;
import com.yeejoin.amos.op.core.entity.Resource;
import com.yeejoin.amos.op.core.entity.handler.EntityChangeHandler;
import com.yeejoin.amos.op.core.jpa.GenericManagerImpl;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 
 * <pre>
 * 实时监测连线
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: TopoConnectionServiceImpl.java, v 0.1 2018年5月29日 下午2:02:38 as-chenjiajun Exp $
 */
@Service
public class TopoConnectionServiceImpl 
implements ITopoConnectionService
{
	
	@Autowired
	private IConnectionDao iConnectionDao;

	@Override
	public void deleteConnections(List<Long> ids) {
		for (Long id : ids) {
			iConnectionDao.delConnectionById(id);
		}
	}
	
	@Override
	public void delConnection(Long id) {
		iConnectionDao.delConnectionById(id);
	}
	
	@Override
	public Long addOrEditConnection(Connection connection) {
		connection = iConnectionDao.save(connection);
		return connection == null ? null : connection.getId();
	}
	
//	@Override
	public void fireResourceReomoved(Resource resource)
	{
		if (resource instanceof Subgraph)
		{
			Subgraph subgraph = (Subgraph)resource;
			List<Connection> connections = subgraph.getConnections();
			if (connections != null)
			{
				connections.forEach(i->iConnectionDao.delConnectionById(i.getId()));
			}
		}
	}

}
