package com.yeejoin.amos.iot.business.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yeejoin.amos.iot.business.dao.repository.INodeDao;
import com.yeejoin.amos.iot.business.entity.Equipment;
import com.yeejoin.amos.iot.business.entity.Node;
import com.yeejoin.amos.iot.business.entity.Subgraph;
import com.yeejoin.amos.iot.business.service.intfc.ITopoNodeService;
import com.yeejoin.amos.op.core.entity.Resource;
import com.yeejoin.amos.op.core.entity.handler.EntityChangeHandler;
import com.yeejoin.amos.op.core.jpa.GenericManagerImpl;
import com.yeejoin.amos.op.core.jpa.IBaseRepository;

/**
 * 
 * <pre>
 * 实时监测节点
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: TopoNodeServiceImpl.java, v 0.1 2018年5月29日 下午2:02:28 as-chenjiajun Exp $
 */
@Service
public class TopoNodeServiceImpl 
implements ITopoNodeService
{
	
	@Autowired
	private INodeDao iNodeDao;

	@Override
	public Long addOrEditNode(Node node) {
		node = iNodeDao.save(node);
		return node == null ? null : node.getId();
	}
	
	@Override
	public void delNodeById(Long id)
	{
//		EntityChangeHandler.fireResourceReomoved(findOne(id));
		iNodeDao.delNodeById(id);
	}
	
//	@Override
	public void fireResourceReomoved(Resource resource)
	{
		if (resource instanceof Subgraph)
		{
			Subgraph subgraph = (Subgraph)resource;
			List<Node> nodes = subgraph.getNodes();
			if (nodes != null)
			{
				nodes.forEach(i->delNodeById(i.getId()));
			}
		} else if (resource instanceof Equipment)
		{
			Equipment equipment = (Equipment)resource;
			List<Node> nodes = iNodeDao.findNodByEquipmentId(equipment.getId());
			if (nodes != null && nodes.size() > 0)
			{
				nodes.forEach(item -> {
					iNodeDao.deleteById(item.getId());
				});
			}
		}
	}

	@Override
	public List<Node> findNodByEquipmentId(Long equipmentId)
	{
		return iNodeDao.findNodByEquipmentId(equipmentId);
	}

	@Override
	public void save(Node node) {
		iNodeDao.save(node);
	}

}
