package com.yeejoin.amos.iot.business.service.intfc;

import com.yeejoin.amos.iot.business.entity.Alarm;
import com.yeejoin.amos.iot.business.param.DeleteAlarmParam;
import com.yeejoin.amos.iot.core.common.request.CommonPageable;
import com.yeejoin.amos.op.core.common.query.DaoCriteria;
import com.yeejoin.amos.op.core.jpa.IGenericManager;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 告警service接口
 *
 * @author as-youjun
 */
public interface IAlarmService //extends IGenericManager<Alarm, Long> 
{

    /**
     * 分页带条件查询告警数据
     *
     * @param criterias，pageable
     * @return Page<Alarm>
     */
    Map<String, Object> findAllByParam(List<DaoCriteria> criterias, CommonPageable pageable);

    /**
     * 清除告警数据（只改变数据状态）
     *
     * @param requests
     */
    void deleteAlarm(DeleteAlarmParam requests);

    /**
     * 处理产生的告警
     *
     * @param alarm
     */
    void raise(Alarm alarm, boolean isClear);


    Map<String, Object> queryPresentAlarmStatic(List<DaoCriteria> daoCriterias);

    /**
     * <pre>
     * 获取设备的所有告警
     * </pre>
     *
     * @param id
     * @return
     */
    List<Alarm> getAlarmsByEqpId(Long id);

    Map<String, Object> alarmStaticByStatus(String orgCode);

    List queryAlarmByEquipAttr(HashMap<String, Object> param);
}
