package com.yeejoin.amos.iot.business.service.intfc;

import java.util.List;

import com.yeejoin.amos.iot.business.entity.DroolsRule;
import com.yeejoin.amos.op.core.jpa.IGenericManager;

/**
 * 
 * <pre>
 * drools规则service接口
 * </pre>
 *
 * @author as-guowubin
 * @version $Id: IDroolsRuleService.java, v 0.1 2018年4月20日 下午4:24:51 as-guowubin Exp $
 */
public interface IDroolsRuleService 
{
	/**
	 * 
	 * <pre>
	 * 根据组id查询已启用的drools规则
	 * </pre>
	 *
	 * @param groupId
	 * @param isUser
	 * @return
	 */
	List<DroolsRule> findByGroupIdAndIsUser(String groupId, Boolean isUser);
	/**
	 * 
	 * <pre>
	 * 根据s所属规则id查询drools规则
	 * </pre>
	 *
	 * @param ruleId
	 * @return
	 */
	List<DroolsRule> findByRuleId(String ruleId);
	
	/**
	 * 
	 * <pre>
	 * delete
	 * </pre>
	 *
	 * @param id
	 */
	void delDroolsRuleById(String id);
	void saveAll(List<DroolsRule> newDroolsRules);

}
