package com.yeejoin.amos.iot.business.service.intfc;

import java.util.List;

import com.yeejoin.amos.iot.business.entity.EqpCpblProperty;
import com.yeejoin.amos.op.core.jpa.IGenericManager;

/**
 * 
 * <pre>
 * 设备能力属性上下限service
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: IEqpCpblPropertyService.java, v 0.1 2018年7月12日 上午9:33:56 as-chenjiajun Exp $
 */
public interface IEqpCpblPropertyService
{
	/**
	 * 
	 * <pre>
	 * 删除设备的所有门限配置信息
	 * </pre>
	 *
	 * @param eqpId 设备id
	 */
	void deleteByEqpId(Long eqpId);

	/**
	 * 
	 * <pre>
	 * 查询设备的所有门限配置信息
	 * </pre>
	 *
	 * @param eqpId
	 * @return
	 */
	List<EqpCpblProperty> findInfoByEqpId(Long eqpId);

	/**
	 * 
	 * <pre>
	 * 查询设备及能力查询门限配置信息
	 * </pre>
	 *
	 * @param eqpId
	 * @param cpblId
	 * @return
	 */
	List<EqpCpblProperty> findByEqpIdAndCpblId(Long eqpId, Long cpblId);

	void saveAll(List<EqpCpblProperty> thresholdList);

	void delete(EqpCpblProperty eqpCpblProperty);
}
