package com.yeejoin.amos.iot.business.service.intfc;

import java.util.List;

import com.yeejoin.amos.iot.business.entity.Equipment;
import com.yeejoin.amos.op.core.common.query.DaoCriteria;
import com.yeejoin.amos.op.core.jpa.IGenericManager;

/**
 * 
 * <pre>
 * 设备服务接口
 * </pre>
 *
 * @author as-guowubin
 * @version $Id: IEquipmentService.java, v 0.1 2018年6月6日 下午6:13:24 as-guowubin Exp $
 */
public interface IEquipmentService 
{
	/**
	 * 
	 * <pre>
	 * 根据eqpTmplId查询
	 * </pre>
	 *
	 * @param eqpTmplId
	 * @return
	 */
	List<Equipment> findByEqpTmplId(Long eqpTmplId);
	/**
	 * 
	 * <pre>
	 * 根据eqpTmplId查询设备数量
	 * </pre>
	 *
	 * @param eqpTmplId
	 * @return
	 */
	long countByEqpTmplId(Long eqpTmplId, String orgCode);
	
	/**
	 * 
	 * <pre>
	 * 假删除
	 * </pre>
	 *
	 * @param ids
	 */
	void delEquipmentById(List<Long> ids);
	
	/**
	 * 
	 * <pre>
	 * 视图中保存设备属性
	 * </pre>
	 *
	 * @param equipment
	 * @return
	 */
	Long updateEquipmentAttribute(Equipment equipment);
	
	/**
	 * 
	 * <pre>
	 * 检查名称重复
	 * </pre>
	 *
	 * @param equipment
	 * @return
	 */
	boolean checkNameConflict(Equipment equipment);
	Equipment save(Equipment equipment);
	Equipment findOne(Long id);
	List<Equipment> findAll(List<DaoCriteria> daoCriterias);
}
