package com.yeejoin.amos.iot.business.service.intfc;

import java.util.List;
import java.util.Map;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import com.yeejoin.amos.iot.business.entity.Intfc;
import com.yeejoin.amos.iot.business.entity.IntfcAttribute;
import com.yeejoin.amos.iot.business.exceptions.IntfcException;
import com.yeejoin.amos.op.core.common.query.DaoCriteria;
import com.yeejoin.amos.op.core.jpa.IGenericManager;

/**
 * 
 * <pre>
 * 设备接口数据Service接口
 * </pre>
 *
 * @author as-shibaobao
 * @version $Id: IIntfcService.java, v 0.1 2018年1月26日 上午11:10:19 as-shibaobao Exp $
 */
public interface IIntfcService 
{

	/**
	 * 
	 * <pre>
	 * 保存接口数据（基础数据和接口属性）
	 * </pre>
	 *
	 * @param intfc
	 * @return
	 */
	Intfc saveBasicInfoAndAttrs(Intfc intfc) throws IntfcException;

	/**
	 * 
	 * <pre>
	 * 根据接口ID分页查询接口详情数据（接口属性）
	 * </pre>
	 *
	 * @param criterias
	 * @param pageable
	 * @return
	 */
	Page<IntfcAttribute> queryIntfcAttributeList(List<DaoCriteria> criterias,Pageable pageable);


	/**
	 * 
	 * <pre>
	 * 编辑接口属性 
	 * </pre>
	 *
	 * @param intfcAttribute 接口属性对象
	 * @return
	 * @throws IntfcException
	 */
	IntfcAttribute editAttribute(IntfcAttribute intfcAttribute) throws IntfcException;

	/**
	 * 
	 * <pre>
	 * 删除接口 
	 * </pre>
	 *
	 * @param ids 接口ID集合
	 */
	void delIntfc(Long id) throws IntfcException;

	/**
	 * 
	 * <pre>
	 * 查询接口数量
	 * </pre>
	 *
	 * @param daoCriteria
	 * @return
	 */
	Map<String, Long> countIntfcInfo(List<DaoCriteria> daoCriteria);
	
	/**
	 * 
	 * <pre>
	 * 分页查询接口数据（基础数据）
	 * </pre>
	 *
	 * @param criterias
	 * @param pageable
	 * @return
	 */
	List<Intfc> findAll(List<DaoCriteria> criterias);

	Intfc findOne(Long intfcId);

}
