/**
 * 
 */
package com.yeejoin.amos.iot.business.service.intfc;

import java.util.List;
import java.util.Map;

import com.yeejoin.amos.iot.business.entity.MetricData;
import com.yeejoin.amos.iot.business.entity.mybatis.MetricDataBo;
import com.yeejoin.amos.iot.business.entity.mybatis.MetricDataVo;
import com.yeejoin.amos.iot.business.param.InputColumn;
import com.yeejoin.amos.iot.business.param.MetricDataPageParam;
import com.yeejoin.amos.iot.core.common.response.CommonPage;
import com.yeejoin.amos.op.core.common.query.DaoCriteria;
import com.yeejoin.amos.op.core.jpa.IGenericManager;

/**
 * 指标数据service接口
 * 
 * @author as-youjun
 *
 */
public interface IMetricDataService{

	/**
	 * 分页查询指标数据
	 * 
	 * @param request
	 * @return
	 */
	CommonPage<MetricDataVo> pageMetricData(MetricDataPageParam request);

	/**
	 * 保存指标数据
	 */
	void saveMetricData(MetricData metricData);

	Object getEchartStatisData(List<InputColumn> columnInfo);
	Object getEchartPStatisData(List<InputColumn> columnInfo);

	/**
	 * 查询设备指标数据（最后一条）
	 * @return
	 */
	Map<String, Object> queryEquipQuotaData(Long equipId, String[] quotaKey,String userName);

    List<MetricData> findAllMetricData(List<DaoCriteria> daoCriterias);

	List<MetricDataBo> findAllMetricDataByEquipId(long id);

	void save(MetricData metricData);
}
