/**
 *
 */
package com.yeejoin.amos.iot.business.service.intfc;

import java.util.List;

import com.yeejoin.amos.iot.business.entity.mybatis.EqpGraphNodeBo;
import com.yeejoin.amos.iot.business.entity.mybatis.EquipmentBo;
import com.yeejoin.amos.iot.business.entity.mybatis.ListenPortBo;
import com.yeejoin.amos.iot.business.param.QueryMonitorEqpParam;

/**
 * 实时监测service接口
 *
 * @author as-youjun
 */
public interface IMonitorService {

    /**
     * 查询监测设备数量
     *
     * @param param
     * @return
     */
    long countMonitorEquipment(QueryMonitorEqpParam param);

    /**
     * 查询监测设备
     *
     * @param param
     * @return
     */
    List<EquipmentBo> findMonitorEquipment(QueryMonitorEqpParam param);

    /**
     * 根据设备id查询EqpGraphNodeBo
     *
     * @param eqpId
     * @return
     */
    EqpGraphNodeBo findEqpGraphNodeByEqpId(Long eqpId);

    /**
     * 查询tcp端口信息
     *
     * @param param
     * @return
     */
    List<ListenPortBo> findTcpPortBo(QueryMonitorEqpParam param);
    /**
     * 查询所有tcp端口信息
     *
     * @param param
     * @return
     */
	List<ListenPortBo> findAllTcpPortBo(QueryMonitorEqpParam queryParam);
    /**
     * 查询监测设备，优化后
     *
     * @param param
     * @return
     */
	List<EquipmentBo> findMonitorEquipmentDet(QueryMonitorEqpParam queryParam);

}
