package com.yeejoin.amos.iot.business.service.intfc;

import java.util.List;

import com.yeejoin.amos.iot.business.entity.NodeVo;
import com.yeejoin.amos.iot.business.param.NodeVoParam;
import com.yeejoin.amos.iot.business.param.RuleConfigParam;
import com.yeejoin.amos.iot.business.param.RuleDataParam;
import com.yeejoin.amos.op.core.jpa.IGenericManager;

/**
 * 
 * <pre>
 * 视图节点元素service接口
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: INodeVoService.java, v 0.1 2018年4月10日 下午3:56:23 as-chenjiajun Exp $
 */
public interface INodeVoService 
{

	/**
	 * 
	 * <pre>
	 * 保存部署图节点和连线
	 * </pre>
	 *
	 * @param ruleData
	 */
	void addEditRuleNodeAndLinks(RuleDataParam ruleData);

	/**
	 * 
	 * <pre>
	 * 根据ruleid查询
	 * </pre>
	 *
	 * @param id
	 * @return
	 */
	List<NodeVo> findByRuleId(String id);

	/**
	 * 
	 * <pre>
	 * 使用key查询
	 * </pre>
	 *
	 * @param id
	 * @return
	 */
	List<NodeVo> findByKey(String id);

	/**
	 * 
	 * <pre>
	 * 删除节点
	 * </pre>
	 *
	 * @param id
	 */
	void deleteNode(String id);

	/**
	 * 
	 * <pre>
	 * 编辑节点名称
	 * </pre>
	 *
	 * @param nodeVo
	 */
	void editNodeName(NodeVo nodeVo);

	/**
	 * 
	 * <pre>
	 * 新增节点
	 * </pre>
	 *
	 * @param nodeVo
	 */
	void addNode(NodeVoParam nodeVo);

	/**
	 * 
	 * <pre>
	 * 编辑节点
	 * </pre>
	 *
	 * @param param
	 */
	void editNode(RuleConfigParam param);

	/**
	 * 
	 * <pre>
	 * 获取node配置信息
	 * </pre>
	 *
	 * @param id
	 * @return
	 */
	RuleConfigParam fetchNode(String id);

	NodeVo findOne(String id);
	
}
