/**
 *
 */
package com.yeejoin.amos.iot.business.service.intfc;

import com.yeejoin.amos.iot.business.entity.Protocol;
import com.yeejoin.amos.iot.business.exceptions.IntfcException;
import com.yeejoin.amos.iot.business.exceptions.ProtocolException;
import com.yeejoin.amos.iot.business.vo.ProtocolDicVo;
import com.yeejoin.amos.iot.business.vo.ProtocolVo;
import com.yeejoin.amos.op.core.common.query.DaoCriteria;
import com.yeejoin.amos.op.core.jpa.IGenericManager;

import java.util.List;
import java.util.Map;

/**
 * <pre>
 * 协议service接口
 * </pre>
 *
 * @author as-lixiangyang
 * @version $Id: IProtocolService.java, v 0.1 2018年1月29日 下午1:30:17
 * as-lixiangyang Exp $
 */
public interface IProtocolService {

    void saveProtocol(Protocol protocol) throws ProtocolException;

    /**
     * <pre>
     * 分页查询协议数据
     * </pre>
     *
     * @param criterias
     * @return
     */
    List<Protocol> findAll(List<DaoCriteria> criterias);

    /**
     * <pre>
     * 根据协议ID详情数据
     * </pre>
     *
     * @param id 协议ID
     * @return
     */
    Protocol queryById(Long id);

    /**
     * 根据协议id查询
     *
     * @param id
     * @return
     */
    ProtocolVo findById(Long id);

    /**
     * <pre>
     * 删除协议
     * </pre>
     *
     * @param id 协议ID
     */
    void delProtocol(Long id) throws IntfcException;

    /**
     * <pre>
     * 协议统计
     * </pre>
     *
     * @param daoCriteria
     * @return
     */
    Map<String, Long> countProtocolInfo(List<DaoCriteria> daoCriteria);

    ProtocolDicVo findProtocolDicVoByFrameType(int frameType);

}
