package com.yeejoin.amos.iot.business.service.intfc;

import com.yeejoin.amos.iot.business.entity.Rule;
import com.yeejoin.amos.iot.business.param.RuleDataParam;
import com.yeejoin.amos.iot.business.param.RulePageParam;
import com.yeejoin.amos.iot.core.common.response.CommonPage;
import com.yeejoin.amos.op.core.jpa.IGenericManager;

/**
 * 
 * <pre>
 * 规则service接口
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: IRuleService.java, v 0.1 2018年4月10日 下午3:55:34 as-chenjiajun Exp $
 */
public interface IRuleService 
{
	/**
	 * 
	 * <pre>
	 * 查询规则数据（支持分页）
	 * </pre>
	 *
	 * @param request
	 * @return
	 */
	CommonPage<Rule> pageRuleData(RulePageParam request);

	/**
	 * 
	 * <pre>
	 * ID查询
	 * </pre>
	 *
	 * @param id
	 * @return
	 */
	RuleDataParam fetchRuleDataByID(String id);

	/**
	 * 
	 * <pre>
	 * 保存
	 * </pre>
	 *
	 * @param rule
	 * @return
	 */
	Rule saveRuleEntity(Rule rule);
	
	/**
	 * 
	 * <pre>
	 * 编辑
	 * </pre>
	 *
	 * @param rule
	 * @return
	 */
	Rule editRuleEntity(Rule rule);
	
	/**
	 * 
	 * <pre>
	 * 启用/停用规则
	 * </pre>
	 *
	 * @param id
	 */
	void startOrStopRule(String id);

	/**
	 * 
	 * <pre>
	 * 启用/停用全部规则
	 * </pre>
	 *
	 * @param status
	 */
	void startOrStopRules(Boolean status,String orgCode);

	/**
	 * 
	 * <pre>
	 * 编辑status信息
	 * </pre>
	 *
	 * @param rule
	 * @return
	 */
	Rule changeRuleStatus(Rule rule);

	/**
	 * 
	 * <pre>
	 * 删除规则
	 * </pre>
	 *
	 * @param id
	 */
	void deleteRule(String id);

	Rule findOne(String id);
}
