package com.yeejoin.amos.iot.context;

import javax.annotation.PostConstruct;
import javax.servlet.http.HttpServletRequest;

import org.springframework.stereotype.Component;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;
import org.typroject.tyboot.core.foundation.context.RequestContext;

import com.yeejoin.amos.component.feign.config.InnerInvokException;
import com.yeejoin.amos.feign.privilege.Privilege;
import com.yeejoin.amos.feign.privilege.model.AgencyUserModel;
import com.yeejoin.amos.iot.core.util.DateUtil;
import com.yeejoin.amos.op.core.entity.BusinessEntity;
import com.yeejoin.amos.op.core.entity.handler.EntityHandler;
import com.yeejoin.amos.op.core.entity.handler.EntityListener;


/**
 * 
 * <pre>
 * 实体变化
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: IotEntityHandler.java, v 0.1 2018年5月29日 下午3:42:41 as-chenjiajun Exp $
 */
@Component
public class IotEntityHandler extends EntityHandler
{
	@PostConstruct
	private void init()
	{
		EntityListener.addModelHandler(this);
	}
	
	public void prePersist(BusinessEntity model)
	{
		model.setCreateUser(getUserInfo().getUserId());
		model.setCreateDate(DateUtil.getCurrentDate());
	}

	public void preUpdate(BusinessEntity model)
	{
		model.setUpdateUser(getUserInfo().getUserId());	
		model.setUpdateDate(DateUtil.getCurrentDate());
	}
	
	/**
	 * 当前登录用户信息
	 */
	protected AgencyUserModel getUserInfo() {
		try {
			ServletRequestAttributes attributes = (ServletRequestAttributes) RequestContextHolder.getRequestAttributes();
	        HttpServletRequest request = attributes.getRequest();
			String token = request.getHeader("token");
			String product = request.getHeader("product");
			String appKey = request.getHeader("appKey");
			RequestContext.setToken(token);
			RequestContext.setProduct(product);
			RequestContext.setAppKey(appKey);
			AgencyUserModel result = Privilege.agencyUserClient.getme().getResult();
			return result;
		} catch (Exception e) {
			System.err.println("get user info fail");
		}
		return null;

	}
	
	
}
