package com.yeejoin.amos.iot.core.adapter;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Configuration;
import org.springframework.web.servlet.config.annotation.ResourceHandlerRegistry;
import org.springframework.web.servlet.config.annotation.WebMvcConfigurerAdapter;

/**
 * 
 * <pre>
 * 提供图片访问功能
 * </pre>
 *
 * @author as-chenjiajun
 * @version $Id: WebImgFileConfig.java, v 0.1 2018年2月2日 上午8:40:31 as-chenjiajun Exp $
 */
@Configuration
public class WebImgFileConfig extends WebMvcConfigurerAdapter
{
	
	@Value("${iot.imagesPath}")
	private String mImagesPath;

	@Override
	public void addResourceHandlers(ResourceHandlerRegistry registry)
	{
		if (mImagesPath.equals("") || mImagesPath.equals("${iot.imagesPath}"))
		{
			String imagesPath = WebImgFileConfig.class.getClassLoader()
					.getResource("").getPath();
			if (imagesPath.indexOf(".jar") > 0)
			{
				imagesPath = imagesPath.substring(0,
						imagesPath.indexOf(".jar"));
			}
			else
				if (imagesPath.indexOf("classes") > 0)
				{
					imagesPath = "file:" + imagesPath.substring(0,
							imagesPath.indexOf("classes"));
				}
			imagesPath = imagesPath.substring(0, imagesPath.lastIndexOf("/"))
					+ "/images/";
			mImagesPath = imagesPath;
		}
		registry.addResourceHandler("/images/**")
				.addResourceLocations(mImagesPath);
		super.addResourceHandlers(registry);
	}
}
