package com.yeejoin.amos.iot.core.remote.services;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Component;
import org.springframework.web.client.RestTemplate;

import com.fasterxml.jackson.databind.node.ObjectNode;
import com.yeejoin.amos.iot.business.entity.Alarm;
import com.yeejoin.amos.op.core.util.ApplicationConfig;

import net.sf.json.JSONObject;

/**
 * 
 * <pre>
 * 运维服务远程调用
 * </pre>
 *
 * @author as-guowubin
 * @version $Id: RemoteOperationService.java, v 0.1 2018年9月6日 上午11:05:14
 *          as-guowubin Exp $
 */
@Component
public class RemoteOperationService
{
	@Autowired
	private ApplicationConfig applicationConfig;
	
	private static RestTemplate restTemplate;
	
	public RemoteOperationService()
	{
		restTemplate = new RestTemplate();
	}

	public ObjectNode onAlarm(Alarm alarm)
	{
		String url = applicationConfig.getParamValueStr("params.remoteOperationUrl");
		HttpHeaders headers = new HttpHeaders();
		MediaType type = MediaType 
				.parseMediaType("application/json; charset=UTF-8");
		headers.setContentType(type);
		headers.add("Accept", MediaType.APPLICATION_JSON.toString());

		JSONObject jsonObj = JSONObject.fromObject(alarm);
		HttpEntity<String> formEntity = new HttpEntity<String>(
				jsonObj.toString(), headers);
		return restTemplate.postForObject(url + "api/operate/alarm",
				formEntity, ObjectNode.class);
	}
	
}
