package com.yeejoin.amos.iot.core.util;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

import com.yeejoin.amos.iot.business.constants.IotConstant;

import net.sf.json.JsonConfig;
import net.sf.json.processors.JsonValueProcessor;

/**
 * 处理json的date类型
 * 
 * @author as-youjun
 *
 */
public class DateJsonValueProcessor implements JsonValueProcessor {

	private DateFormat dateFormat;

	/**
	 * 构造方法
	 * 
	 * @param datePattern
	 */
	public DateJsonValueProcessor(String datePattern) {
		try {
			dateFormat = new SimpleDateFormat(datePattern);
		} catch (Exception e) {
			dateFormat = new SimpleDateFormat(IotConstant.DATE_TIME_STR_YMDHMS);
		}
	}

	/**
	 * processArrayValue
	 */
	public Object processArrayValue(Object value, JsonConfig jsonConfig) {
		return process(value);
	}

	/**
	 * processObjectValue
	 */
	public Object processObjectValue(String key, Object value, JsonConfig jsonConfig) {
		return process(value);
	}

	/**
	 * process
	 * 
	 * @param value
	 * @return
	 */
	private Object process(Object value) {
		return dateFormat.format((Date) value);
	}

}