/**
 * 
 */
package com.yeejoin.amos.iot.mongodb.entity;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import org.springframework.data.mongodb.core.index.Indexed;

/**
 * 能力数据
 * 
 * @author as-youjun
 *
 */
public class CapabilityData {

	/**
	 * 能力id
	 */
	private Long cpblId;

	/**
	 * 能力名称(英文、数字、下划线)
	 */
	@Indexed
	private String cpblName;

	/**
	 * 能力分类：1表示采集；2表示控制；3表示诊断
	 */
	@Indexed
	private Integer cpblType;

	/**
	 * 能力描述
	 */
	private String cpblDescr;

	/**
	 * 协议id
	 */
	private Long protocolId;

	/**
	 * 采集时间
	 */
	private Date exeTime;

	/**
	 * 指标数据(value为基本类型的封装类)
	 */
	private Map<String, Object> metricDataMap = new HashMap<>();

	/**
	 * @return the cpblId
	 */
	public Long getCpblId() {
		return cpblId;
	}

	/**
	 * @param cpblId
	 *            the cpblId to set
	 */
	public void setCpblId(Long cpblId) {
		this.cpblId = cpblId;
	}

	/**
	 * @return the cpblName
	 */
	public String getCpblName() {
		return cpblName;
	}

	/**
	 * @param cpblName
	 *            the cpblName to set
	 */
	public void setCpblName(String cpblName) {
		this.cpblName = cpblName;
	}

	/**
	 * @return the cpblType
	 */
	public Integer getCpblType() {
		return cpblType;
	}

	/**
	 * @param cpblType
	 *            the cpblType to set
	 */
	public void setCpblType(Integer cpblType) {
		this.cpblType = cpblType;
	}

	/**
	 * @return the cpblDescr
	 */
	public String getCpblDescr() {
		return cpblDescr;
	}

	/**
	 * @param cpblDescr
	 *            the cpblDescr to set
	 */
	public void setCpblDescr(String cpblDescr) {
		this.cpblDescr = cpblDescr;
	}

	/**
	 * @return the protocolId
	 */
	public Long getProtocolId() {
		return protocolId;
	}

	/**
	 * @param protocolId
	 *            the protocolId to set
	 */
	public void setProtocolId(Long protocolId) {
		this.protocolId = protocolId;
	}

	/**
	 * @return the exeTime
	 */
	public Date getExeTime() {
		return exeTime;
	}

	/**
	 * @param exeTime
	 *            the exeTime to set
	 */
	public void setExeTime(Date exeTime) {
		this.exeTime = exeTime;
	}

	/**
	 * @return the metricDataMap
	 */
	public Map<String, Object> getMetricDataMap() {
		return metricDataMap;
	}

	/**
	 * @param metricDataMap
	 *            the metricDataMap to set
	 */
	public void setMetricDataMap(Map<String, Object> metricDataMap) {
		this.metricDataMap = metricDataMap;
	}

}
