/**
 * 
 */
package com.yeejoin.amos.iot.mongodb.service.intfc;

import java.util.List;

import org.springframework.transaction.annotation.Transactional;

import com.yeejoin.amos.iot.business.entity.MetricData;
import com.yeejoin.amos.iot.business.param.QueryMetricDataParam;
import com.yeejoin.amos.iot.mongodb.entity.EqpMetricData;

/**
 * 设备指标数据Service接口
 * 
 * @author as-youjun
 *
 */
public interface IEquipMetricDataService {

	/**
	 * 保存数据
	 * 
	 * @param equipMetricData
	 */
	@Transactional
	void save(EqpMetricData equipMetricData);

	/**
	 * 根据参数查询指标数据
	 * 
	 * @param param
	 * @return
	 */
	List<EqpMetricData> findByParam(QueryMetricDataParam param);

	/**
	 * 指标数据保存到mongodb
	 * 
	 * @param metricData
	 */
	void saveMetricData2MongoDb(MetricData metricData, String sourceId);

	/**
	 * 指标数据保存到mongodb
	 * 
	 * @param metricData
	 */
	void saveMetricData2MongoDb(MetricData metricData);

}
