package com.yeejoin.amos.iot.netty.customer;

import java.net.InetSocketAddress;
import java.util.concurrent.TimeUnit;

import org.apache.log4j.Logger;
import org.springframework.stereotype.Component;

import com.yeejoin.amos.iot.netty.customer.coder.CustomerDecoder;
import com.yeejoin.amos.iot.netty.customer.coder.CustomerEecoder;

import io.netty.channel.ChannelInitializer;
import io.netty.channel.socket.SocketChannel;
import io.netty.handler.timeout.IdleStateHandler;

@Component
public class CustomerChannelInitalizer  extends ChannelInitializer<SocketChannel>{
	
//	@Autowired
//	private CustomerDecoder customerDecoder;
//	@Autowired
//	private CustomerEecoder customerEncoder;
//	@Autowired
//	private CustomerHandler customerHandler;
    /**
     * 初始化通道
     */
    @Override
    protected void initChannel(SocketChannel channel) throws Exception {
        InetSocketAddress s = channel.remoteAddress();
        Logger.getLogger(this.getClass()).debug("client channel:" + s.toString());
        // 空闲状态助手
		channel.pipeline().addLast(new IdleStateHandler(4, 5, 10, TimeUnit.SECONDS));
        // 分隔符解码器
        channel.pipeline().addLast(new CustomerDecoder());
        // 车载总端通道助手
        channel.pipeline().addLast(new CustomerHandler());
        //缓存通道助手
        channel.pipeline().addLast(new CustomerEecoder());
    }

}
