package com.yeejoin.amos.iot.netty.customer.session;

import java.util.Date;

import com.yeejoin.amos.iot.netty.customer.connector.TcpConnector;
import com.yeejoin.amos.iot.netty.customer.entity.Wapper;

import io.netty.channel.ChannelHandlerContext;

public class Session {
	private TcpConnector tcpConnector;
	private String sessionId;
	
	private long recordTime;
	
	public Session(String sessionId, ChannelHandlerContext ctx) {
		this.tcpConnector = new TcpConnector(ctx);
		this.sessionId = sessionId;
	}
	
	public void refreshRecordTime() {
		Date date = new Date();
		this.recordTime = date.getTime();
	}
	
	public void send(Wapper wapper){
		tcpConnector.sendMessage(wapper);
	}
	
	public void closeConnect() {
		tcpConnector.closeConnect();
	}
	
	public TcpConnector getTcpConnector() {
		return tcpConnector;
	}
	public void setTcpConnector(TcpConnector tcpConnector) {
		this.tcpConnector = tcpConnector;
	}
	public String getSessionId() {
		return sessionId;
	}
	public void setSessionId(String sessionId) {
		this.sessionId = sessionId;
	}


	public long getRecordTime() {
		return recordTime;
	}

	
}
