package com.yeejoin.amos.iot.netty.gateway;

import org.apache.log4j.Logger;

import com.yeejoin.amos.iot.business.constants.IotConstant;

/**
 * 有人网关TCP通信协议帧类型
 * @author mafeipeng
 *
 */
public class UsrFrameType {
    private UsrFrameType() {
        Logger.getLogger(this.getClass()).debug(IotConstant.CONSTRUCTOR);
    }
    
    //有人网关帧类型(上行)
    public final static byte USR_GA_LOGON = (byte) 0x03; //注册帧
    public final static byte USR_GA_HEART_BEAT = (byte) 0x01; //心跳帧
    public final static byte USR_GA_REPORT_DATA = (byte) 0x09; //主动上报数据帧
    public final static byte USR_GA_ACTIVE_OFFLINE = (byte) 0x82; //主动下线帧
    //有人网关帧类型(下行)
    public final static byte USR_GA_LOGON_RESPONSE = (byte) 0x83; //注册响应帧
    public final static byte USR_GA_HEART_BEAT_RESPONSE = (byte) 0x81; //心跳响应帧
    public final static byte USR_GA_REPORT_DATA_RESPONSE = (byte) 0x85; //上报数据响应帧
    public final static byte USR_GA_ACTIVE_ISSUE_DATA = (byte) 0x89; //主动下发数据帧
    public final static byte USR_GA_ACTIVE_OFFLINE_RESPONSE = (byte) 0x02; //主动下线响应帧
}
