package com.yeejoin.amos.iot.netty.gateway;

import com.yeejoin.amos.iot.netty.vehicle.MessageCommonUtil;

/**
 * 车载网关响应帧
 * @author mafeipeng
 *
 */
public class UsrGwResponseFrame {

    /**
     * 创建响应帧
     * @param message
     * @return
     */
    public static byte[] createResponse(byte[] message) {
        byte type = message[1];
        
        switch (type) {
        case UsrFrameType.USR_GA_LOGON:
            return createResponseByResponseType(UsrFrameType.USR_GA_LOGON_RESPONSE, message);
        case UsrFrameType.USR_GA_HEART_BEAT:
            return createResponseByResponseType(UsrFrameType.USR_GA_HEART_BEAT_RESPONSE, message);
//        case UsrFrameType.USR_GA_REPORT_DATA:
//            return createResponseByResponseType(UsrFrameType.USR_GA_REPORT_DATA_RESPONSE, message);
        case UsrFrameType.USR_GA_ACTIVE_OFFLINE:
            return createResponseByResponseType(UsrFrameType.USR_GA_ACTIVE_OFFLINE_RESPONSE, message);
        default:
            return null;
        }
    }
    
    /**
     * 根据响应类型创建响应帧
     * @param responseType
     * @param message
     * @return
     */
    private static byte[] createResponseByResponseType(byte responseType, byte[] message) {
        byte[] repMessage = MessageCommonUtil.getAnyPartMessage(message, 0, message.length);
        repMessage[1] = responseType;
        return repMessage;
    }
}
