package com.yeejoin.amos.iot.netty.gateway;

import org.apache.log4j.Logger;

import com.yeejoin.amos.iot.business.polling.PollingScheduledExecutor;
import com.yeejoin.amos.iot.netty.vehicle.MessageCommonUtil;

import io.netty.channel.ChannelHandlerContext;

public class UsrSamplerScheduleTask implements Runnable {

    /**
     * 日志记录器
     */
    private static final Logger logger = Logger
            .getLogger(UsrSamplerScheduleTask.class);
    
    /**
     * 有人网关Id
     */
    private String gaId;
    /**
     * 透传给中继的抄读命令
     */
    private String command;

    
    public UsrSamplerScheduleTask(String gaId, String command) {
        this.gaId = gaId;
        this.command = command;
    }


    @Override
    public void run() {
        ChannelHandlerContext ctx = UsrGatewayManager.getCtx(gaId);
        if (ctx == null) {
            logger.debug("网关"+gaId+"没有在线。");
        }
        if (ctx != null && command!=null && command != "") {
        	byte[] commandBytes = MessageCommonUtil.hexStr2ByteArray(command);
            ctx.writeAndFlush(ctx.alloc().buffer(command.length()).writeBytes(commandBytes));
        }
    }
}
