package com.yeejoin.amos.iot.netty.http;

import com.yeejoin.amos.iot.netty.vehicle.CacheChannelHandler;

import io.netty.channel.ChannelInitializer;
import io.netty.channel.socket.SocketChannel;
import io.netty.handler.codec.http.HttpObjectAggregator;
import io.netty.handler.codec.http.HttpRequestDecoder;
import io.netty.handler.codec.http.HttpResponseEncoder;

public class HttpChannelInitializer extends ChannelInitializer<SocketChannel>{

	@Override
	protected void initChannel(SocketChannel channel) throws Exception {
        //解码器
        channel.pipeline().addLast(new HttpRequestDecoder());
        //编码器
        channel.pipeline().addLast(new HttpResponseEncoder());
        //请求封装成FullHttpRequest
        channel.pipeline().addLast( new HttpObjectAggregator(10*1024*1024));     
        //业务处理
        channel.pipeline().addLast(new HttpChannelHandler());

	}
	

}
