package com.yeejoin.amos.iot.netty.mqtt.processor;

import io.netty.channel.ChannelHandlerContext;
import net.sf.json.JSONObject;

import java.util.Map;
import java.util.Set;

import org.meqantt.message.DisconnectMessage;
import org.meqantt.message.Message;
import org.meqantt.message.PublishMessage;

import org.apache.log4j.Logger;

import com.yeejoin.amos.iot.netty.mqtt.MqttFrameQueue;
import com.yeejoin.amos.iot.netty.mqtt.handler.entity.ChannelEntity;
import com.yeejoin.amos.iot.netty.mqtt.tool.MemPool;
import com.yeejoin.amos.iot.netty.vehicle.VehicleChannelCache;

public class PublishProcesser implements Processer {
	private static final Logger logger = Logger.getLogger(PublishProcesser.class);
	private static DisconnectMessage DISCONNECT = new DisconnectMessage();

	public Message proc(Message msg, ChannelHandlerContext ctx) {
		String clientId = MemPool.getClientId(ctx.channel());
		if (clientId == null) {
			return DISCONNECT;
		}

		PublishMessage pm = (PublishMessage) msg;

		String json = pm.getDataAsString();
		Map<String, Object> valueMap = (Map<String, Object>) JSONObject.toBean(JSONObject.fromObject(json), Map.class);
		String sid = String.valueOf(valueMap.get("sourceId"));
		if (!sid.equals("null")) {
			// 数据放入帧队列
			byte[] frame = json.getBytes();
			MqttFrameQueue.getInstance().add(frame);
			// 注册通道
			VehicleChannelCache.getInstance().channelRegister(ctx.channel(), sid);
		}
		
		Set<ChannelEntity> channelEntitys = MemPool.getChannelByTopics(pm
				.getTopic());
		if (channelEntitys == null) {
			return null;
		}
		
		for (ChannelEntity channelEntity : channelEntitys) {
			logger.debug("PUBLISH to ChannelEntity("+channelEntity.getChannel().remoteAddress()+") topic = " + pm.getTopic()
					+ " payload = " + pm.getDataAsString());
			channelEntity.write(pm);
		}

		return null;
	}
}