package com.yeejoin.amos.iot.netty.mqtt.server;

import java.net.InetSocketAddress;

import org.apache.log4j.Logger;

import com.yeejoin.amos.iot.netty.mqtt.handler.MqttMessageHandler;
import com.yeejoin.amos.iot.netty.mqtt.handler.coder.MqttMessageNewDecoder;
import com.yeejoin.amos.iot.netty.mqtt.handler.coder.MqttMessageNewEncoder;
import com.yeejoin.amos.iot.netty.vehicle.CacheChannelHandler;

import io.netty.channel.ChannelInitializer;
import io.netty.channel.ChannelPipeline;
import io.netty.channel.socket.SocketChannel;

public class TcpChannelInitializer extends ChannelInitializer<SocketChannel> {
	
	@Override
	public void initChannel(SocketChannel ch) throws Exception {
		
		InetSocketAddress s = ch.remoteAddress();
        
		ChannelPipeline pipeline = ch.pipeline();
		// Mqtt message encoder
		pipeline.addLast("encoder", new MqttMessageNewEncoder());
		// Mqtt message decoder
		pipeline.addLast("decoder", new MqttMessageNewDecoder());
		// 业务处理
		pipeline.addLast("handler", new MqttMessageHandler());
		//缓存通道助手
        pipeline.addLast(new CacheChannelHandler());
	}
}