package com.yeejoin.amos.iot.netty.vehicle;

import org.apache.log4j.Logger;

import com.yeejoin.amos.iot.business.constants.IotConstant;
import com.yeejoin.amos.iot.business.queue.AlarmDataObj;
import com.yeejoin.amos.iot.business.queue.AlarmDataQueue;
import com.yeejoin.amos.iot.business.queue.ChannelAlarmData;

import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelInboundHandlerAdapter;

/**
 * 车载终端帧处理器
 * 
 * @author as-mafeipeng
 *
 */
public class VehicleChannelHandler extends ChannelInboundHandlerAdapter {

	@Override
	public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {
		byte[] frame = (byte[]) msg;
		VehicleFrameQueue.getInstance().add(frame);
		addChannelCache(frame,ctx);
	}

	@Override
	public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) {
		cause.printStackTrace();
		ctx.close();
	}

	private void addChannelCache(byte[] frame,ChannelHandlerContext ctx){
		VehicleFrame vFrame = new VehicleFrame(frame);
		// 如果是心跳帧，则不做任务处理
		if (vFrame.type() == VehicleFrameType.HEART_BEAT) {
			return;
		}
		String sid = vFrame.getSid();
		VehicleChannelCache.getInstance().channelRegister(ctx.channel(), sid);
		vFrame = null;
	}

}
