/**
 *
 */
package com.yeejoin.amos.iot.netty.vehicle;

import io.netty.channel.ChannelInitializer;
import io.netty.channel.socket.SocketChannel;
import org.apache.log4j.Logger;

import java.net.InetSocketAddress;

/**
 * 车载总端ChannellInitalizer
 *
 * @author as-youjun
 */
public class VehicleChannellInitalizer extends ChannelInitializer<SocketChannel> {

    /**
     * 初始化通道
     */
    @Override
    protected void initChannel(SocketChannel channel) throws Exception {
        InetSocketAddress s = channel.remoteAddress();
        Logger.getLogger(this.getClass()).debug("client channel:" + s.toString());
        // 空闲状态助手
//		channel.pipeline().addLast(new IdleStateHandler(4, 5, 10, TimeUnit.SECONDS));
        // 分隔符解码器
        channel.pipeline().addLast(new VehicleFrameDecoder());
        // 车载总端通道助手
        channel.pipeline().addLast(new VehicleChannelHandler());
        //缓存通道助手
        channel.pipeline().addLast(new CacheChannelHandler());
    }

}
