/**
 * 
 */
package com.yeejoin.amos.iot.netty.vehicle;

import java.util.Date;

/**
 * 车载终端一帧数据
 * 
 * @author as-youjun
 *
 */
public class VehicleData {

	/**
	 * 设备ID
	 */
	private String sourceID;

	/**
	 * 帧类型
	 */
	private byte frameType;

	/**
	 * 标签类型: 1.如果labelType==null，则由sourceID、frameType唯一确定一个能力；
	 * 2.如果labelType！=null，则由sourceID、frameType、labelType唯一确定一个能力
	 */
	private Byte labelType;

	/**
	 * 时间
	 */
	private Date time;

	/**
	 * 一帧数据(json格式)
	 */
	private String frameJson;

	/**
	 * @return the sourceID
	 */
	public String getSourceID() {
		return sourceID;
	}

	/**
	 * @param sourceID
	 *            the sourceID to set
	 */
	public void setSourceID(String sourceID) {
		this.sourceID = sourceID;
	}

	/**
	 * @return the frameType
	 */
	public byte getFrameType() {
		return frameType;
	}

	/**
	 * @param frameType
	 *            the frameType to set
	 */
	public void setFrameType(byte frameType) {
		this.frameType = frameType;
	}

	/**
	 * @return the time
	 */
	public Date getTime() {
		return time;
	}

	/**
	 * @param time
	 *            the time to set
	 */
	public void setTime(Date time) {
		this.time = time;
	}

	/**
	 * @return the frameJson
	 */
	public String getFrameJson() {
		return frameJson;
	}

	/**
	 * @param frameJson
	 *            the frameJson to set
	 */
	public void setFrameJson(String frameJson) {
		this.frameJson = frameJson;
	}

	/**
	 * @return the labelType
	 */
	public Byte getLabelType() {
		return labelType;
	}

	/**
	 * @param labelType
	 *            the labelType to set
	 */
	public void setLabelType(Byte labelType) {
		this.labelType = labelType;
	}

	@Override
	public String toString() {
		return ("sourceID:" + sourceID + ",frameType:" + frameType + ",labelType:" + labelType + ",frameJson:"
				+ frameJson).toString();
	}

}
