package com.yeejoin.amos.iot.rule.cmd;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.yeejoin.amos.iot.business.service.intfc.ICapabilityAttrService;
import com.yeejoin.amos.iot.business.service.intfc.ICapabilityService;
import com.yeejoin.amos.iot.business.service.intfc.IDeviceService;
import com.yeejoin.amos.iot.business.service.intfc.IRuleEmailService;
import com.yeejoin.amos.iot.business.service.intfc.IRuleMqttService;
import com.yeejoin.amos.iot.business.service.intfc.IRuleTcpService;
import com.yeejoin.amos.iot.business.service.intfc.ISystemLogService;
import com.yeejoin.amos.op.core.repository.NativeRespository;

/**
 * <pre> 
 * 命令执行时所需上下文 ，包括全部业务服务等
 *  </pre>
 * @author  HK
 * @version  $Id: CommandContext.java, v 0.1 2017年12月25日 下午7:21:40 HK Exp $
 */
@Component
public class CommandContext
{
	
	@Autowired
	private ISystemLogService toipLogService;
	
	@PersistenceContext
	private EntityManager entityManager;
	
	@Autowired
	private NativeRespository nativeRespository;
	
	@Autowired
	private IRuleEmailService ruleEmailService;
	
	@Autowired
	private IDeviceService deviceService;
	
	@Autowired
	private ICapabilityAttrService capabilityAttrService;

	@Autowired
	private  ICapabilityService capabilityService;
	
	@Autowired
	private IRuleMqttService ruleMqttServicel;
	
	@Autowired
	private IRuleTcpService ruleTcpService;
	
	public EntityManager getEntityManager()
	{
		return entityManager;
	}

	public void setEntityManager(EntityManager entityManager)
	{
		this.entityManager = entityManager;
	}

	public ISystemLogService getToipLogService()
	{
		return toipLogService;
	}

	public void setToipLogService(ISystemLogService toipLogService)
	{
		this.toipLogService = toipLogService;
	}

	public NativeRespository getNativeRespository() {
		return nativeRespository;
	}

	public void setNativeRespository(NativeRespository nativeRespository) {
		this.nativeRespository = nativeRespository;
	}

	public IRuleEmailService getRuleEmailService()
	{
		return ruleEmailService;
	}

	public void setRuleEmailService(IRuleEmailService ruleEmailService)
	{
		this.ruleEmailService = ruleEmailService;
	}

	public IDeviceService getDeviceService()
	{
		return deviceService;
	}

	public void setDeviceService(IDeviceService deviceService)
	{
		this.deviceService = deviceService;
	}

	public ICapabilityAttrService getCapabilityAttrService()
	{
		return capabilityAttrService;
	}

	public void setCapabilityAttrService(
			ICapabilityAttrService capabilityAttrService)
	{
		this.capabilityAttrService = capabilityAttrService;
	}

	public ICapabilityService getCapabilityService()
	{
		return capabilityService;
	}

	public void setCapabilityService(ICapabilityService capabilityService)
	{
		this.capabilityService = capabilityService;
	}

	public IRuleMqttService getRuleMqttServicel()
	{
		return ruleMqttServicel;
	}

	public void setRuleMqttServicel(IRuleMqttService ruleMqttServicel)
	{
		this.ruleMqttServicel = ruleMqttServicel;
	}

	public IRuleTcpService getRuleTcpService()
	{
		return ruleTcpService;
	}

	public void setRuleTcpService(IRuleTcpService ruleTcpService)
	{
		this.ruleTcpService = ruleTcpService;
	}

}
