package com.yeejoin.amos.iot.rule.cmd;

import java.util.Date;

import org.apache.log4j.Logger;

import com.yeejoin.amos.iot.business.entity.SystemLog;
import com.yeejoin.amos.iot.rule.log.BizLogCollector;
import com.yeejoin.amos.iot.rule.log.LogType;


/**
 * 
 * <pre>
 * 命令执行log
 * </pre>
 *
 * @author HK
 * @version $Id: LogInterceptor.java, v 0.1 2017年12月28日 下午5:47:08 HK Exp $
 */
public class LogInterceptor extends AbstractCommandInterceptor
{

	private static final Logger log = Logger.getLogger(LogInterceptor.class);
	@Override
	public <T> T execute(Command<T> command)
	{
		try
		{
			T t = next.execute(command);
			SystemLog toipLog = new SystemLog();
//			AbstractAction<ActionResult> abstractAction = (AbstractAction<ActionResult>)command;
//			RuleAction ruleAction =  abstractAction.getRuleAction();
//			String name = ruleAction != null ? ruleAction.getDisplayName()
//					: null;
//			toipLog.setContext(
//					name == null ? command.getClass().getName() + "动作执行成功"
//							: name + "动作执行成功");
//			toipLog.setTime(new Date());
//			toipLog.setBizId(ruleAction.getId());
//			AbstractActionResult abstractActionResult = (AbstractActionResult)t;
//			if ((abstractActionResult.getToipResponse()) instanceof ToipResponse)
//			{
//				toipLog.setRemark(abstractActionResult.getToipResponse().toJsonStr());
//			}
			toipLog.setType(LogType.actionresult.name());
			BizLogCollector.collect(toipLog);
			return t;
		}
		catch (Exception e)
		{
			SystemLog toipLog = new SystemLog();
			toipLog.setContext(command.getClass().getSimpleName() + "动作执行失败");
			toipLog.setTime(new Date());
			toipLog.setRemark(e.getMessage());
			toipLog.setType(LogType.actionresult.name());
			BizLogCollector.collect(toipLog);
			log.error("动作执行失败:" + e.getMessage());
			return null;
		}
		finally
		{
		}
	}
}
