package com.yeejoin.amos.iot.rule.engine.action;

import java.util.List;

import net.sf.json.JSONObject;
import org.apache.log4j.Logger;

import com.yeejoin.amos.iot.business.entity.RuleMqtt;
import com.yeejoin.amos.iot.core.util.MqttPublisher;
import com.yeejoin.amos.iot.rule.cmd.CommandContext;
import com.yeejoin.amos.iot.rule.resource.RuleAIEntity;

/**
 * 
 * <pre>
 * mqtt动作
 * 连接到MQTT代理并发布消息
 * 
 * </pre>
 *
 * @author as-guowubin
 * @version $Id: MqttAction.java, v 0.1 2018年5月3日 上午10:54:42 as-guowubin Exp $
 */
public class MqttAction extends CmdAction
{
	private static final Logger log = Logger.getLogger(MqttAction.class);

	public String mqttId;
	public String ruleStatus;
	
	public MqttAction(List<RuleAIEntity> ruleEntities)
	{
		super(ruleEntities);
	}
	
	public MqttAction(List<RuleAIEntity> ruleEntities, String mqttId, String ruleStatus)
	{		
		super(ruleEntities);
		this.mqttId = mqttId;
		this.ruleStatus = ruleStatus;
	}

	@Override
	public Object execute(CommandContext commandContext)
	{
		try
		{
			for (RuleAIEntity ruleAIEntity : ruleEntities)
			{
				RuleMqtt ruleMqtt = commandContext.getRuleMqttServicel().findOne(mqttId);
				log.info(ruleMqtt.toString());
				log.info(ruleAIEntity.toString());
				ruleAIEntity.setRuleStatus(ruleStatus);
				MqttPublisher.getInstance(ruleMqtt.getUserName(), ruleMqtt.getPassword(),
						ruleMqtt.getServerIp(), ruleMqtt.getPort()).publisher(ruleAIEntity, ruleMqtt.getTheme());
			}
		}
		catch (Exception e)
		{
			e.printStackTrace();
			log.error("MqttAction执行失败：" + e.getMessage());
		}
		ruleEntities = null;
		return null;
	}

}
