package com.yeejoin.amos.iot.rule.engine.action;
import org.apache.log4j.Logger;

import io.netty.bootstrap.Bootstrap;
import io.netty.buffer.ByteBuf;
import io.netty.channel.*;
import io.netty.channel.nio.NioEventLoopGroup;
import io.netty.channel.socket.SocketChannel;
import io.netty.channel.socket.nio.NioSocketChannel;

public class NettyTcpClientUtil {
	
	private static final Logger log = Logger.getLogger(NettyTcpClientUtil.class);
	public static void sendMessage(String host, int port, String message) {
        EventLoopGroup group = new NioEventLoopGroup();
        try {
            Bootstrap bs = new Bootstrap();
            bs.group(group);
            bs.option(ChannelOption.CONNECT_TIMEOUT_MILLIS, 2000);
            bs.remoteAddress(host, port);
            bs.channel(NioSocketChannel.class);
            bs.handler(new ChannelInitializer<SocketChannel>() {
                @Override
                protected void initChannel(SocketChannel ch) throws Exception {
                    //先添加json解码器，再添加业务处理器
                    ch.pipeline().addLast(new SimpleChannelInboundHandler() {
                        @Override
                        public void channelRead0(ChannelHandlerContext ctx, Object msg) throws Exception {
                            super.channelRead(ctx, msg);
                        }
                        @Override
                        public void channelActive(ChannelHandlerContext ctx) throws Exception {
                            System.out.println("TCP 客户端成功连接到"+host+":"+port);
                            log.debug("===========TCP 客户端成功连接到============"+host+":"+port);
                            ByteBuf buf = ctx.alloc().buffer(message.length());
                            buf.writeBytes(message.getBytes());
                            ChannelFuture f = ctx.writeAndFlush(buf);
                            f.addListener(ChannelFutureListener.CLOSE);
                        }
                        @Override
                        public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
                            cause.printStackTrace();
                            System.out.println("TCP 客户端连接到"+host+":"+port+"异常:"+cause.getMessage());
                            log.debug("===========TCP 客户端连接到============="+host+":"+port+"异常:"+cause.getMessage());
                            ctx.close();
                        }

                        @Override
                        public void channelUnregistered(ChannelHandlerContext ctx) throws Exception {
                        	   log.debug("============TCP 客户端与============"+host+":"+port+"连接断开。");
                            System.out.println("TCP 客户端与"+host+":"+port+"连接异常。");
                        }
                    });
                }
            });

            ChannelFuture future = bs.connect().sync();
            future.channel().closeFuture().sync();
        } catch (Exception e) {
        	log.error(e.getMessage(),e);
            e.printStackTrace();
        } finally {
            group.shutdownGracefully();
        }
    }
}
