package com.yeejoin.amos.iot.rule.engine.cfg;

import java.util.LinkedList;
import java.util.List;

import com.yeejoin.amos.iot.rule.cmd.CommandExecutor;
import com.yeejoin.amos.iot.rule.cmd.CommandInterceptor;
import com.yeejoin.amos.iot.rule.log.BizLogCollector;
import com.yeejoin.amos.iot.rule.log.BufferLogCollector;
import com.yeejoin.amos.iot.rule.log.LogHandler;

/**
 * 
 * <pre>
 * 规则相关配置
 * </pre>
 *
 * @author HK
 * @version $Id: RuleEngineConfiguration.java, v 0.1 2018年1月12日 上午10:34:56 HK
 *          Exp $
 */
public abstract class RuleEngineConfiguration
{
	// 命令相关
	protected CommandInterceptor commandInvoker;
	protected List<CommandInterceptor> customPreCommandInterceptors;
	protected List<CommandInterceptor> customPostCommandInterceptors;
	protected List<CommandInterceptor> commandInterceptors;
	protected CommandExecutor commandExecutor;
	
	// 日志处理
	protected List<LogHandler> logHandlers = new LinkedList<>();	
	
	public void init()
	{
		initlogHandlers();
	}
	
	private void initlogHandlers(){
//		logHandlers = getDefaultLogHandlers();
		BizLogCollector.addLogHandler(logHandlers);
		BufferLogCollector.addLogHandler(logHandlers);
	}

	public List<LogHandler> getLogHandlers()
	{
		return logHandlers;
	}


	public void setLogHandlers(List<LogHandler> logHandlers)
	{
		this.logHandlers = logHandlers;
	}

}
