package com.yeejoin.amos.iot.rule.engine.service;

import java.util.List;

import com.yeejoin.amos.iot.business.entity.DroolsRule;
import com.yeejoin.amos.iot.business.entity.RuleGroup;
import com.yeejoin.amos.iot.rule.resource.RuleAIEntity;

public interface IDroolsManageService {
	
	/**
	 * <pre>
	 * 根据fact触发规则
	 * </pre>
	 *
	 * @param ruleAIEntity
	 */
	void fireRule(RuleAIEntity ruleAIEntity);
	
	/**
	 * <pre>
	 * 根据ruleGroup和ruleList重新加载规则
	 * </pre>
	 *
	 * @param ruleGroup
	 * @param ruleList
	 */
	void updateRule(RuleGroup ruleGroup,List<DroolsRule> ruleList);
	
	/**
	 * <pre>
	 * 规则引擎中销毁规则
	 * </pre>
	 *
	 * @param ruleGroupList
	 */
	void destroyRule(List<RuleGroup> ruleGroupList);
	
}