package com.yeejoin.amos.iot.rule.engine.service.impl;

import java.util.List;

import javax.annotation.PostConstruct;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.yeejoin.amos.iot.business.entity.DroolsRule;
import com.yeejoin.amos.iot.business.entity.Rule;
import com.yeejoin.amos.iot.business.entity.RuleGroup;
import com.yeejoin.amos.iot.business.service.intfc.IDroolsRuleService;
import com.yeejoin.amos.iot.business.service.intfc.IRuleGroupService;
import com.yeejoin.amos.iot.rule.engine.service.IDroolsManageService;
import com.yeejoin.amos.iot.rule.engine.service.IRuleEngineService;
import com.yeejoin.amos.iot.rule.resource.RuleAIEntity;
import com.yeejoin.amos.op.core.entity.Resource;
import com.yeejoin.amos.op.core.entity.handler.EntityChangeHandler;
import com.yeejoin.amos.op.core.service.impl.AbstractSupportedModel;

@Component
public class RuleEngineServiceImpl extends AbstractSupportedModel implements IRuleEngineService{

	@Autowired
	IDroolsManageService droolsManageService;
	
	@Autowired
	private IRuleGroupService ruleGroupService;
	
	@Autowired
	private IDroolsRuleService droolsRuleService;
	
	@PostConstruct
	public void init() {
		EntityChangeHandler.addModel(this);
	}
	
	@Override
	public void updateRule(RuleGroup ruleGroup,List<DroolsRule> ruleList) {
		// TODO Auto-generated method stub
		droolsManageService.updateRule(ruleGroup, ruleList);
	}

	@Override
	public void fireRule(RuleAIEntity ruleAIEntity) {
		// TODO Auto-generated method stub
		droolsManageService.fireRule(ruleAIEntity);
	}

	@Override
	public void destroyRule(List<RuleGroup> ruleGroupList)
	{
		if(ruleGroupList.size()>0){
			droolsManageService.destroyRule(ruleGroupList);
		}
		
	}
	
	@Override
	public void fireResourceReomoved(Resource resource)
	{
		if (resource instanceof Rule)
		{
			//更新规则引擎
			RuleGroup ruleGroup = ruleGroupService.findOne("1");
			List<DroolsRule> droolsRules = droolsRuleService.findByGroupIdAndIsUser(ruleGroup.getId(), true);
			updateRule(ruleGroup, droolsRules);
		}
	}

}