package com.yeejoin.amos.iot.rule.log;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.apache.log4j.Logger;

import com.yeejoin.amos.iot.business.entity.SystemLog;
import com.yeejoin.amos.op.core.entity.Resource;

/**
 * 
 * <pre>
 * 日志记录
 * </pre>
 *
 * @author HK
 * @version $Id: CommonLogCollector.java, v 0.1 2018年1月19日 下午5:41:28 HK Exp $
 */
public class BizLogCollector
{
	private static final Logger log = Logger.getLogger(BizLogCollector.class);

	private static final List<LogHandler> logHandlers = new ArrayList<>();

	public static void addLogHandler(List<LogHandler> logHandler)
	{
		logHandlers.addAll(logHandler);
	}

	/**
	 * 
	 * <pre>
	 * 记录日志
	 * </pre>
	 *
	 * @param t
	 */
	public static <T extends Resource> void collect(T t)
	{
		// 把日志交给LogHandler处理
		log.info("日志处理开始");
		logHandlers.forEach(logHandler -> {
			logHandler.handle(t);
		});
		log.info("日志处理完成");
	}

	public static void collect(String logstr, LogType type)
	{
		SystemLog logObj = new SystemLog();
		logObj.setContext(logstr);
		logObj.setTime(new Date());
		logObj.setType(type.name());
		// 把日志交给LogHandler处理
		log.info("日志处理开始");
		logHandlers.forEach(logHandler -> {
			logHandler.handle(logObj);
		});
		log.info("日志处理完成");
	}

}
