package com.yeejoin.amos.iot.rule.log;

import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yeejoin.amos.iot.business.entity.SystemLog;
import com.yeejoin.amos.iot.business.service.intfc.ISystemLogService;
import com.yeejoin.amos.op.core.entity.Resource;

/**
 * 
 * <pre>
 * 日志保存到数据库
 * </pre>
 *
 * @author as-guowubin
 * @version $Id: DatabaseLogHandler.java, v 0.1 2018年4月23日 下午5:49:31 as-guowubin Exp $
 */
@Service
public class DatabaseLogHandler implements LogHandler
{

	private static final Logger log = Logger
			.getLogger(DatabaseLogHandler.class);
	// 使用日志数据库
	@Autowired
	private ISystemLogService logService;

	@Override
	public <T extends Resource> void handle(List<T> list)
	{	
		int len = list.size();
		log.info("需要保存的日志数目：" + len);
		long start = System.currentTimeMillis();
		// 保存日志
		for(T obj : list){
			handle(obj);
		}
//		logService.save(list.iterator());
		long cost = System.currentTimeMillis() - start;
		log.info("成功保存 " + len + " 条日志, 耗时: " + cost);
	}

	@Override
	public <T extends Resource> void handle(T obj)
	{
		if (obj instanceof SystemLog)
		{
			logService.save((SystemLog) obj);
			log.info("日志成功保存 ");
		}
	}

}
