package com.yeejoin.amos.iot.rxtx.reader;


import com.yeejoin.amos.iot.context.IotContext;
import com.yeejoin.amos.iot.context.RedisUtil;
import com.yeejoin.amos.iot.netty.customer.utils.ByteConvert;
import com.yeejoin.amos.iot.rxtx.SerialContext;
import org.apache.commons.lang3.ArrayUtils;
import org.apache.tools.ant.types.selectors.SizeSelector;
import org.bouncycastle.pqc.math.linearalgebra.ByteUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.locks.ReentrantLock;


public class AnyDataReader implements SerialReader {

    SerialContext serialContext;
    private String portName;
    RedisUtil redisUtil = (RedisUtil) IotContext.getInstance().getBean(RedisUtil.class);

    public AnyDataReader(SerialContext serialContext) {
        this.serialContext = serialContext;
        this.portName = serialContext.getSerialPort().getName();
    }

    @Override
    public byte[] readBytes() {
        try {
            int length = serialContext.getSerialPort().getInputStream().available();
//            String serialPort = serialContext.getSerialPort().getName();
            if (length == 0) {
                return null;
            }

            byte[] dist = new byte[length];
            serialContext.getSerialPort().getInputStream().read(dist);
//            System.out.printf("read data from %s , data : %s" , portName, ByteUtils.toHexString(dist));
//            System.out.println();
            if (dist[0] == 0 && dist[length - 1] == -2) {
                return filter(dist);
            } else if (dist[0] == 0 && dist[length - 1] != -2){
                redisUtil.set("buffer-"+ portName, new String(filter(dist)));
                return null;
            } else if (dist[0] != 0 && dist[length - 1] != -2) {
                byte[] buffer = redisUtil.get("buffer-"+ portName).toString().getBytes();
                buffer = ArrayUtils.addAll(buffer, dist);
                redisUtil.set("buffer-"+ portName, new String(filter(buffer)));
                buffer = null;
                return null;
            } else if (dist[length - 1] == -2) {
                byte[] buffer = redisUtil.get("buffer-"+ portName).toString().getBytes();
                buffer = ArrayUtils.addAll(buffer, dist);
                byte[] bytesXml = filter(buffer);
                buffer = null;
                redisUtil.set("buffer-"+ portName, "");
                return bytesXml;
            }
            return null;
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
//            System.out.printf("read data from %s read stop" , portName);
            System.out.println();
        }
        return null;
    }

    private byte[] filter(byte[] src) {
        List<Byte> list = new ArrayList<Byte>();
        for (byte b: src) {
            if (b != 0 && b != -2) {
                list.add(b);
            }
        }

        byte[] t = new byte[list.size()];
        for (int i = 0; i < list.size(); i++) {
            t[i] = list.get(i).byteValue();
        }
        list.clear();
        list = null;
        src = null;
        return t;
    }

}
