package com.yeejoin.amos.iot.rxtx.service;

import java.io.UnsupportedEncodingException;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.log4j.Logger;
import org.dom4j.DocumentException;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Service;
import org.springframework.util.ObjectUtils;

import com.yeejoin.amos.iot.rxtx.RxTxUtil;

@Service("iSerialFrameService")
@Scope("singleton")
public class SerialFrameServiceImpl implements ISerialFrameService {
    private static final Logger logger = Logger.getLogger(SerialFrameServiceImpl.class);


    private boolean checkXml(String xml) {
        String regex = "<\\?xml\\s+version=\"1.0\"\\s+encoding=\"(.*?)\"\\?>";
        Pattern pattern = Pattern.compile(regex);
        Matcher matcher = pattern.matcher(xml);
        if (matcher.matches()) {
            return true;
        }
        return false;
    }

    @Override
    public void parseData(byte[] msg) {
        String str = null;
        try {
            str = new String(msg,  "utf-8");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        msg = null;
        if (ObjectUtils.isEmpty(str)) {
            return;
        }

        String regex = "<\\?xml\\s+version=\"1.0\"\\s+encoding=\"(.*?)\"\\?>";
        String[] xmls = str.split(regex);
        for (String xml : xmls) {
            if (ObjectUtils.isEmpty(xml)) {
                continue;
            }
            StringBuffer sf = new StringBuffer();
            if (!checkXml(xml)) {
                sf.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            }

            sf.append(xml);
            logger.debug("xml:"+sf.toString());
            logger.debug("ddd"+RxTxUtil.getType(sf.toString()));
            switch (RxTxUtil.getType(sf.toString())) {
                case "Json":
                    parseJson(sf.toString());
                    break;
                case "xml":
                    parseXML(sf.toString());
                    break;
                case "Number":
                case "String":
                    parseString(sf.toString());
                    break;
                default:
                    logger.debug("unkown String type");
            }
            xml = null;
            sf = null;
        }
        xmls = null;
    }

        private void parseJson(String str) {
            logger.debug("enter str"+str);
        }

        private void parseXML(String str) {
        logger.debug("enter xml"+str);
        try {
            Map<String, Object> map = RxTxUtil.xmlToMap(str, false);
            logger.debug("enter xml map "+map.get("data").toString());
            SerialDataQueue.getInstance().add((Map) map.get("data"));
        } catch (DocumentException e) {
            logger.debug("parseXML ERROR, ERROR string is : " + str);
            e.printStackTrace();
        }
    }

    private void parseString(String str) {
        logger.debug("enter str"+str);
    }

}
