/**
 * 
 */
package com.yeejoin.amos.iot.script;

import javax.script.Invocable;
import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;

import org.apache.log4j.Logger;
import org.springframework.stereotype.Service;

import com.yeejoin.amos.iot.business.constants.IotConstant;
import com.yeejoin.amos.iot.entity.ParseResult;

/**
 * JavaScript动态脚本service实现类
 * 
 * @author as-youjun
 *
 */
@Service("javaScriptService")
public class JavaScriptServiceImpl implements IScriptService {

	/**
	 * 解析协议数据
	 */
	@Override
	public ParseResult analyze(String scriptText, Object[] args) {
		ParseResult parseResult = new ParseResult();
		try {
			ScriptEngine engine = new ScriptEngineManager().getEngineByName("nashorn");
			engine.eval(scriptText);
			Invocable invocable = (Invocable) engine;
			Object result = invocable.invokeFunction(PARSE_DATA_METHOD_NAME, args);
			parseResult.setStatus(IotConstant.SUCCESS);
			parseResult.setResult(result);
		} catch (Exception e) {
			Logger.getLogger(this.getClass()).error("parse protocol data error!" + e);
			parseResult.setStatus(IotConstant.FAILURE);
			parseResult.setErrorMsg(e.getMessage());
		}
		return parseResult;
	}

}
