/**
 * 
 */
package com.yeejoin.amos.iot.snmp;

import org.apache.log4j.Logger;

import com.adventnet.snmp.beans.SnmpTarget;
import com.adventnet.snmp.snmp2.SnmpVarBind;

/**
 * snmp协议数据采集/控制
 * 
 * @author as-youjun
 *
 */
public class SnmpOpDevice {

	/**
	 * 获取单个oid节点数据
	 * 
	 * @param snmpParam
	 * @return
	 */
	public static SnmpVarBind snmpGetVariableBinding(SnmpParam snmpParam) {
		SnmpVarBind snmpvarbind = null;

		try {
			SnmpTarget snmpSession = new SnmpTarget();
			snmpSession.setTimeoutInMilliSec(snmpParam.getTimeout());
			snmpSession.setSnmpVersion(snmpParam.getVersion());
			snmpSession.setRetries(snmpParam.getTryTimes());
			snmpSession.setTargetHost(snmpParam.getIp());
			snmpSession.setTargetPort(snmpParam.getPort());
			snmpSession.setCommunity(snmpParam.getRdComm());
			snmpSession.setMaxNumRows(snmpParam.getMaxRows());
			snmpSession.setObjectID(snmpParam.getOids()[0]);
			snmpvarbind = snmpSession.snmpGetVariableBinding();
			snmpSession.releaseResources();
		} catch (Exception e) {
			Logger.getLogger(SnmpOpDevice.class).error(e);
		}

		return snmpvarbind;
	}

	/**
	 * 获取oid集合(也可以是单个oid)对应的mib节点数据
	 * 
	 * @param snmpParam
	 * @return
	 */
	public static SnmpVarBind[] snmpGetVariableBindings(SnmpParam snmpParam) {
		SnmpVarBind[] snmpvarbinds = null;

		try {
			SnmpTarget snmpSession = new SnmpTarget();
			snmpSession.setTimeoutInMilliSec(snmpParam.getTimeout());
			snmpSession.setSnmpVersion(snmpParam.getVersion());
			snmpSession.setRetries(snmpParam.getTryTimes());
			snmpSession.setTargetHost(snmpParam.getIp());
			snmpSession.setTargetPort(snmpParam.getPort());
			snmpSession.setCommunity(snmpParam.getRdComm());
			snmpSession.setMaxNumRows(snmpParam.getMaxRows());
			snmpSession.setObjectIDList(snmpParam.getOids());
			snmpvarbinds = snmpSession.snmpGetVariableBindings();
			snmpSession.releaseResources();
		} catch (Exception e) {
			Logger.getLogger(SnmpOpDevice.class).error(e);
		}

		return snmpvarbinds;
	}

	/**
	 * 获取oid集合(也可以是单个oid)对应的mib节点数据
	 * 
	 * @param snmpParam
	 * @return
	 */
	public static SnmpVarBind[][] snmpGetAllVariableBindings(SnmpParam snmpParam) {
		SnmpVarBind[][] snmpvarbinds = null;

		try {
			SnmpTarget snmpSession = new SnmpTarget();
			snmpSession.setTimeoutInMilliSec(snmpParam.getTimeout());
			snmpSession.setSnmpVersion(snmpParam.getVersion());
			snmpSession.setRetries(snmpParam.getTryTimes());
			snmpSession.setTargetHost(snmpParam.getIp().trim());
			snmpSession.setTargetPort(snmpParam.getPort());
			snmpSession.setCommunity(snmpParam.getRdComm());
			snmpSession.setMaxNumRows(snmpParam.getMaxRows());
			snmpSession.setObjectIDList(snmpParam.getOids());
			snmpvarbinds = snmpSession.snmpGetAllVariableBindings();
			snmpSession.releaseResources();
		} catch (Exception e) {
			Logger.getLogger(SnmpOpDevice.class).error(e);
		}

		return snmpvarbinds;
	}

}
