package com.yeejoin.amos.iot.snmp;

/**
 * snmp版本枚举
 * 
 * @author as-youjun
 *
 */
public enum SnmpVersion {

	// snmp版本：-1表示未知,1表示V1，1表示V2C，3表示V3
	UNKNOWN("UNKNOWN", -1), V1("V1", 0), V2C("V2C", 1), V3("V3", 3);

	/**
	 * 名称
	 */
	private String name;

	/**
	 * 值
	 */
	private int value;

	// 构造方法
	private SnmpVersion(String name, int value) {
		this.name = name;
		this.value = value;
	}

	/**
	 * 
	 * <pre>
	 * 获取索引名称
	 * </pre>
	 *
	 * @param value
	 * @return
	 */
	public static String getName(int value) {
		for (SnmpVersion c : SnmpVersion.values()) {
			if (c.getValue() == value) {
				return c.name;
			}
		}
		return null;
	}

	/**
	 * 
	 * <pre>
	 * 获取索引
	 * </pre>
	 *
	 * @param value
	 * @return
	 */
	public static SnmpVersion getEnum(int value) {
		for (SnmpVersion c : SnmpVersion.values()) {
			if (c.getValue() == value) {
				return c;
			}
		}
		return null;
	}

	/**
	 * 
	 * <pre>
	 * 获取索引
	 * </pre>
	 *
	 * @param name
	 * @return
	 */
	public static SnmpVersion getEnum(String name) {
		for (SnmpVersion c : SnmpVersion.values()) {
			if (c.getName().equals(name)) {
				return c;
			}
		}
		return null;
	}

	/**
	 * Getter method for property <tt>name</tt>.
	 * 
	 * @return property value of name
	 */
	public String getName() {
		return name;
	}

	/**
	 * Setter method for property <tt>name</tt>.
	 * 
	 * @param name
	 *            value to be assigned to property name
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Getter method for property <tt>value</tt>.
	 * 
	 * @return property value of value
	 */
	public int getValue() {
		return value;
	}

	/**
	 * Setter method for property <tt>value</tt>.
	 * 
	 * @param value
	 *            value to be assigned to property value
	 */
	public void setValue(int value) {
		this.value = value;
	}

}
