package com.yeejoin.amos.iot.snmp.groovy

import net.sf.json.JSONObject
import org.apache.commons.collections.MapUtils

/**
 * 解析协议数据
 *
 * @param originals
 * @return
 */
public Object parseData(Object[] originals) {
    Map<String, Double> resultMap = new HashMap();
    if ((originals != null) && (originals.length > 0) && (originals[0] != null)) {
        Map<String, String> valueMap = (Map<String, String>) originals[0];
        String index = "";
        double hrStorageAllocationUnits = 0;//内存分配单元大小(字节)
        double hrStorageSize = 0;//内存总单元数
        double hrStorageUsed = 0;//内存已使用单元数
        if (MapUtils.isNotEmpty(valueMap)) {
            //1.获取index
            Iterator<String> iterator = valueMap.keySet().iterator();
            while (iterator.hasNext()) {
                String objectID = iterator.next();
                String variable = valueMap.get(objectID);
                if ("Physical Memory".equalsIgnoreCase(variable)) {
                    String[] array = objectID.split("\\.");
                    index = array[array.length - 1];
                    break;
                }
            }
            //2.获取:内存分配单元大小(字节)、内存总单元数、内存已使用单元数
            //内存分配单元大小(字节)
            if (valueMap.get(".1.3.6.1.2.1.25.2.3.1.4." + index) != null) {
                hrStorageAllocationUnits = Double.valueOf(valueMap.get(".1.3.6.1.2.1.25.2.3.1.4." + index));
            }
            //内存总单元数
            if (valueMap.get(".1.3.6.1.2.1.25.2.3.1.5." + index) != null) {
                hrStorageSize = Double.valueOf(valueMap.get(".1.3.6.1.2.1.25.2.3.1.5." + index));
            }
            //内存已使用单元数
            if (valueMap.get(".1.3.6.1.2.1.25.2.3.1.6." + index) != null) {
                hrStorageUsed = Double.valueOf(valueMap.get(".1.3.6.1.2.1.25.2.3.1.6." + index));
            }

            if (hrStorageAllocationUnits > 0 && hrStorageSize > 0 && hrStorageUsed > 0) {
                double memTotalSize = hrStorageSize * hrStorageAllocationUnits / (1024 * 1024);//内存总大小(MB)
                BigDecimal bdMemTotalSize   =   new   BigDecimal(memTotalSize);
                memTotalSize =  bdMemTotalSize.setScale(2,   BigDecimal.ROUND_HALF_UP).doubleValue();
                double memUsedSize = hrStorageUsed * hrStorageAllocationUnits / (1024 * 1024);//内存已使用量(MB)
                BigDecimal bdMemUsedSize   =   new   BigDecimal(memUsedSize);
                memUsedSize =  bdMemUsedSize.setScale(2,   BigDecimal.ROUND_HALF_UP).doubleValue();
                double memRemainSize = memTotalSize - memUsedSize;//内存剩余量(MB)
                BigDecimal bdMemRemainSize   =   new   BigDecimal(memRemainSize);
                memRemainSize =  bdMemRemainSize.setScale(2,   BigDecimal.ROUND_HALF_UP).doubleValue();
                double memRate = memUsedSize / memTotalSize * 100;//内存使用率
                BigDecimal bdMemRate  =   new   BigDecimal(memRate);
                memRate =  bdMemRate.setScale(2,   BigDecimal.ROUND_HALF_UP).doubleValue();
                resultMap.put("memTotalSize", memTotalSize);
                resultMap.put("memUsedSize", memUsedSize);
                resultMap.put("memRemainSize", memRemainSize);
                resultMap.put("memRate", memRate);
            }
        }
    } else {
        System.out.println("originals is empty!");
    }
    return JSONObject.fromObject(resultMap).toString();
}
