/**
 * 
 */
package com.yeejoin.amos.iot.socket.websocket;

import java.util.HashMap;

import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.cloud.openfeign.support.SpringEncoder;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import com.yeejoin.amos.iot.socket.websocket.alarm.AlarmMessage;
import com.yeejoin.amos.iot.socket.websocket.service.MetricDataMessage;
import com.yeejoin.amos.iot.socket.websocket.service.MorphicMessage;
import com.yeejoin.amos.op.core.common.response.CommonResponse;

/**
 * websocketservice客户端
 * 
 * @author as-youjun
 *
 */
@FeignClient(name = "AmosWebsocket", configuration = SpringEncoder.class, fallback = WebsocketClientFallback.class)
public interface WebsocketClient {

	/**
	 * 发送告警消息
	 * 
	 * @param message
	 * @return
	 */
	@PostMapping("/sendAlarmDataMessage")
	CommonResponse sendAlarmDataMessage(@RequestBody AlarmMessage message);

	/**
	 * 发送指标消息
	 * 
	 * @param message
	 * @return
	 */
	@PostMapping("/sendMetricDataMessage")
	CommonResponse sendMetricDataMessage(@RequestBody MetricDataMessage message);

	/**
	 * 发送指标消息
	 * 
	 * @param message
	 * @return
	 */
	@PostMapping("/sendMorphicMessage")
	CommonResponse sendMorphicMessage(@RequestBody MorphicMessage message);

	/**
	 * 发送消息
	 * 
	 * @param message
	 * @return
	 */
	@PostMapping("/sendMessage")
	CommonResponse sendMessage(@RequestBody CommonMessage message);


	/**
	 * 发送消息
	 *
	 * @param message
	 * @return
	 */
	@PostMapping("/generic/sendMessage")
	CommonResponse sendMessage(@RequestBody HashMap<String, Object> message);

}
