package com.yeejoin.amos.iot.socket.websocket;

import com.yeejoin.amos.iot.socket.websocket.alarm.AlarmMessage;
import com.yeejoin.amos.iot.socket.websocket.service.MetricDataMessage;
import com.yeejoin.amos.iot.socket.websocket.service.MorphicMessage;
import com.yeejoin.amos.op.core.common.response.CommonResponse;

import java.util.HashMap;

/**
 * websocketservice调用熔断处理
 * 
 * @author as-youjun
 *
 */
public class WebsocketClientFallback implements WebsocketClient {

	@Override
	public CommonResponse sendAlarmDataMessage(AlarmMessage message) {
		// 熔断处理暂时如下处理,后续完善
		CommonResponse commonResponse = new CommonResponse();
		commonResponse.setResult("FAILED");
		return commonResponse;
	}

	@Override
	public CommonResponse sendMetricDataMessage(MetricDataMessage message) {
		CommonResponse commonResponse = new CommonResponse();
		commonResponse.setResult("FAILED");
		return commonResponse;
	}

	@Override
	public CommonResponse sendMessage(CommonMessage message) {
		CommonResponse commonResponse = new CommonResponse();
		commonResponse.setResult("FAILED");
		return commonResponse;
	}

	@Override
	public CommonResponse sendMessage(HashMap<String, Object> message) {
		CommonResponse commonResponse = new CommonResponse();
		commonResponse.setResult("FAILED");
		return commonResponse;
	}

	@Override
	public CommonResponse sendMorphicMessage(MorphicMessage message) {
		// TODO Auto-generated method stub
		CommonResponse commonResponse = new CommonResponse();
		commonResponse.setResult("FAILED");
		return commonResponse;
	}

}
