/**
 * 
 */
package com.yeejoin.amos.iot.socket.websocket.alarm;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yeejoin.amos.iot.socket.websocket.WebsocketClient;

/**
 * websocket服务实现类
 * 
 * @author as-lichenglong
 *
 */
@Service("alarmSocketService")
public class AlarmSocketServiceImpl implements IAlarmSocketService {

	@Autowired
	private WebsocketClient websocketClient;

	@Override
	public void sendAlarmDataMessage(Long userId, String jsonData, String target) {
		AlarmMessage message = new AlarmMessage();
		message.setUserId(userId);
		message.setTarget(target);
		message.setJsonData(jsonData);
		websocketClient.sendAlarmDataMessage(message);
	}

	@Override
	public void sendAlarmDataMessage(String jsonData, String target) {
		AlarmMessage message = new AlarmMessage();
		message.setTarget(target);
		message.setJsonData(jsonData);
		websocketClient.sendAlarmDataMessage(message);
	}
}
