/**
 * 
 */
package com.yeejoin.amos.iot.socket.websocket.service;

import java.util.HashMap;
import java.util.List;

import com.yeejoin.amos.iot.rxtx.service.SerialFrameServiceImpl;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.yeejoin.amos.iot.socket.websocket.WebsocketClient;

/**
 * websocket服务实现类
 * 
 * @author as-youjun
 *
 */
@Service("webSocketService")
public class WebSocketServiceImpl implements IWebSocketService {
	private static final Logger logger = Logger.getLogger(WebSocketServiceImpl.class);

	@Autowired
	private WebsocketClient websocketClient;

	/**
	 * 向前端推送指标数据
	 */
	@Override
	public void sendMetricDataMessage(List<Long> subGraphIds, String jsonData,
			String target) {
		logger.error(" websocket ++++" +target );

		try {
	new Thread(() -> {

		MetricDataMessage message = new MetricDataMessage();
		message.setSubGraphIds(subGraphIds);
		message.setTarget(target);
		message.setJsonData(jsonData);
		websocketClient.sendMetricDataMessage(message);

	}).start();
} catch (Exception e) {
	e.printStackTrace();
}


	}

	/**
	 * 向前端推送指标数据
	 */
	@Override
	public void sendMetricDataMessage(Long userId, String jsonData,
			String target) {
		MetricDataMessage message = new MetricDataMessage();
		message.setUserId(userId);
		message.setTarget(target);
		message.setJsonData(jsonData);
		websocketClient.sendMetricDataMessage(message);
	}

	/**
	 * 向所有前端推送指标数据
	 */
	@Override
	public void sendMetricDataMessage(String jsonData, String target) {
		MetricDataMessage message = new MetricDataMessage();
		message.setTarget(target);
		message.setJsonData(jsonData);
		websocketClient.sendMetricDataMessage(message);
	}

	@Override
	public void sendMetricDataMessage(HashMap<String, Object> message) {
		websocketClient.sendMessage(message);
	}

}
