package com.yeejoin.amos.iot.test.js;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.UnsupportedEncodingException;

import javax.script.Invocable;
import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;

import com.yeejoin.amos.iot.netty.vehicle.entity.GprmcInfo;

import net.sf.json.JSONObject;

public class TestJs {

	private static final String testGpsdata = "$GPRMC,132311.00,A,2259.50813,N,11302.34754,E,21.374,91.77,150517,,,D*67\r\n-";

	public static void test1() {
		ScriptEngine engine = new ScriptEngineManager().getEngineByName("nashorn");
		try {
			engine.eval(new FileReader("src/test/java/com/yeejoin/amos/iot/test/js/test.js"));
			Invocable invocable = (Invocable) engine;
			byte[] bytes = testGpsdata.getBytes();
			Object[] args = new Object[] { bytes, "sid0001" };
			Object result = invocable.invokeFunction("parseData", args);
			System.out.println(result);
			System.out.println(result.getClass());
			GprmcInfo gprmcInfo = (GprmcInfo) JSONObject.toBean(JSONObject.fromObject(result), GprmcInfo.class);
			System.out.println(gprmcInfo);
		} catch (FileNotFoundException | ScriptException | NoSuchMethodException e) {
			e.printStackTrace();
		}
	}

	public static void test2() {
		try {
			ScriptEngineManager manager = new ScriptEngineManager();
			ScriptEngine engine = manager.getEngineByName("JavaScript");
			engine.eval(new FileReader("src/main/java/com/yeejoin/amos/iot/js/test.js"));
			Invocable invocable = (Invocable) engine;
			byte[] bytes = testGpsdata.getBytes("UTF-8");
			Object result = invocable.invokeFunction("parseData", "sid001", bytes);
			System.out.println(result);
			System.out.println(result.getClass());
			GprmcInfo gprmcInfo = (GprmcInfo) JSONObject.toBean(JSONObject.fromObject(result), GprmcInfo.class);
			System.out.println(gprmcInfo);
		} catch (FileNotFoundException | UnsupportedEncodingException | NoSuchMethodException | ScriptException e) {
			e.printStackTrace();
		}
	}

	public static void test3() {
		try {
			ScriptEngineManager manager = new ScriptEngineManager();
			ScriptEngine engine = manager.getEngineByName("JavaScript");
			engine.eval(new FileReader("src/main/java/com/yeejoin/amos/iot/js/test.js"));
			Invocable invocable = (Invocable) engine;
			byte[] bytes = "$GPRMC,132311.00,A,2259.50813,N,11302.34754,E,21.374,91.77,150517,,,D*67".getBytes("UTF-8");
			Object result = invocable.invokeFunction("bytes2HexStringWithDelimiter", bytes, ",");
			System.out.println(result);
			System.out.println(result.getClass());
		} catch (FileNotFoundException | UnsupportedEncodingException | NoSuchMethodException | ScriptException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		test1();
		// test2();
		// test3();
	}

}
