## 说明：将基础平台服务打包成docker镜像，并推送到私服保存。
## 需要登录本地私服，然后才能推送

export AMOS_VERSION=3.1.22
## 部署环境



#工作目录
rm -f Dockerfile-iot

WORKDIR /home/amos
#Dockerfile-dashboard
echo "FROM 172.16.3.99:9980/library/serverjre:v8
MAINTAINER magintursh
COPY target/yee-amos-iot-start-$AMOS_VERSION.jar  ./
WORKDIR /
ENV NACOS_HOST amos-nacos
ENV NACOS_PORT 8848
ENV NACOS_DISCOVERY_NAMESPACE qa
ENV SPRING_PROFILES_ACTIVE docker
EXPOSE  30009
CMD java -jar yee-amos-iot-start-$AMOS_VERSION.jar --spring.profiles.active=\$SPRING_PROFILES_ACTIVE --nacos.discovery.namespace=\$NACOS_DISCOVERY_NAMESPACE --nacos.host=\$NACOS_HOST --nacos.port=\$NACOS_PORT"  > Dockerfile-iot

#删除已有的镜像
sudo docker rmi 172.16.3.99:9980/amos-project/yee-amos-iot-start:$AMOS_VERSION


#构建新的镜像
sudo docker build -t 172.16.3.99:9980/amos-project/yee-amos-iot-start:$AMOS_VERSION --pull -f Dockerfile-iot .


#删除临时创建的Dockerfile
sudo rm -f Dockerfile-iot


## 推送到私服保存
#sudo docker push 172.16.3.99:9980/amos-project/yee-amos-iot-start:$AMOS_VERSION