UPDATE `t_protocol`
SET `script_code` = 'import java.util.Calendar;\r\nimport java.text.SimpleDateFormat;\r\nimport groovy.json.JsonOutput;\r\n\r\n    String parseData(byte[] bytesData, String sourceID) {\r\n    Map gprmcInfo = [:]\r\n    String[] datas = new String(bytesData).split(\",\");\r\n    if (datas.length == 13) {\r\n      gprmcInfo.put(\'sourceId\', sourceID);\r\n      gprmcInfo.put(\'formatTime\', transTime(datas[1], datas[9]));\r\n      gprmcInfo.put(\'status\', transStatus(datas[2]));\r\n      gprmcInfo.put(\'latitude\', transLatitude(datas[3], datas[4]));\r\n      gprmcInfo.put(\'indicatorNS\', datas[4]);\r\n      gprmcInfo.put(\'longitude\', transLongitude(datas[5], datas[6]));\r\n      gprmcInfo.put(\'indicatorEW\', datas[6]);\r\n      gprmcInfo.put(\'speed\', datas[7]);\r\n      gprmcInfo.put(\'direction\', datas[8]);\r\n      gprmcInfo.put(\'dayTime\', datas[9]);\r\n      gprmcInfo.put(\'poleNum\', datas[10]);\r\n      gprmcInfo.put(\'checkNum\', datas[12]);\r\n	  gprmcInfo.put(\'type\', \'gps\');\r\n    }\r\n    return JsonOutput.toJson(gprmcInfo);\r\n  }\r\n\r\n    public String  transTime(String time, String day) {\r\n    if (\"\".equals(time) || \"\".equals(day)) {\r\n      return \"空\";\r\n    }\r\n    Calendar rightNow = Calendar.getInstance();\r\n    rightNow.set(Integer.valueOf(\"20\" + day.substring(4, 6)), Integer.valueOf(day.substring(2, 4)) - 1,\r\n        Integer.valueOf(day.substring(0, 2)), Integer.valueOf(time.substring(0, 2)),\r\n        Integer.valueOf(time.substring(2, 4)),\r\n        Integer.valueOf(time.substring(4, 6)));\r\n    rightNow.add(Calendar.HOUR_OF_DAY, 8);\r\n        SimpleDateFormat simpleDataFormat = new SimpleDateFormat(\"yyyy-MM-dd HH:mm:ss\");\r\n    return simpleDataFormat.format(rightNow.getTime());\r\n  }  \r\n\r\n  public String transStatus(String status) {\r\n    String message = \"\";\r\n    if (\"A\".equals(status)) {\r\n      message = \"信息可用\";\r\n    } else if (\"V\".equals(status)) {\r\n      message = \"信息不可用\";\r\n    }\r\n    return message;\r\n  }\r\n  \r\n  public Double transLatitude(String latitude) {\r\n    if (\"\".equals(latitude)) {\r\n      return 0;\r\n    }\r\n  \r\n    StringBuffer sBuffer = new StringBuffer();\r\n    double hour = Double.valueOf(latitude.substring(0, 2));\r\n    double minute = Double.valueOf(latitude.substring(2, latitude.length()));\r\n    double locate = hour + minute / 60;\r\n  \r\n    sBuffer.append(locate);\r\n    return Double.valueOf(sBuffer.toString());\r\n  }\r\n  \r\n  public Double transLatitude(String latitude, String indicator) {\r\n    if (\"\".equals(latitude)) {\r\n      return 0;\r\n    }\r\n  \r\n    StringBuffer sBuffer = new StringBuffer();\r\n    double hour = Double.valueOf(latitude.substring(0, 2));\r\n    double minute = Double.valueOf(latitude.substring(2, latitude.length()));\r\n    double locate = hour + minute / 60;\r\n  \r\n    if (\"S\".equals(indicator)) {\r\n      locate = 0 - locate;\r\n    }\r\n  \r\n    sBuffer.append(locate);\r\n    return Double.valueOf(sBuffer.toString());\r\n  }\r\n  \r\n  public Double transLongitude(String longitude) {\r\n    if (\"\".equals(longitude)) {\r\n      return 0;\r\n    }\r\n    StringBuffer sBuffer = new StringBuffer();\r\n  \r\n    double hour = Double.valueOf(longitude.substring(0, 3));\r\n    double minute = Double.valueOf(longitude.substring(3, longitude.length()));\r\n    double locate = hour + minute / 60;\r\n  \r\n    sBuffer.append(locate);\r\n    return Double.valueOf(sBuffer.toString());\r\n  }\r\n  \r\n  public Double transLongitude(String longitude, String indicator) {\r\n    if (\"\".equals(longitude)) {\r\n      return 0;\r\n    }\r\n    StringBuffer sBuffer = new StringBuffer();\r\n  \r\n    double hour = Double.valueOf(longitude.substring(0, 3));\r\n    double minute = Double.valueOf(longitude.substring(3, longitude.length()));\r\n    double locate = hour + minute / 60;\r\n  \r\n    if (\"W\".equals(indicator)) {\r\n      locate = 360 - locate;\r\n    }\r\n    sBuffer.append(locate);\r\n  \r\n    return Double.valueOf(sBuffer.toString());\r\n  }\r\n  \r\n  public String transTime(String time) {\r\n    StringBuffer sBuffer = new StringBuffer();\r\n    Calendar calendar = Calendar.getInstance();\r\n    sBuffer.append(calendar.get(Calendar.YEAR)).append(\"年\");\r\n    sBuffer.append(calendar.get(Calendar.MONTH)).append(\"月\");\r\n    sBuffer.append(calendar.get(Calendar.DAY_OF_MONTH)).append(\"日\");\r\n    sBuffer.append(time.substring(0, 2)).append(\"时\");\r\n    sBuffer.append(time.substring(2, 4)).append(\"分\");\r\n    sBuffer.append(time.substring(6, time.length())).append(\"秒\");\r\n    return sBuffer.toString();\r\n  }\r\n  \r\n  public String transIndicator(String indicator) {\r\n    String message = \"\";\r\n    try {\r\n      int indicate = Integer.valueOf(indicator);\r\n      switch (indicate) {\r\n        case 0:\r\n          message = \"未定位或无效的定位\";\r\n          break;\r\n        case 1:\r\n          message = \"GPS SPS 格式（SPS 为商业用途格式），已定位\";\r\n          break;\r\n        case 2:\r\n          message = \"偏差修正GPS（即DGPS），SPS格式，已定位\";\r\n          break;\r\n        case 3:\r\n          message = \"GPS PPS定位（PPS为军用格式），已定位\";\r\n          break;\r\n        default:\r\n          break;\r\n      }\r\n    } catch (Exception e) {\r\n      e.printStackTrace();\r\n    }\r\n    return message;\r\n  }'
WHERE `id` = 1;
UPDATE `t_protocol`
SET `script_code` = 'import groovy.json.JsonOutput;\r\nimport com.yeejoin.amos.iot.netty.vehicle.MessageCommonUtil\r\n\r\nString parseData(byte[] bytesData, String sourceID) {\r\n	byte COMMON_LABEL = (byte) 0x55; // 普通标签头\r\n	byte AI_LIQUID_LEVEL_LABEL = (byte) 0x56; // 模拟量液位标签头\r\n	byte UT_LIQUID_LEVEL_LABEL = (byte) 0x57; // 超声波液位标签头\r\n	byte OBD_REAL_TIME_DATA_LABEL = (byte) 0x59; // OBD及时数据\r\n	byte OBD_STATISTIC_DATA_LABEL = (byte) 0x5A; // OBD及时数据\r\n	byte OBD_ALARM_DATA_LABEL = (byte) 0x5B; // OBD及时数据\r\n	byte TPMS_DATA_LABEL = (byte) 0x5C; // 胎压监测系统数据\r\n	\r\n	String emptyResult = JsonOutput.toJson([:]);\r\n	if (!bytesData) {\r\n		return emptyResult\r\n	}\r\n\r\n	switch (bytesData[0]) {\r\n		case COMMON_LABEL:\r\n			return parseCommonLables(bytesData, sourceID);\r\n		case AI_LIQUID_LEVEL_LABEL:\r\n			return parseAILiquidLevelLable(bytesData, sourceID);\r\n		case UT_LIQUID_LEVEL_LABEL:\r\n			return parseUTLiquidLevelLable(bytesData, sourceID);\r\n		case OBD_REAL_TIME_DATA_LABEL:\r\n			return parseObdRaeltimeDataLabel(bytesData, sourceID);\r\n		case OBD_STATISTIC_DATA_LABEL:\r\n			return parseObdStatisticDataLabel(bytesData, sourceID);\r\n		case OBD_ALARM_DATA_LABEL:\r\n			return parseObdAlarmDataLabel(bytesData, sourceID);\r\n		case TPMS_DATA_LABEL:\r\n			return parseTpmsDataLabel(bytesData, sourceID);\r\n		default:\r\n			return emptyResult;\r\n	}\r\n}\r\n\r\nString parseCommonLables(byte[] data, String sourceID) {\r\n	int ONE_COMMON_LORA_LENGTH = 6; // 普通lora标签长度\r\n	byte COMMON_LABEL = (byte) 0x55; // 普通标签头\r\n	Map commonLables = [:];\r\n	List idList = [];\r\n	for (int i = 0; i < data.length / ONE_COMMON_LORA_LENGTH; i++) {\r\n		int start = i * ONE_COMMON_LORA_LENGTH;\r\n		int end = start + ONE_COMMON_LORA_LENGTH - 1;\r\n		byte[] lora = data[start..end] as byte[];\r\n		Map map = parseCommonLable(lora);\r\n		if (!map.isEmpty()) {\r\n			idList << map[\'labelId\'];\r\n		}\r\n	}\r\n\r\n	if (!idList.isEmpty()) {\r\n		commonLables.put(\'sourceId\', sourceID);\r\n		commonLables.put(\'type\', COMMON_LABEL);\r\n		commonLables.put(\'ids\', idList);;\r\n	}\r\n\r\n	return JsonOutput.toJson(commonLables);\r\n}\r\n\r\nMap parseCommonLable(byte[] lora) {\r\n	byte COMMON_LABEL = (byte) 0x55; // 普通标签头\r\n	Map map = [:];\r\n	if (checksum(lora)) {\r\n		String labelId = MessageCommonUtil.bytes2HexString(lora[1..3] as byte[]);\r\n		if (COMMON_LABEL == lora[0]) {\r\n			map.put(\"labelId\", labelId);\r\n			map.put(\"runningTime\", MessageCommonUtil.convertByte2Unsigned(lora[4]));\r\n		}\r\n	}\r\n\r\n	return map;\r\n}\r\n\r\nString parseAILiquidLevelLable(byte[] data, String sourceID) {\r\n	int ONE_AI_LIQUID_LEVEL_LORA_LENGTH = 13; // 模拟量液位lora标签长度\r\n	if (ONE_AI_LIQUID_LEVEL_LORA_LENGTH != data.length) {\r\n		Map errorResult = [:];\r\n		errorResult[\'errorMessage\'] = errorMessage(data, \", 平板模拟量液位标签长度不是13：\", sourceID);\r\n		return JsonOutput.toJson(errorResult);\r\n	}\r\n	if (!checksum(data)) {\r\n		Map errorResult = [:];\r\n		errorResult[\'errorMessage\'] = errorMessage(data, \", 平板模拟量液位标签校验和失败：\", sourceID);\r\n		return JsonOutput.toJson(errorResult);\r\n	}\r\n	String labelId = MessageCommonUtil.bytes2HexString(data[1..3] as byte[]);\r\n	int firstCircuitValue = MessageCommonUtil.convertTwoBytes2Uint16(data[5], data[4]);\r\n	int secondCircuitValue = MessageCommonUtil.convertTwoBytes2Uint16(data[7], data[6]);\r\n	int thirdCircuitValue = MessageCommonUtil.convertTwoBytes2Uint16(data[9], data[8]);\r\n	int fourthCircuitValue = MessageCommonUtil.convertTwoBytes2Uint16(data[11], data[10]);\r\n	Map result = [:];\r\n	result.put(\"sourceId\", sourceID);\r\n	result.put(\"type\", data[0]);\r\n	result.put(\"labelId\", labelId);\r\n	result.put(\"firstCircuit\", firstCircuitValue);\r\n	result.put(\"secondCircuit\", secondCircuitValue);\r\n	result.put(\"thirdCircuit\", thirdCircuitValue);\r\n	result.put(\"fourthCircuit\", fourthCircuitValue);\r\n	\r\n	return JsonOutput.toJson(result);\r\n}\r\n\r\nprivate String parseUTLiquidLevelLable(byte[] data, String sourceID) {\r\n	int ONE_UT_LIQUID_LEVEL_LORA_LENGTH = 9; // 超声波液位lora标签长度\r\n	if (ONE_UT_LIQUID_LEVEL_LORA_LENGTH != data.length) {\r\n		Map errorResult = [:];\r\n		errorResult[\'errorMessage\'] = errorMessage(data, \", 平板超声波液位标签长度不是9：\", sourceID);\r\n		return JsonOutput.toJson(errorResult);\r\n	}\r\n	if (!checksum(data)) {\r\n		Map errorResult = [:];\r\n		errorResult[\'errorMessage\'] = errorMessage(data, \", 平板超声波液位标签校验和失败：\", sourceID);\r\n		return JsonOutput.toJson(errorResult);\r\n	}\r\n	String labelId = MessageCommonUtil.bytes2HexString(MessageCommonUtil.getAnyPartMessage(data, 1, 3));\r\n	int fifthCircuitValue = MessageCommonUtil.convertTwoBytes2Uint16(data[5], data[4]);\r\n	int sixthCircuitValue = MessageCommonUtil.convertTwoBytes2Uint16(data[7], data[6]);\r\n	Map result = [:];\r\n	result.put(\"sourceId\", sourceID);\r\n	result.put(\"type\", data[0]);\r\n	result.put(\"labelId\", labelId);\r\n	result.put(\"fifthCircuit\", fifthCircuitValue);\r\n	result.put(\"sixthCircuit\", sixthCircuitValue);\r\n	\r\n	return JsonOutput.toJson(result);\r\n}\r\n\r\nString parseObdRaeltimeDataLabel(byte[] data, String sourceID) {\r\n	int ONE_OBD_REAL_TIME_LORA_LENGTH = 9; // OBD实时数据lora标签长度\r\n	Map realtimeData = [:];\r\n	if (ONE_OBD_REAL_TIME_LORA_LENGTH == data.length && checksum(data)) {\r\n		String labelId = MessageCommonUtil.bytes2HexString(data[1..2] as byte[]);\r\n		int engineFuel = MessageCommonUtil.convertTwoBytes2Uint16(data[4], data[3]);\r\n		int engineSpeed = MessageCommonUtil.convertTwoBytes2Uint16(data[6], data[5]);\r\n		int speed = MessageCommonUtil.convertByte2Unsigned(data[7]);\r\n		realtimeData.put(\"sourceId\", sourceID);\r\n		realtimeData.put(\"type\", data[0]);\r\n		realtimeData.put(\"labelId\", labelId);\r\n		realtimeData.put(\"engineFuel\", engineFuel); // 瞬时油耗\r\n		realtimeData.put(\"engineSpeed\", engineSpeed); // 发动机转速\r\n		realtimeData.put(\"speed\", speed); // 车速\r\n	} else {\r\n		String errorMessage = errorMessage(data, \", OBD实时数据标签长度不是9或者校验和失败：\", sourceID);\r\n		realtimeData.put(\"errorMessage\", errorMessage);\r\n	}\r\n	\r\n	return JsonOutput.toJson(realtimeData);\r\n}\r\n\r\nString parseObdStatisticDataLabel(byte[] data, String sourceID) {\r\n	int ONE_OBD_STATISTIC_LORA_LENGTH = 8; // OBD统计数据lora标签长度\r\n	Map statisticData = [:]\r\n	if (ONE_OBD_STATISTIC_LORA_LENGTH == data.length && checksum(data)) {\r\n		String labelId = MessageCommonUtil.bytes2HexString(data[1..2] as byte[]);\r\n		int voltage = MessageCommonUtil.convertTwoBytes2Uint16(data[4], data[3]);\r\n		int waterTemperature = MessageCommonUtil.convertByte2Unsigned(data[5]);\r\n		int remainingFuel = MessageCommonUtil.convertByte2Unsigned(data[6]);\r\n		statisticData.put(\"sourceId\", sourceID);\r\n		statisticData.put(\"type\", data[0]);\r\n		statisticData.put(\"labelId\", labelId);\r\n		statisticData.put(\"voltage\", voltage); // 电压\r\n		statisticData.put(\"waterTemperature\", waterTemperature); // 水温\r\n		statisticData.put(\"remainingFuel\", remainingFuel); // 剩余油量\r\n	} else {\r\n		String errorMessage = errorMessage(data, \", OBD统计数据标签长度不是8或者校验和失败：\", sourceID);\r\n		statisticData.put(\"errorMessage\", errorMessage);\r\n	}\r\n	\r\n	return JsonOutput.toJson(statisticData);\r\n}\r\n\r\nString parseObdAlarmDataLabel(byte[] data, String sourceID) {\r\n	int ONE_OBD_ALARM_LORA_LENGTH = 6; // OBD报警数据lora标签长度\r\n	Map alarmData = [:];\r\n	if (ONE_OBD_ALARM_LORA_LENGTH == data.length && checksum(data)) {\r\n		alarmData.put(\"sourceId\", sourceID);\r\n		alarmData.put(\"type\", data[0]);\r\n		alarmData.put(\"labelId\", MessageCommonUtil.bytes2HexString(data[1..2] as byte[]));\r\n		alarmData.put(\"alarmType\", MessageCommonUtil.convertByte2Unsigned(data[3])); // 报警类型\r\n		alarmData.put(\"alarmData\", MessageCommonUtil.convertByte2Unsigned(data[4])); // 报警数据\r\n	} else {\r\n		String errorMessage = errorMessage(data, \", OBD报警数据标签长度不是6或者校验和失败：\", sourceID);\r\n		alarmData.put(\"errorMessage\", errorMessage);\r\n	}\r\n	\r\n	return JsonOutput.toJson(alarmData);\r\n}\r\n\r\nString parseTpmsDataLabel(byte[] data, String sourceID) {\r\n	int ONE_TPMS_LORA_LENGTH = 11; // OBD报警数据lora标签长度\r\n	Map tpmsData = [:];\r\n	if (ONE_TPMS_LORA_LENGTH == data.length && checksum(data)) {\r\n		String labelId = MessageCommonUtil.bytes2HexString(data[1..4] as byte[]);\r\n		double voltage = MessageCommonUtil.convertByte2Unsigned(data[5]) * 0.01 + 1.12;\r\n		double pressure = MessageCommonUtil.convertTwoBytes2Uint16(data[7], data[6]) * 1.572 * 2;\r\n		int temperature = MessageCommonUtil.convertByte2Unsigned(data[8]) - 55;\r\n		int state = MessageCommonUtil.convertByte2Unsigned(data[9]);\r\n		tpmsData.put(\"sourceId\", sourceID);\r\n		tpmsData.put(\"type\", data[0]);\r\n		tpmsData.put(\"labelId\", labelId); // 传感器id\r\n		tpmsData.put(\"voltage\", voltage); // 传感器电压，单位：V\r\n		tpmsData.put(\"pressure\", pressure); // 胎压，单位：kPa\r\n		tpmsData.put(\"temperature\", temperature); // 温度，单位：摄氏度\r\n		tpmsData.put(\"state\", state); // 状态位，无符号整型\r\n	} else {\r\n		String errorMessage = errorMessage(data, \", TPMS胎压监测数据长度不是10或者校验和失败：\", sourceID);\r\n		tpmsData.put(\"errorMessage\", errorMessage);\r\n	}\r\n	\r\n	return JsonOutput.toJson(tpmsData);\r\n}\r\n\r\nString errorMessage(byte[] data, String errorMessage, String sourceID) {\r\n	return \"sid：\" + sourceID + errorMessage + \"， 报文：\" + MessageCommonUtil.bytes2HexStringWithSpace(data);\r\n}\r\n\r\nboolean checksum(byte[] lora) {\r\n	int sum = 0;\r\n	for (int i = 0; i < lora.length - 1; i++) {\r\n		sum += (lora[i] & 0xff);\r\n	}\r\n	return (sum & 0xff) == (lora[lora.length - 1] & 0xff);\r\n}'
WHERE `id` = 2;
UPDATE `t_protocol`
SET `script_code` = 'import groovy.json.JsonOutput;\r\n    import com.yeejoin.amos.iot.netty.vehicle.MessageCommonUtil;\r\n    import java.text.SimpleDateFormat\r\n\r\n    String parseData(byte[] bytesData, String sourceID) {\r\n        String dataString = new String(bytesData);\r\n        String[] strings = dataString.split(\',\');\r\n        Map gprmcInfo = [:];\r\n        if (strings.length != 7) {\r\n            String errorMessage = errorMessage(bytesData, \'，平板终端的GPS报文数据格式不正确\', sourceID);\r\n            gprmcInfo.put(\"errorMessage\", errorMessage);\r\n        } else {\r\n            gprmcInfo.put(\'type\', \'gps\');\r\n            gprmcInfo.put(\'sourceId\', sourceID);\r\n            gprmcInfo.put(\'formatTime\', transTime(strings[0]));\r\n            gprmcInfo.put(\'latitude\', round(strings[1], 6));\r\n            gprmcInfo.put(\'longitude\', round(strings[2], 6));\r\n            gprmcInfo.put(\'speed\', strings[4]);\r\n            gprmcInfo.put(\'direction\', strings[5]);\r\n            gprmcInfo.put(\'status\', strings[6].equals(\"01\") ? \"信息可用\" : \"信息不可用\");\r\n        }\r\n        \r\n        return JsonOutput.toJson(gprmcInfo);\r\n    }\r\n    \r\n    String transTime(String time) {\r\n        Calendar rightNow = Calendar.getInstance();\r\n        rightNow.set(Integer.parseInt(time.substring(0, 4))\r\n                , Integer.parseInt(time.substring(4, 6)) - 1\r\n                , Integer.parseInt(time.substring(6, 8))\r\n                , Integer.parseInt(time.substring(8, 10))\r\n                , Integer.parseInt(time.substring(10, 12))\r\n                , Integer.parseInt(time.substring(12, 14)));\r\n        SimpleDateFormat simpleDataFormat = new SimpleDateFormat(\"yyyy-MM-dd HH:mm:ss\");\r\n        return simpleDataFormat.format(rightNow.getTime());\r\n    }\r\n    \r\n    double round(String str, int scale) {\r\n        double d = Double.parseDouble(str);\r\n        return round(d, scale);\r\n    }\r\n    \r\n    double round(double d, int scale) {\r\n        return (double)Math.round(d*Math.pow(10,scale))/Math.pow(10,scale);\r\n    }\r\n    \r\n    String errorMessage(byte[] data, String errorMessage, String sourceID) {\r\n        return \"sid：\" + sourceID + errorMessage + \"， 报文：\" + MessageCommonUtil.bytes2HexStringWithSpace(data);\r\n    }'
WHERE `id` = 3;
UPDATE `t_protocol`
SET `script_code` = 'import groovy.json.JsonOutput;\r\nimport com.yeejoin.amos.iot.netty.vehicle.MessageCommonUtil;\r\n\r\nString parseData(byte[] bytesData, String sourceID) {\r\n	int ONE_NEW_LABEL_LENGTH = 8;\r\n	Map result = [:];\r\n	List idList = [];\r\n	(bytesData.length / ONE_NEW_LABEL_LENGTH).times{\r\n		int start = it * ONE_NEW_LABEL_LENGTH;\r\n		int end = start + ONE_NEW_LABEL_LENGTH - 1;\r\n		byte[] bytesLabel = bytesData[start..end] as byte[];\r\n		Map label = parseLabel(bytesLabel);\r\n		idList << label[\'labelId\'];\r\n	}\r\n	\r\n	if (!idList.isEmpty()) {\r\n		result.put(\'sourceId\', sourceID);\r\n		result.put(\'ids\', idList);\r\n		result.put(\'type\', \'lora\');\r\n	}\r\n\r\n	return JsonOutput.toJson(result);\r\n}\r\n\r\nMap parseLabel(byte[] bytesLabel) {\r\n	Map label = [:];\r\n	String labelId = MessageCommonUtil.bytes2HexString(bytesLabel[2..7] as byte[]);\r\n	label.put(\'labelId\', labelId);\r\n	label.put(\'labelType\', genLabelType(bytesLabel[0]));\r\n	label.put(\'alarmState\', genAlarm(bytesLabel[1]));\r\n	\r\n	return label;\r\n}\r\n\r\nString genAlarm(byte alarmCode) {\r\n	byte LOW_VOLTAGE_NORMAL_VALUE = (byte) 0x00;\r\n	return LOW_VOLTAGE_NORMAL_VALUE == alarmCode ? \'normal\' : \'alarm\';\r\n}\r\n\r\nString genLabelType(byte type) {\r\n	byte LABEL_TYPE_PEOPLE = (byte) 0x00;\r\n	byte LABEL_TYPE_EQUIPMENT = (byte) 0x01;\r\n	switch (type) {\r\n	case LABEL_TYPE_PEOPLE:\r\n		return \'people\';\r\n	case LABEL_TYPE_EQUIPMENT:\r\n		return \'equipment\';\r\n	default:\r\n		return \'illgel\';\r\n	}\r\n}'
WHERE `id` = 4;
UPDATE `t_protocol`
SET `script_code` = 'import groovy.json.JsonOutput;\r\nimport com.yeejoin.amos.iot.netty.vehicle.MessageCommonUtil;\r\n\r\nString parseData(byte[] bytesData, String sourceID) {\r\n	byte OBD_REAL_TIME_DATA_LABEL = (byte) 0x59; // OBD及时数据\r\n	byte OBD_STATISTIC_DATA_LABEL = (byte) 0x5A; // OBD及时数据\r\n	byte OBD_ALARM_DATA_LABEL = (byte) 0x5B; // OBD及时数据\r\n	switch (bytesData[0]) {\r\n		case OBD_REAL_TIME_DATA_LABEL:\r\n			return parseObdRaeltimeDataLabel(bytesData, sourceID);\r\n		case OBD_STATISTIC_DATA_LABEL:\r\n			return parseObdStatisticDataLabel(bytesData, sourceID);\r\n		case OBD_ALARM_DATA_LABEL:\r\n			return parseObdAlarmDataLabel(bytesData, sourceID);\r\n		default:\r\n			String errorMessage = errorMessage(bytesData, \"OBD报文子类型无法识别! \", sourceID);\r\n			Map errorResult = [:];\r\n			errorResult[\'errorMessage\'] = errorMessage;\r\n			return JsonOutput.toJson(errorResult);\r\n	}\r\n}\r\n\r\nString parseObdRaeltimeDataLabel(byte[] data, String sourceID) {\r\n	int ONE_OBD_REAL_TIME_LORA_LENGTH = 9; // OBD实时数据lora标签长度\r\n	Map realtimeData = [:];\r\n	if (ONE_OBD_REAL_TIME_LORA_LENGTH == data.length && checksum(data)) {\r\n		String labelId = MessageCommonUtil.bytes2HexString(data[1..2] as byte[]);\r\n		int engineFuel = MessageCommonUtil.convertTwoBytes2Uint16(data[4], data[3]);\r\n		int engineSpeed = MessageCommonUtil.convertTwoBytes2Uint16(data[6], data[5]);\r\n		int speed = MessageCommonUtil.convertByte2Unsigned(data[7]);\r\n		realtimeData.put(\"sourceId\", sourceID);\r\n		realtimeData.put(\"type\", data[0]);\r\n		realtimeData.put(\"labelId\", labelId);\r\n		realtimeData.put(\"engineFuel\", engineFuel); // 瞬时油耗\r\n		realtimeData.put(\"engineSpeed\", engineSpeed); // 发动机转速\r\n		realtimeData.put(\"speed\", speed); // 车速\r\n	} else {\r\n		String errorMessage = errorMessage(data, \", OBD实时数据标签长度不是9或者校验和失败：\", sourceID);\r\n		realtimeData.put(\"errorMessage\", errorMessage);\r\n	}\r\n	\r\n	return JsonOutput.toJson(realtimeData);\r\n}\r\n\r\nString parseObdStatisticDataLabel(byte[] data, String sourceID) {\r\n	int ONE_OBD_STATISTIC_LORA_LENGTH = 8; // OBD统计数据lora标签长度\r\n	Map statisticData = [:]\r\n	if (ONE_OBD_STATISTIC_LORA_LENGTH == data.length && checksum(data)) {\r\n		String labelId = MessageCommonUtil.bytes2HexString(data[1..2] as byte[]);\r\n		int voltage = MessageCommonUtil.convertTwoBytes2Uint16(data[4], data[3]);\r\n		int waterTemperature = MessageCommonUtil.convertByte2Unsigned(data[5]);\r\n		int remainingFuel = MessageCommonUtil.convertByte2Unsigned(data[6]);\r\n		statisticData.put(\"sourceId\", sourceID);\r\n		statisticData.put(\"type\", data[0]);\r\n		statisticData.put(\"labelId\", labelId);\r\n		statisticData.put(\"voltage\", voltage); // 电压\r\n		statisticData.put(\"waterTemperature\", waterTemperature); // 水温\r\n		statisticData.put(\"remainingFuel\", remainingFuel); // 剩余油量\r\n	} else {\r\n		String errorMessage = errorMessage(data, \", OBD统计数据标签长度不是8或者校验和失败：\", sourceID);\r\n		statisticData.put(\"errorMessage\", errorMessage);\r\n	}\r\n	\r\n	return JsonOutput.toJson(statisticData);\r\n}\r\n\r\nString parseObdAlarmDataLabel(byte[] data, String sourceID) {\r\n	int ONE_OBD_ALARM_LORA_LENGTH = 6; // OBD报警数据lora标签长度\r\n	Map alarmData = [:];\r\n	if (ONE_OBD_ALARM_LORA_LENGTH == data.length && checksum(data)) {\r\n		alarmData.put(\"sourceId\", sourceID);\r\n		alarmData.put(\"type\", data[0]);\r\n		alarmData.put(\"labelId\", MessageCommonUtil.bytes2HexString(data[1..2] as byte[]));\r\n		alarmData.put(\"alarmType\", MessageCommonUtil.convertByte2Unsigned(data[3])); // 报警类型\r\n		alarmData.put(\"alarmData\", MessageCommonUtil.convertByte2Unsigned(data[4])); // 报警数据\r\n	} else {\r\n		String errorMessage = errorMessage(data, \", OBD报警数据标签长度不是6或者校验和失败：\", sourceID);\r\n		alarmData.put(\"errorMessage\", errorMessage);\r\n	}\r\n	\r\n	return JsonOutput.toJson(alarmData);\r\n}\r\n\r\nString errorMessage(byte[] data, String errorMessage, String sourceID) {\r\n	return \"sid：\" + sourceID + errorMessage + \"， 报文：\" + MessageCommonUtil.bytes2HexStringWithSpace(data);\r\n}\r\n\r\nboolean checksum(byte[] lora) {\r\n	int sum = 0;\r\n	lora[0..-2].each{\r\n		sum += (it & 0xff);\r\n	}\r\n	return (sum & 0xff) == (lora[lora.length - 1] & 0xff);\r\n}'
WHERE `id` = 5;